# ImageMorphology

![Julia version](https://img.shields.io/badge/julia-%3E%3D%201.6-blue)
[![][action-img]][action-url]
[![][pkgeval-img]][pkgeval-url]
[![][codecov-img]][codecov-url]
[![][docs-stable-img]][docs-stable-url]
[![][docs-dev-img]][docs-dev-url]

This package provides morphology operations for structure analysis and image processing.

ImageMorphology is a sub-package of the umbrella package [Images.jl][images-url] -- either `using
Images` or `using ImageMorphology` will give you access to this functionality.

## Documentation

Full documentation and description can be found [here][docs-stable-url].

## Installation

Just like all normal Julia packages, you can use [Pkg][Pkg-docs-url] to install it:

```julia
pkg> add ImageMorphology # hit ] to enter Pkg mode
```

<!-- URLS -->

[pkgeval-img]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/I/ImageMorphology.svg
[pkgeval-url]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/report.html
[action-img]: https://github.com/JuliaImages/ImageMorphology.jl/workflows/Unit%20test/badge.svg
[action-url]: https://action-ci.org/JuliaImages/ImageMorphology.jl
[codecov-img]: https://codecov.io/github/JuliaImages/ImageMorphology.jl/coverage.svg?branch=master
[codecov-url]: https://codecov.io/github/JuliaImages/ImageMorphology.jl?branch=master
[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://JuliaImages.github.io/ImageMorphology.jl/stable
[docs-dev-img]: https://img.shields.io/badge/docs-dev-blue.svg
[docs-dev-url]: https://JuliaImages.github.io/ImageMorphology.jl/dev

[images-url]: https://github.com/JuliaImages/Images.jl
[Pkg-docs-url]: https://pkgdocs.julialang.org/v1/getting-started/

# This doesn't run under "runtests.jl" but does under CI
using ImageMorphology
using Test

@testset "multithreaded" begin
    @test Threads.nthreads() > 1
    @testset "feature_transform" begin
        img = rand(100, 128) .> 0.9
        @test feature_transform(img; nthreads=Threads.nthreads()) ==
            feature_transform(img; nthreads=1)
        # Since the threaded implementation handles two dimensions specially, we should check 0d and 1d
        img = reshape([true])
        @test feature_transform(img; nthreads=Threads.nthreads()) ==
            feature_transform(img; nthreads=1) ==
            reshape([CartesianIndex()])
        img = rand(100) .> 0.9
        @test feature_transform(img; nthreads=Threads.nthreads()) ==
            feature_transform(img; nthreads=1)
    end
end

"""
    isboundary!(img::AbstractArray; background = 0, dims = coords_spatial(A), kwargs...)

Finds the boundaries that are just within each object, replacing the original image.
`background` is the scalar value of the background pixels which will not be marked as boundaries.
Keyword arguments are passed to `extreme_filter` which include `dims` indicating the dimension(s)
over which to discover boundaries.

See out-of-place version, [`isboundary`](@ref), for examples.
"""
function isboundary!(img::AbstractArray{Bool,N}; background=false, kwargs...) where {N}
    # Find regions where there is at least one background pixel
    # centered on a foreground pixel
    if background == true
        # background_img = img
        # foreground_img = .!img
        img .= .!img .& extreme_filter(|, img; kwargs...)
        # Alternatively, with ImageFiltering.jl
        # img .= .!img .& mapwindow(any, img, (3,3))
    elseif background == false
        # background_img = .!img
        # foreground_img = img
        img .&= extreme_filter(|, .!img; kwargs...)
        # Alternatively, with ImageFiltering.jl
        # img .&= mapwindow(any, .!img, (3,3))
    else
        # This should be the same as isboundary_thick
        # background is neither true or false, use more generic algorithm
        background = Int8(-1) # Any value other than true or false will do
        #allequal(x,y) = ifelse(x == y, x, background)
        allequal(x, y) = x == y ? x : background
        # the entire image is the foreground
        img .= (extreme_filter!(allequal, similar(img, Int8), img; kwargs...) .== background)
    end
    return img
end
function isboundary!(img::AbstractArray{T}; background=zero(T), kwargs...) where {T}
    # Find regions where that are not homogeneous (all equal)
    # centered on a foreground pixel
    # background_img = img .== background
    # foreground_img = img .!= background
    #allequal(x,y) = ifelse(x == y, x, background)
    allequal(x, y) = x == y ? x : background
    m = extreme_filter(allequal, img; kwargs...)
    img .= (m .== background) .& (img .!= background)
    # Alternatively, with ImageFiltering.jl
    # allequal(x) = all(==(first(x)), @view(x[2:end]))
    # .!mapwindow(allequal, A, (3,3)) .& (A .!= background)
    return img
end

"""
    isboundary(img::AbstractArray; background = 0, dims = coords_spatial(A), kwargs...)

Finds the boundaries that are just within each object.
`background` is the scalar value of the background pixels which will not be marked as boundaries.
Keyword arguments are passed to `extremefilt!` which include `dims` indicating the dimension(s)
over which to discover boundaries.

See also its in-place version [`isboundary!`](@ref) and the alternative version that finds thick boundaries, [`isboundary_thick`](@ref ImageMorphology.isboundary_thick).

# Examples

```@meta
DocTestSetup = quote
    import ImageMorphology: isboundary
end
```

```jldoctest
julia> A = zeros($Int, 16, 16); A[4:8, 4:8] .= 5; A[4:8, 9:12] .= 6; A[10:12,13:15] .= 3; A[10:12,3:6] .= 9; A
16×16 Matrix{$Int}:
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  5  5  5  5  5  6  6  6  6  0  0  0  0
 0  0  0  5  5  5  5  5  6  6  6  6  0  0  0  0
 0  0  0  5  5  5  5  5  6  6  6  6  0  0  0  0
 0  0  0  5  5  5  5  5  6  6  6  6  0  0  0  0
 0  0  0  5  5  5  5  5  6  6  6  6  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  9  9  9  9  0  0  0  0  0  0  3  3  3  0
 0  0  9  9  9  9  0  0  0  0  0  0  3  3  3  0
 0  0  9  9  9  9  0  0  0  0  0  0  3  3  3  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0

julia> isboundary(A)
16×16 Matrix{$Int}:
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  1  1  1  1  1  1  1  1  1  0  0  0  0
 0  0  0  1  0  0  0  1  1  0  0  1  0  0  0  0
 0  0  0  1  0  0  0  1  1  0  0  1  0  0  0  0
 0  0  0  1  0  0  0  1  1  0  0  1  0  0  0  0
 0  0  0  1  1  1  1  1  1  1  1  1  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  1  1  1  1  0  0  0  0  0  0  1  1  1  0
 0  0  1  0  0  1  0  0  0  0  0  0  1  0  1  0
 0  0  1  1  1  1  0  0  0  0  0  0  1  1  1  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0

julia> isboundary(A .!= 0)
16×16 BitMatrix:
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  1  1  1  1  1  1  1  1  1  0  0  0  0
 0  0  0  1  0  0  0  0  0  0  0  1  0  0  0  0
 0  0  0  1  0  0  0  0  0  0  0  1  0  0  0  0
 0  0  0  1  0  0  0  0  0  0  0  1  0  0  0  0
 0  0  0  1  1  1  1  1  1  1  1  1  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  1  1  1  1  0  0  0  0  0  0  1  1  1  0
 0  0  1  0  0  1  0  0  0  0  0  0  1  0  1  0
 0  0  1  1  1  1  0  0  0  0  0  0  1  1  1  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0

julia> isboundary(A .!= 0; dims = 1)
16×16 BitMatrix:
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  1  1  1  1  1  1  1  1  1  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  1  1  1  1  1  1  1  1  1  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  1  1  1  1  0  0  0  0  0  0  1  1  1  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  1  1  1  1  0  0  0  0  0  0  1  1  1  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0

julia> isboundary(A .!= 0; dims = 2)
16×16 BitMatrix:
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  1  0  0  0  0  0  0  0  1  0  0  0  0
 0  0  0  1  0  0  0  0  0  0  0  1  0  0  0  0
 0  0  0  1  0  0  0  0  0  0  0  1  0  0  0  0
 0  0  0  1  0  0  0  0  0  0  0  1  0  0  0  0
 0  0  0  1  0  0  0  0  0  0  0  1  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  1  0  0  1  0  0  0  0  0  0  1  0  1  0
 0  0  1  0  0  1  0  0  0  0  0  0  1  0  1  0
 0  0  1  0  0  1  0  0  0  0  0  0  1  0  1  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
```
"""
function isboundary(img::AbstractArray{T}; background=zero(T), kwargs...) where {T}
    return isboundary!(copy(img); background=background, kwargs...)
end

## Alternate implementations using dilate and erode
# The implementations below are based on scikit-image

#=
Copyright (C) 2021, Mark Kittisopikul and JuliaImages Github Organization
Copyright (C) 2019, the scikit-image team
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 3. Neither the name of skimage nor the names of its contributors may be
    used to endorse or promote products derived from this software without
    specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.
=#

# Specific implementation of `isboundary_thick` using dilate and erode similar to scikit-image, uses extreme_filter twice
function isboundary_thick_dilate_erode(img::AbstractArray; kwargs...)
    # https://github.com/scikit-image/scikit-image/blob/d44ceda6241cb23a22dc8abf09a05090ed14da7f/skimage/segmentation/boundaries.py#L165-L167
    return dilate(img; kwargs...) .!= erode(img; kwargs...)
end
function isboundary_dilate_erode(img::AbstractArray{T}; background=zero(T), kwargs...) where {T}
    # https://github.com/scikit-image/scikit-image/blob/d44ceda6241cb23a22dc8abf09a05090ed14da7f/skimage/segmentation/boundaries.py#L165-L170
    thick_boundaries = isboundary_thick_dilate_erode(img; kwargs...)
    foreground_img = img .!= background
    return thick_boundaries .& foreground_img
end
"""
    isboundary_thick(img::AbstractArray; dims = coords_spatial(img), kwargs...)

Find thick boundaries that are just outside and just inside the objects.
This is a union of the inner and outer boundaries.
Keyword `dims` indicates over which dimensions to look for boundaries. This `dims` and additional keywords `kwargs` are passed to [`extreme_filter`](@ref).

See also [`isboundary`](@ref) which just yields the inner boundaries.

# Examples

```@meta
DocTestSetup = quote
    import ImageMorphology: isboundary_thick
end
```

```jldoctest
julia> A = zeros($Int, 16, 16); A[4:8, 4:8] .= 5; A[4:8, 9:12] .= 6; A[10:12,13:15] .= 3; A[10:12,3:6] .= 9; A
16×16 Matrix{$Int}:
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  5  5  5  5  5  6  6  6  6  0  0  0  0
 0  0  0  5  5  5  5  5  6  6  6  6  0  0  0  0
 0  0  0  5  5  5  5  5  6  6  6  6  0  0  0  0
 0  0  0  5  5  5  5  5  6  6  6  6  0  0  0  0
 0  0  0  5  5  5  5  5  6  6  6  6  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  9  9  9  9  0  0  0  0  0  0  3  3  3  0
 0  0  9  9  9  9  0  0  0  0  0  0  3  3  3  0
 0  0  9  9  9  9  0  0  0  0  0  0  3  3  3  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0

julia> isboundary_thick(A)
16×16 BitMatrix:
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  1  1  1  1  1  1  1  1  1  1  1  0  0  0
 0  0  1  1  1  1  1  1  1  1  1  1  1  0  0  0
 0  0  1  1  0  0  0  1  1  0  0  1  1  0  0  0
 0  0  1  1  0  0  0  1  1  0  0  1  1  0  0  0
 0  0  1  1  0  0  0  1  1  0  0  1  1  0  0  0
 0  0  1  1  1  1  1  1  1  1  1  1  1  0  0  0
 0  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1
 0  1  1  1  1  1  1  0  0  0  0  1  1  1  1  1
 0  1  1  0  0  1  1  0  0  0  0  1  1  0  1  1
 0  1  1  1  1  1  1  0  0  0  0  1  1  1  1  1
 0  1  1  1  1  1  1  0  0  0  0  1  1  1  1  1
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0

 julia> isboundary_thick(A) .& (A .!= 0)
16×16 BitMatrix:
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  1  1  1  1  1  1  1  1  1  0  0  0  0
 0  0  0  1  0  0  0  1  1  0  0  1  0  0  0  0
 0  0  0  1  0  0  0  1  1  0  0  1  0  0  0  0
 0  0  0  1  0  0  0  1  1  0  0  1  0  0  0  0
 0  0  0  1  1  1  1  1  1  1  1  1  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  1  1  1  1  0  0  0  0  0  0  1  1  1  0
 0  0  1  0  0  1  0  0  0  0  0  0  1  0  1  0
 0  0  1  1  1  1  0  0  0  0  0  0  1  1  1  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
 0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0

 julia> isboundary_thick(A) == isboundary(A; background = -1)
true

julia> isboundary_thick(A) .& (A .!= 0) == isboundary(A) # inner boundaries
true

julia> isboundary_thick(A .!= 0) .& (A .== 0)  == isboundary(A .== 0) # outer boundaries
true
 ```
"""
const isboundary_thick = isboundary_thick_dilate_erode

# ---
# title: "`closing`"
# id: op_closing
# cover: assets/closing.png
# ---

# `closing` operator is defined as `dilate(erode(img))`. Intuitively, closing operation
# fills the black holes in the image.

using ImageMorphology
using TestImages
using ImageBase
using ImageShow

img = restrict(testimage_dip3e("fig0940")) # rice
img01 = @. Gray(img > 0.5)
mosaic(img, img01; nrow=1)

#-

out1 = closing(img) # default: all spatial dimensions, r=1, a box-shape SE
out2 = closing(img; dims=(2,)) # only apply to the second dimension
out3 = closing(img; r=5) # half-size r=5

## also to the binary version
out1_01 = closing(img01)
out2_01 = closing(img01; dims=(2,))
out3_01 = closing(img01; r=5)

mosaic(out1, out2, out3, out1_01, out2_01, out3_01; nrow=2, rowmajor=true)


# ## See also

# [`closing`](@ref op_closing) is the dual operator of `closing` in the following sense:

complement.(closing(img)) == closing(complement.(img))

# For a comprehensive and more accurate documentation, please check the [`closing`](@ref)
# reference page.

# save cover image #src
using FileIO #src
mkpath("assets") #src
img = Gray.(restrict(testimage("blobs"))) #src
save("assets/closing.png", closing(img; r=2)) #src

module ImageMorphology

using DataStructures: Queue
using ImageCore
using ImageCore: GenericGrayImage, MappedArrays, FixedPointNumbers
using OffsetArrays
using OffsetArrays: centered
using LinearAlgebra
using TiledIteration: EdgeIterator, SplitAxis, SplitAxes
using Requires
using LoopVectorization

const _docstring_se = """
`se` is the structuring element that defines the neighborhood of the image. See
[`strel`](@ref) for more details. If `se` is not specified, then it will use the
[`strel_box`](@ref) with an extra keyword `dims` to control the dimensions to filter,
and half-size `r` to control the diamond size.
"""
include("StructuringElements/StructuringElements.jl")
using .StructuringElements

include("convexhull.jl")
include("connected.jl")
include("clearborder.jl")
include("extreme_filter.jl")
include("extremum.jl")
include("ops/dilate.jl")
include("ops/erode.jl")
include("ops/closing.jl")
include("ops/opening.jl")
include("ops/tophat.jl")
include("ops/bothat.jl")
include("ops/mgradient.jl")
include("ops/mlaplacian.jl")
include("ops/mreconstruct.jl")
include("ops/underbuild.jl")
include("ops/overbuild.jl")
include("isboundary.jl")
include("thinning.jl")
include("imfill.jl")
include("maxtree.jl")
include("leveling.jl")

include("feature_transform.jl")
include("utils.jl")
using .FeatureTransform

include("deprecations.jl")

export
    # structuring_element.jl
    centered, # from OffsetArrays
    strel,
    strel_chain,
    strel_product,
    strel_type,
    strel_size,
    strel_diamond,
    strel_box,

    # operations
    dilate,
    dilate!,
    erode,
    erode!,
    extreme_filter,
    extreme_filter!,
    opening,
    opening!,
    closing,
    closing!,
    tophat,
    tophat!,
    bothat,
    bothat!,
    mgradient,
    mgradient!,
    mlaplacian,
    mlaplacian!,
    mreconstruct,
    mreconstruct!,
    underbuild,
    underbuild!,
    overbuild,
    overbuild!,

    # connected.jl
    label_components,
    label_components!,
    component_boxes,
    component_lengths,
    component_indices,
    component_subscripts, # deprecated (v0.4)
    component_centroids,
    label_flatzones,
    label_flatzones!,
    label_lambdaflatzones,
    label_lambdaflatzones!,

    # convexhull.jl
    convexhull,

    # isboundary.jl
    isboundary,
    isboundary!,

    # thinning.jl
    thinning,
    GuoAlgo,
    imfill,

    # maxtree.jl
    MaxTree,
    areas,
    boundingboxes,
    diameters,
    area_opening,
    area_opening!,
    area_closing,
    area_closing!,
    diameter_opening,
    diameter_opening!,
    diameter_closing,
    diameter_closing!,
    local_maxima!,
    local_maxima,
    local_minima!,
    local_minima,

    #feature_transform.jl
    feature_transform,
    distance_transform,
    clearborder,

    #leveling
    low_leveling,
    low_leveling!,
    high_leveling,
    high_leveling!,
    leveling,
    leveling!,
    #extremum
    hmaxima,
    hmaxima!,
    hminima,
    hminima!,
    regional_maxima,
    regional_maxima!,
    regional_minima,
    regional_minima!

function __init__()
    @require ImageMetadata = "bc367c6b-8a6b-528e-b4bd-a4b897500b49" begin
        # morphological operations for ImageMeta
        function dilate(img::ImageMetadata.ImageMeta; kwargs...)
            out = dilate!(similar(ImageMetadata.arraydata(img)), img; kwargs...)
            return ImageMetadata.shareproperties(img, out)
        end
        function erode(img::ImageMetadata.ImageMeta; kwargs...)
            out = erode!(similar(ImageMetadata.arraydata(img)), img; kwargs...)
            return ImageMetadata.shareproperties(img, out)
        end
    end
end

end # module

"""
Max-tree morphological representation of an image.

# Details
Let's consider a *thresholding* operation,
```julia
    mask = [val ≥ threshold for val in image]
```
One can identify the connected components (the sets of neighboring true values)
in `mask`. When *image thresholding* is sequentially applied for all possible
thresholds, it generates a collection of connected components that could be
organized into a hierarchical structure called *component tree*. Consider 1D
"image" with values 1, 2 and 3:
```
       2233233312223322
```
The connected components would be
```
    1: AAAAAAAAAAAAAAAA
    2: BBBBBBBB.CCCCCCC
    3: ..DD.EEE....FF..
```
Here, the letters are the labels of the resulting connected components,
and `.` specifies that the pixel value is below the threshold.
In this example, the corresponding *component tree* is:
```
      A
     ⭩ ⭨
    B   C
   ⭩ ⭨   ⭨
  D   E   F
```

A *max-tree* is an efficient representation of the *component tree*.
A connected component ``C`` at threshold level ``t`` is represented by the
single *reference pixel* ``r`` from this level (`image[r] == t`), which is the
parent to all other pixels of ``C`` and also to the *reference pixels* of the
connected components at higher thresholds, which are the children of ``C``.
In our example, the reference pixels (denoted by the letter of the corresponding
component) would be:
```
    1: ........A.......
    2: B........C......
    3: ..D..E......F...
```
I.e.

| Comp | Ref.Pixel |
| ---- | ---------:|
| *A* |  9 |
| *B* |  1 |
| *C* | 10 |
| *D* |  3 |
| *E* |  6 |
| *F* | 13 |

So the whole max-tree could be encoded as a vector of indices of parent pixels:
```
9  1  1  3  1  1  6  6  9  9 10 10 10 13 10 10
```

The *max-tree* is the basis for many morphological operators,
namely connected operators. Unlike morphological openings and closings, these
operators do not require a fixed structuring element, but rather act with a
flexible structuring element that meets a certain criterion.

# See also
[`area_opening`](@ref), [`area_closing`](@ref),
[`diameter_opening`](@ref), [`diameter_closing`](@ref).

# References
1. Salembier, P., Oliveras, A., & Garrido, L. (1998). *Antiextensive Connected Operators for Image and Sequence Processing*. IEEE Transactions on Image Processing, 7(4), 555-570.
   > https://doi.org/10.1109/83.663500
2. Berger, C., Geraud, T., Levillain, R., Widynski, N., Baillard, A., Bertin, E. (2007). *Effective Component Tree Computation with Application to Pattern Recognition in Astronomical Imaging*. In International Conference on Image Processing (ICIP), 41-44.
   > https://doi.org/10.1109/ICIP.2007.4379949
3. Najman, L., & Couprie, M. (2006). *Building the component tree in quasi-linear time*. IEEE Transactions on Image Processing, 15(11), 3531-3539.
   > https://doi.org/10.1109/TIP.2006.877518
4. Carlinet, E., & Geraud, T. (2014). *A Comparative Review of Component Tree Computation Algorithms*. IEEE Transactions on Image Processing, 23(9), 3885-3895.
   > https://doi.org/10.1109/TIP.2014.2336551
"""
struct MaxTree{N}
    """
    If `false`, the tree is constructed from the smallest to the largest values,
    the tree root being the smallest (darkest) pixel.
    Otherwise, if `true`, the direction is from large to small values.
    """
    rev::Bool

    """
    Array of the same shape as the source image.
    Each value is the linear index of the parent pixel in the max-tree.
    """
    parentindices::Array{Int,N}

    """
    The order of the elements in the tree, from root to leaves.
    Each element corresponds to the linear index of the pixel in the image.
    A parent of the pixel always comes before the pixel itself, i.e.
    `parentindices[traverse[1]] == traverse[1]` (the root pixel) and
    `parentindices[traverse[k]] ∈ traverse[1:k-1]` for all `k >= 2`.
    """
    traverse::Vector{Int}

    # create uninitialized MaxTree for image
    MaxTree{N}(image::GenericGrayImage{<:Any, N}, rev::Bool) where N =
        new{N}(rev, Array{Int,N}(undef, size(image)),
               Vector{Int}(undef, length(image)))
end

Base.ndims(::Type{<:MaxTree{N}}) where N = N
Base.ndims(maxtree::MaxTree) = ndims(typeof(maxtree))
Base.length(maxtree::MaxTree) = length(maxtree.parentindices)
Base.size(maxtree::MaxTree) = size(maxtree.parentindices)
Base.:(==)(a::MaxTree, b::MaxTree) =
    (ndims(a) == ndims(b)) && (a.rev == b.rev) &&
    (a.parentindices == b.parentindices) &&
    (a.traverse == b.traverse)

"""
    root_index(maxtree::MaxTree) -> Int

Linear index of the root pixel.
"""
root_index(maxtree::MaxTree) = maxtree.traverse[1]

# Gets the path to the root of the max-tree (defined by `ancestors`) starting from
# `node`. The indices of the nodes along the path are stored into `path`.
# Returns the index of the root
@inline function rootpath!(path::Vector{Int},
                           ancestors::AbstractArray{<:Integer},
                           node::Integer)
    empty!(path)
    p = node
    @label next
    push!(path, p)
    @inbounds q = ancestors[p]
    if p != q
        p = q
        @goto next
    end
    return p
end

# Corrects `maxtree.parentindices`, so that the parent of every pixel
# is a canonical node. I.e. for each connected component at a level l,
# all pixels point to the same representative, which in turn points to the
# representative pixel at the next level.
#
# A canonical node ``p`` is either a root of the max-tree, or
# ``image(parent(p)) != image(p)``
function canonize!(maxtree::MaxTree, image::GenericGrayImage)
    @assert size(maxtree) == size(image)
    parentindices = maxtree.parentindices
    @inbounds for p in maxtree.traverse
        q = parentindices[p]
        if image[q] == image[parentindices[q]]
            parentindices[p] = parentindices[q]
        end
    end
    return maxtree
end

# Checks whether the `pixel` + `offset` is still a valid pixel
# contained inside the image area defined by `axes`.
isvalid_offset(offset::CartesianIndex{N}, pixel::CartesianIndex{N},
               axes::NTuple{N}) where N =
    Base.checkbounds_indices(Bool, axes, (pixel + offset,))

# generates a vector of offsets to the CartesianIndex that defines
# the neighborhood of the pixel in an N-dimensional image.
# `connectivity` is the maximal number of orthogonal steps
# (+1/-1 to a single dimension) that are required to reach a neighbor.
# Note that the corresponding offsets of linear indices would be sorted in ascending order
# ensuring efficient memory access pattern.
function neighbor_cartesian_offsets(::Type{CartesianIndex{N}}, connectivity::Integer) where N
    (connectivity >= 1) || throw(ArgumentError("connectivity should be positive integer"))
    return [ci for ci in CartesianIndices(ntuple(_ -> -1:1, N))
            if 1 <= sum(abs, Tuple(ci)) <= connectivity]
end

# convert offsets of cartesian indices into linear offsets of the given array
linear_offsets(offsets::AbstractVector{<:CartesianIndex},
               arr::AbstractArray) =
    dot.(Tuple.(offsets), Ref(strides(arr)))

"""
    rebuild!(maxtree::MaxTree, image::GenericGrayImage,
             neighbors::AbstractVector{CartesianIndex}) -> maxtree

Rebuilds the `maxtree` for the `image` using `neighbors` as the pixel
connectivity specification.

# Details
The pixels in the connected components generated by the method should be
connected to each other by a path through neighboring pixels.
The pixels ``p_1`` and ``p_2`` are neighbors, if `neighbors` array contains
``d``, such that ``p_2 = p_1 + d``.

# See also
[`MaxTree`](@ref)
"""
function rebuild!(maxtree::MaxTree{N},
                  image::GenericGrayImage{<:Any, N},
                  #=mask::AbstractArray{Bool, N},=#
                  neighbors::AbstractVector{CartesianIndex{N}}) where N
    check_maxtree(maxtree, image, rev=maxtree.rev)
    # pixels need to be sorted according to their gray level.
    sortperm!(maxtree.traverse, vec(image), rev=maxtree.rev)

    neighbor_offsets = linear_offsets(neighbors, maxtree.parentindices)
    p_indices = fill!(maxtree.parentindices, 0) |> vec # 0=uninitialized parent
    p_cis = CartesianIndices(maxtree.parentindices)
    p_axes = axes(maxtree.parentindices)
    r_indices = fill!(similar(p_indices), 0) # temporary array containing current roots
    rootpath = Vector{Int}() # temp array to hold the path to the current root within ancestors

    # traverse the array in reversed order (from highest value to lowest value)
    @inbounds for p in Iterators.Reverse(maxtree.traverse)
        p_ci = p_cis[p]
        p_indices[p] = r_indices[p] = p # it's a new root

        for i in eachindex(neighbors)
            # check that p is in the mask and that it's neighbor is a valid image pixel
            (#=mask[p] && =#isvalid_offset(neighbors[i], p_ci, p_axes)) || continue
            index = p + neighbor_offsets[i] # linear index of the neighbor
            (p_indices[index] == 0) && continue # ignore neighbor without parent (this means image[index] < image[p])
            root = rootpath!(rootpath, r_indices, index) # neighbor's root
            if (root != p) || (length(rootpath) > 1) # attach neighbor's root to the p
                p_indices[root] = p
                r_indices[rootpath] .= p # also attach the ancestral nodes of neighbor to p
            end
        end
    end
    return canonize!(maxtree, image)
end

"""
    MaxTree(image::GenericGrayImage; connectivity=1, rev=false) -> MaxTree

Constructs the *max-tree* of the `image`.

# Arguments
- `connectivity::Integer=1`: defines the pixel neighborhood used to construct
  the connected components. The value is the maximum number of orthogonal steps
  to reach a neighbor. In 2D, it is 1 for a 4-neighborhood and 2 for a
  8-neighborhood. See [`rebuild!](@ref).
- `rev::Bool=false`: if `false`, the max-tree is traversed from the darkest
  (the root node) to the brightest, otherwise it's traversed from the brightest
  (the root) to the darkest.

# Examples
We create a small sample image (Figure 1 from [4]) and build the max-tree.

```jldoctest; setup = :(using ImageMorphology), filter = r"Array{$Int,2}|Matrix{$Int}"
julia> image = [15 13 16; 12 12 10; 16 12 14]
3×3 Array{$Int,2}:
 15  13  16
 12  12  10
 16  12  14

julia> mtree = MaxTree(image, connectivity=2)
MaxTree{2}(false, [4 2 4; 8 2 8; 2 2 2], [8, 2, 5, 6, 4, 9, 1, 3, 7])
```
"""
function MaxTree(image::GenericGrayImage;
                 connectivity::Integer=1, rev::Bool=false)
    N = ndims(image)
    # User defined masks are not allowed, as there might be more than one
    # connected component in the mask (and therefore not a single tree that
    # represents the image). Mask here is an image that is 0 on the border
    # and 1 everywhere else
    #=
    mask = np.ones(image.shape)
    for k in range(len(image.shape)):
        np.moveaxis(mask, k, 0)[0] = 0
        np.moveaxis(mask, k, 0)[-1] = 0
    =#
    neighbors = neighbor_cartesian_offsets(CartesianIndex{N}, connectivity)
    return rebuild!(MaxTree{N}(image, rev), #=mask,=# image, neighbors)
end

"""
    areas(maxtree::MaxTree) -> Array{Int}

Computes the areas of all `maxtree` components.

# Returns
The array of the same shape as the original image. The `i`-th element is
the area (in pixels) of the component that is represented by the reference
pixel with index `i`.

# See also
[`diameters`](@ref), [`area_opening`](@ref), [`area_closing`](@ref).
"""
function areas(maxtree::MaxTree)
    areas = fill(1, size(maxtree)) # start with 1-pixel areas
    parentindices = maxtree.parentindices
    @inbounds for p in Iterators.Reverse(maxtree.traverse)
        q = parentindices[p]
        (q != p) && (areas[q] += areas[p])
    end
    return areas
end

"""
    boundingboxes(maxtree::MaxTree) -> Array{NTuple{2, CartesianIndex}}

Computes the minimal bounding boxes of all `maxtree` components.

# Returns
The array of the same shape as the original image. The `i`-th element is
the tuple of the minimal and maximal cartesian indices for the bounding box
of the component that is represented by the reference pixel with index `i`.

# See also
[`diameters`](@ref).
"""
function boundingboxes(maxtree::MaxTree{N}) where N
    # initialize bboxes
    bboxes = [(ci, ci) for ci in CartesianIndices(maxtree.parentindices)]
    @inbounds for p in Iterators.Reverse(maxtree.traverse)
        q = maxtree.parentindices[p]
        bbp, bbq = bboxes[p], bboxes[q]
        bboxes[q] = (min(bbq[1], bbp[1]), max(bbq[2], bbp[2]))
    end
    return bboxes
end

"""
    diameters(maxtree::MaxTree) -> Array{Int}

Computes the "diameters" of all `maxtree` components.

"Diameter" of the *max-tree* connected component is the length of
the widest side of the component's bounding box.

# Returns
The array of the same shape as the original image. The `i`-th element is the
"diameter" of the component that is represented by the reference pixel with
index `i`.

# See also
[`boundingboxes`](@ref), [`areas`](@ref),
[`diameter_opening`](@ref), [`diameter_closing`](@ref).
"""
diameters(maxtree::MaxTree) =
    [maximum(Tuple(bbox[2] - bbox[1])) + 1 for bbox in boundingboxes(maxtree)]

"""
    filter_components!(output::GenericGrayImage, image::GenericGrayImage,
                       maxtree::MaxTree, attrs::AbstractVector,
                       min_attr, all_below_min) -> output

Filters the connected components of the `image` and stores the result in `output`.

The ``output`` is the copy of the ``image`` exluding the connected components,
whose attribute value is below `min_attr`. That is, the pixels of the exluded
component are reset to the value of the reference pixel of its first valid
ancestor (the connected component with the attribute value greater or equal
to `min_attr`).

# Arguments
- `maxtree::MaxTree`: pre-built max-tree representation of the `image`
- `attrs::AbstractVector`: `attrs[i]` is the attribute value for the ``i``-th
   component of the tree (``i`` being the linear index of its *reference pixel*)
- `all_below_min`: the value to fill the `output` if all attributes of all
  components (including the root one) are below `min_attr`

# Details
This function is the basis for [`area_opening`](@ref), [`diameter_opening`](@ref)
and similar transformations.
E.g. for [`area_opening`](@ref) the attribute is the area of the components.
In this case, the max-tree components of the `output` have area no smaller
than `min_attr` pixels.

The method assumes that the attribute values are monotone with respect to the
components hieararchy, i.e. ``attrs[i] <= attrs[maxtree.parentindices[i]]`` for
each `i`.
"""
function filter_components!(output::GenericGrayImage, image::GenericGrayImage,
                            maxtree::MaxTree,
                            attrs::AbstractArray, min_attr,
                            all_below_min = zero(eltype(output)))
    # should have been already checked by higher-level functions
    @assert size(output) == size(image)
    @assert size(image) == size(maxtree)
    @assert length(attrs) == length(maxtree)

    p_root = root_index(maxtree)
    # if p_root is below min_attr, then all others are as well
    (attrs[p_root] < min_attr) && return fill!(output, all_below_min)
    output[p_root] = image[p_root]
    parentindices = maxtree.parentindices

    for p in maxtree.traverse
        q = parentindices[p]
        # this means p is not canonical
        # in other words, it has a parent that has the
        # same image value.
        if image[p] == image[q]
            output[p] = output[q]
            continue
        end
        # if attribute is below the threshold, stop at the lower parent,
        # otherwise continue to reconstruct the image
        output[p] = attrs[p] < min_attr ? output[q] : image[p]
    end

    return output
end

function check_output_image(output::GenericGrayImage, image::GenericGrayImage)
    (size(output) == size(image)) ||
        throw(DimensionMismatch("The sizes of the output and the input image do not match"))
end

# checks if the provided maxtree is compatible with the given options
# or builds the new maxtree if none was given
function check_maxtree(maxtree::MaxTree,
                       image::GenericGrayImage;
                       rev::Bool=false)
    (size(maxtree) == size(image)) ||
        throw(DimensionMismatch("The sizes of the max-tree and the input image do not match"))
    (maxtree.rev == rev) ||
        throw(ArgumentError("The traversal order of the given max-tree is different from the requested one"))
end

"""
    area_opening!(output, image, [maxtree];
                  min_area=64, connectivity=1) -> output

Performs in-place *area opening* of the `image` and stores the result in `output`.
See [`area_opening`](@ref) for the detailed description of the method.
"""
function area_opening!(output::GenericGrayImage, image::GenericGrayImage,
                       maxtree::MaxTree; min_area::Number=64)
    check_output_image(output, image)
    check_maxtree(maxtree, image, rev=false)
    return filter_components!(output, image, maxtree, areas(maxtree), min_area)
end

"""
    area_opening(image, [maxtree]; min_area=64, connectivity=1) -> Array

Performs an *area opening* of the `image`.

*Area opening* replaces all bright components of an image that
have a surface smaller than `min_area` with the darker value taken from
their first ancestral component (in *max-tree* representation of `image`)
that has the area no smaller than `min_area`.

# Details
Area opening is similar to morphological opening (see [`opening`](@ref)),
but instead of using a fixed structuring element (e.g. disk) it employs
small (less than `min_area`) components of the *max-tree*. Consequently,
the `area_opening` with `min_area = 1` is the identity transformation.

In the binary case, area opening is equivalent to `remove_small_objects`;
this operator is thus extended to gray-level images.

# Arguments
- `image::GenericGrayImage`: the ``N``-dimensional input image
- `min_area::Number=64`: the smallest size (in pixels) of the image component
  to keep intact
- `connectivity::Integer=1`: the neighborhood connectivity. The maximum number
  of orthogonal steps to reach a neighbor of the pixel.
  In 2D, it is 1 for a 4-neighborhood and 2 for a 8-neighborhood.
- `maxtree::MaxTree`: optional pre-built *max-tree*. Note that
  `maxtree` and `connectivity` optional parameters are mutually exclusive.

# Returns
An array of the same type and shape as the `image`.

# See also
[`area_opening!`](@ref), [`area_closing`](@ref),
[`diameter_opening`](@ref),
[`MaxTree`](@ref), [`opening`](@ref)

# References
1. Vincent, L. (1993). *Grayscale area openings and closings, their efficient implementation and applications*, Proc. of EURASIP Workshop on Mathematical Morphology and its Applications to Signal Processing, Barcelona, Spain, 22-27
2. Soille, P. (2003). Chapter 6 *Geodesic Metrics* of *Morphological Image Analysis: Principles and Applications*, 2nd edition, Springer.
   > https://doi.org/10.1007/978-3-662-05088-0
3. Salembier, P., Oliveras, A., & Garrido, L. (1998). *Antiextensive Connected Operators for Image and Sequence Processing*. IEEE Transactions on Image Processing, 7(4), 555-570.
   > https://doi.org/10.1109/83.663500
4. Najman, L., & Couprie, M. (2006). *Building the component tree in quasi-linear time*. IEEE Transactions on Image Processing, 15(11), 3531-3539.
   > https://doi.org/10.1109/TIP.2006.877518
5. Carlinet, E., & Geraud, T. (2014). *A Comparative Review of Component Tree Computation Algorithms*. IEEE Transactions on Image Processing, 23(9), 3885-3895.
   > https://doi.org/10.1109/TIP.2014.2336551

# Examples
Creating a test image `f` (quadratic function with a maximum in the center and
4 additional local maxima):
```jldoctest; setup = :(using ImageMorphology)
julia> w = 12;

julia> f = [20 - 0.2*((x - w/2)^2 + (y-w/2)^2) for x in 0:w, y in 0:w];

julia> f[3:4, 2:6] .= 40; f[3:5, 10:12] .= 60; f[10:12, 3:5] .= 80;

julia> f[10:11, 10:12] .= 100; f[11, 11] = 100;

julia> f_aopen = area_opening(f, min_area=8, connectivity=1);
```
The peaks with a surface smaller than 8 are removed.
"""
area_opening

"""
    diameter_opening!(output, image, [maxtree];
                      min_diameter=8, connectivity=1) -> output

Performs in-place *diameter opening* of the `image` and stores the result in `output`.
See [`diameter_opening`](@ref) for the detailed description of the method.
"""
function diameter_opening!(output::GenericGrayImage, image::GenericGrayImage,
                           maxtree::MaxTree; min_diameter=8)
    check_output_image(output, image)
    check_maxtree(maxtree, image, rev=false)
    return filter_components!(output, image, maxtree, diameters(maxtree), min_diameter)
end

"""
    diameter_opening(image, [maxtree]; min_diameter=8, connectivity=1) -> Array

Performs a *diameter opening* of the `image`.

*Diameter opening* replaces all bright structures of an image that have
the diameter (the widest dimension of their bounding box) smaller than
`min_diameter` with the darker value taken from their first ancestral component
(in *max-tree* representation of `image`) that has the diameter no smaller than
`min_diameter`.

The operator is also called *Bounding Box Opening*. In practice,
the result is similar to a *morphological opening*, but long and thin
structures are not removed.

# Arguments
- `image::GenericGrayImage`: the ``N``-dimensional input image
- `min_diameter::Number=8`: the minimal length (in pixels) of the widest
  dimension of the bounding box of the image component to keep intact
- `connectivity::Integer=1`: the neighborhood connectivity. The maximum number
  of orthogonal steps to reach a neighbor of the pixel. In 2D, it is 1 for
  a 4-neighborhood and 2 for a 8-neighborhood.
- `maxtree::MaxTree`: optional pre-built *max-tree*. Note that
  `maxtree` and `connectivity` optional parameters are mutually exclusive.

# Returns
An array of the same type and shape as the `image`.

# See also
[`diameter_opening!`](@ref), [`diameter_closing`](@ref),
[`area_opening`](@ref),
[`MaxTree`](@ref), [`opening`](@ref)

# References
1. Walter, T., & Klein, J.-C. (2002). *Automatic Detection of Microaneurysms in Color Fundus Images of the Human Retina by Means of the Bounding Box Closing*. In A. Colosimo, P. Sirabella, A. Giuliani (Eds.), *Medical Data Analysis. Lecture Notes in Computer Science*, vol 2526, 210-220. Springer Berlin Heidelberg.
   > https://doi.org/10.1007/3-540-36104-9_23
2. Carlinet, E., & Geraud, T. (2014). *A Comparative Review of Component Tree Computation Algorithms*. IEEE Transactions on Image Processing, 23(9), 3885-3895.
   > https://doi.org/10.1109/TIP.2014.2336551

# Examples
Creating a test image `f` (quadratic function with a maximum in the center and
4 additional local maxima):
```jldoctest; setup = :(using ImageMorphology)
julia> w = 12;

julia> f = [20 - 0.2*((x - w/2)^2 + (y-w/2)^2) for x in 0:w, y in 0:w];

julia> f[3:4, 2:6] .= 40; f[3:5, 10:12] .= 60; f[10:12, 3:5] .= 80;

julia> f[10:11, 10:12] .= 100; f[11, 11] = 100;

julia> f_dopen = diameter_opening(f, min_diameter=3, connectivity=1);
```
The peaks with a maximal diameter of 2 or less are removed.
For the remaining peaks the widest side of the bounding box is at least 3.
"""
diameter_opening

"""
    area_closing!(output, image, [maxtree];
                  min_area=64, connectivity=1) -> output

Performs in-place *area closing* of the `image` and stores the result in `output`.
See [`area_closing`](@ref) for the detailed description of the method.
"""
function area_closing!(output::GenericGrayImage, image::GenericGrayImage,
                       maxtree::MaxTree; min_area::Number=64)
    check_output_image(output, image)
    check_maxtree(maxtree, image, rev=true)
    return filter_components!(output, image, maxtree, areas(maxtree), min_area)
end

"""
    area_closing(image, [maxtree]; min_area=64, connectivity=1) -> Array

Performs an *area closing* of the `image`.

*Area closing* replaces all dark components of an image that
have a surface smaller than `min_area` with the brighter value taken from
their first ancestral component (in *max-tree* representation of `image`)
that has the area no smaller than `min_area`.

# Details
*Area closing* is the dual operation to *area opening* (see [`area_opening`](@ref)).
It is similar to morphological closings (see [`closing`](@ref)),
but instead of using a fixed structuring element (e.g. disk) it employs
small (less than `min_area`) components of the *max-tree*. Consequently,
the `area_closing` with `min_area = 1` is the identity transformation.

In the binary case, area closing is equivalent to
`remove_small_holes`; this operator is thus extended to gray-level images.

# Arguments
- `image::GenericGrayImage`: the ``N``-dimensional input image
- `min_area::Number=64`: the smallest size (in pixels) of the image component
  to keep intact
- `connectivity::Integer=1`: the neighborhood connectivity. The maximum number
  of orthogonal steps to reach a neighbor of the pixel. In 2D, it is 1 for
  a 4-neighborhood and 2 for a 8-neighborhood.
- `maxtree::MaxTree`: optional pre-built *max-tree*. Note that
  `maxtree` and `connectivity` optional parameters are mutually exclusive.

# Returns
An array of the same type and shape as the `image`.

# See also
[`area_closing!`](@ref), [`area_opening`](@ref),
[`diameter_closing`](@ref),
[`MaxTree`](@ref), [`closing`](@ref)

# References
1. Vincent, L. (1993). *Grayscale area openings and closings, their efficient implementation and applications*, Proc. of EURASIP Workshop on Mathematical Morphology and its Applications to Signal Processing, Barcelona, Spain, 22-27
2. Soille, P. (2003). Chapter 6 *Geodesic Metrics* of *Morphological Image Analysis: Principles and Applications*, 2nd edition, Springer.
   > https://doi.org/10.1007/978-3-662-05088-0
3. Salembier, P., Oliveras, A., & Garrido, L. (1998). *Antiextensive Connected Operators for Image and Sequence Processing*. IEEE Transactions on Image Processing, 7(4), 555-570.
   > https://doi.org/10.1109/83.663500
4. Najman, L., & Couprie, M. (2006). *Building the component tree in quasi-linear time*. IEEE Transactions on Image Processing, 15(11), 3531-3539.
   > https://doi.org/10.1109/TIP.2006.877518
5. Carlinet, E., & Geraud, T. (2014). *A Comparative Review of Component Tree Computation Algorithms*. IEEE Transactions on Image Processing, 23(9), 3885-3895.
   > https://doi.org/10.1109/TIP.2014.2336551

# Examples
Creating a test image `f` (quadratic function with a minimum in the center and
4 additional local minima):
```jldoctest; setup = :(using ImageMorphology)
julia> w = 12;

julia> f = [180 + 0.2*((x - w/2)^2 + (y-w/2)^2) for x in 0:w, y in 0:w];

julia> f[3:4, 2:6] .= 40; f[3:5, 10:12] .= 60; f[10:12, 3:5] .= 80;

julia> f[10:11, 10:12] .= 100; f[11, 11] = 100;

julia> f_aclose = area_closing(f, min_area=8, connectivity=1);
```
All small minima are removed, and the remaining minima have at least
a size of 8.
"""
area_closing

"""
    diameter_closing!(output, image, [maxtree];
                      min_diameter=8, connectivity=1) -> output

Performs in-place *diameter closing* of the `image` and stores the result in `output`.
See [`diameter_closing`](@ref) for the detailed description of the method.
"""
function diameter_closing!(output::GenericGrayImage, image::GenericGrayImage,
                           maxtree::MaxTree; min_diameter::Number=8)
    check_output_image(output, image)
    check_maxtree(maxtree, image, rev=true)
    return filter_components!(output, image, maxtree, diameters(maxtree), min_diameter)
end

"""
    diameter_closing(image, [maxtree]; min_diameter=8, connectivity=1) -> Array

Performs a *diameter closing* of the `image`.

*Diameter closing* replaces all dark structures of an image that have
the diameter (the widest dimension of their bounding box) smaller than
`min_diameter` with the brighter value taken from their first ancestral component
(in *max-tree* representation of `image`) that has the diameter no smaller than
`min_diameter`.

# Arguments
- `image::GenericGrayImage`: the ``N``-dimensional input image
- `min_diameter::Number=8`: the minimal length (in pixels) of the widest
  dimension of the bounding box of the image component to keep intact
- `connectivity::Integer=1`: the neighborhood connectivity. The maximum number
  of orthogonal steps to reach a neighbor of the pixel. In 2D, it is 1 for
  a 4-neighborhood and 2 for a 8-neighborhood.
- `maxtree::MaxTree`: optional pre-built *max-tree*. Note that
  `maxtree` and `connectivity` optional parameters are mutually exclusive.

# Returns
An array of the same type and shape as the `image`.

# See also
[`diameter_closing!`](@ref), [`diameter_opening`](@ref),
[`area_closing`](@ref),
[`MaxTree`](@ref), [`closing`](@ref)

# References
1. Walter, T., & Klein, J.-C. (2002). *Automatic Detection of Microaneurysms in Color Fundus Images of the Human Retina by Means of the Bounding Box Closing*. In A. Colosimo, P. Sirabella, A. Giuliani (Eds.), *Medical Data Analysis. Lecture Notes in Computer Science*, vol 2526, 210-220. Springer Berlin Heidelberg.
   > https://doi.org/10.1007/3-540-36104-9_23
2. Carlinet, E., & Geraud, T. (2014). *A Comparative Review of Component Tree Computation Algorithms*. IEEE Transactions on Image Processing, 23(9), 3885-3895.
   > https://doi.org/10.1109/TIP.2014.2336551

# Examples
Creating a test image `f` (quadratic function with a minimum in the center and
4 additional local minima):
```jldoctest; setup = :(using ImageMorphology)
julia> w = 12;

julia> f = [180 + 0.2*((x - w/2)^2 + (y-w/2)^2) for x in 0:w, y in 0:w];

julia> f[3:4, 2:6] .= 40; f[3:5, 10:12] .= 60; f[10:12, 3:5] .= 80;

julia> f[10:11, 10:12] .= 100; f[11, 11] = 100;

julia> f_dclose = diameter_closing(f, min_diameter=3, connectivity=1);
```
All small minima with a diameter of 2 or less are removed.
For the remaining minima the widest bounding box side is at least 3.
"""
diameter_closing

# Calculates the local maxima or minima of the image using the max-tree
# representation (maxima if maxtree.rev=false, minima otherwise).
# It's not the most effecient method for extrema calculation, but could be
# useful if the max-tree is already calculated.
# Each minima/maxima region is labeled with the unique id (1 is the global
# maximum/minimum).
function local_extrema!(output::GenericGrayImage,
                        image::GenericGrayImage,
                        maxtree::MaxTree)
    (size(image) == size(maxtree)) || throw(DimensionMismatch())
    (size(output) == size(image)) || throw(DimensionMismatch())

    next_label = oneunit(eltype(output))
    fill!(output, next_label) # initialize output (just has to be non-zero)
    @inbounds for p in Iterators.reverse(maxtree.traverse)
        q = maxtree.parentindices[p]
        # if p is canonical (parent has a different value)
        if image[p] != image[q]
            output[q] = 0
            # if output[p] was the parent of some other canonical
            # pixel, it has been set to zero. Only the leaves
            # (local maxima) are thus > 0.
            if output[p] > 0
                output[p] = next_label
                next_label += 1
            end
        end
    end

    @inbounds for p in Iterators.reverse(maxtree.traverse)
        q = maxtree.parentindices[p]
        # if p is not canonical (parent has the same value)
        if image[p] == image[q]
            # in this case we propagate the value
            output[p] = output[q]
        end
    end

    return output
end

"""
    local_maxima!(output, image, [maxtree]; connectivity=1) -> output

Detects the local maxima of `image` and stores the result in `output`.
See [`local_maxima`](@ref) for the detailed description of the method.
"""
function local_maxima!(output::GenericGrayImage, image::GenericGrayImage,
                       maxtree::MaxTree)
    check_output_image(output, image)
    check_maxtree(maxtree, image, rev=false)
    return local_extrema!(output, image, maxtree)
end

"""
    local_maxima(image, [maxtree]; connectivity=1) -> Array

Determines and labels all *local maxima* of the `image`.

# Details
The *local maximum* is defined as the connected set of pixels that have the
same value, which is greater than the values of all pixels in direct
neighborhood of the set.

Technically, the implementation is based on the *max-tree* representation
of an image. It's beneficial if the max-tree is already computed,
otherwise `ImageFiltering.findlocalmaxima` would be more efficient.

# Arguments
- `image::GenericGrayImage`: the ``N``-dimensional input image
- `connectivity::Integer=1`: the neighborhood connectivity.
  The maximum number of orthogonal steps to reach a neighbor of the pixel.
  In 2D, it is 1 for a 4-neighborhood and 2 for a 8-neighborhood.
- `maxtree::MaxTree`: optional pre-built *max-tree*. Note that
  `maxtree` and `connectivity` optional parameters are mutually exclusive.

# Returns
An integer array of the same shape as the `image`. Pixels that are not local
maxima have 0 value. Pixels of the same local maximum share the same positive
value (the local maximum id).

# See also
[`MaxTree`](@ref), [`local_maxima!`](@ref), [`local_minima`](@ref),
`ImageFiltering.findlocalmaxima`

# Examples
Create `f` (quadratic function with a maximum in the center and
4 additional constant maxima):
```jldoctest; setup = :(using ImageMorphology)
julia> w = 10;

julia> f = [20 - 0.2*((x - w/2)^2 + (y-w/2)^2) for x in 0:w, y in 0:w];

julia> f[3:5, 3:5] .= 40; f[3:5, 8:10] .= 60; f[8:10, 3:5] .= 80; f[8:10, 8:10] .= 100;

julia> f_maxima = local_maxima(f); # Get all local maxima of `f`
```
The resulting image contains the 4 labeled local maxima.
"""
local_maxima

"""
    local_minima!(output, image, [maxtree]; connectivity=1) -> output

Detects the local minima of `image` and stores the result in `output`.
See [`local_minima`](@ref) for the detailed description of the method.
"""
function local_minima!(output::GenericGrayImage, image::GenericGrayImage,
                       maxtree::MaxTree; connectivity::Integer=1)
    check_output_image(output, image)
    check_maxtree(maxtree, image, rev=true)
    return local_extrema!(output, image, maxtree)
end

"""
    local_minima(image, [maxtree]; connectivity=1) -> Array

Determines and labels all *local minima* of the `image`.

# Details
The *local minimum* is defined as the connected set of pixels that have the
same value, which is less than the values of all pixels in direct
neighborhood of the set.

Technically, the implementation is based on the *max-tree* representation
of an image. It's beneficial if the max-tree is already computed,
otherwise `ImageFiltering.findlocalminima` would be more efficient.

# Arguments
- `image::GenericGrayImage`: the ``N``-dimensional input image
- `connectivity::Integer=1`: the neighborhood connectivity. The maximum number
  of orthogonal steps to reach a neighbor of the pixel. In 2D, it is 1 for
  a 4-neighborhood and 2 for a 8-neighborhood.
- `maxtree::MaxTree`: optional pre-built *max-tree*. Note that
  `maxtree` and `connectivity` optional parameters are mutually exclusive.

# Returns
An integer array of the same shape as the `image`. Pixels that are not local
minima have 0 value. Pixels of the same local minimum share the same positive
value (the local minimum id).

# See also
[`MaxTree`](@ref), [`local_minima!`](@ref), [`local_maxima`](@ref),
`ImageFiltering.findlocalminima`

# Examples
Create `f` (quadratic function with a minimum in the center and
4 additional constant minimum):
```jldoctest; setup = :(using ImageMorphology)
julia> w = 10;

julia> f = [180 + 0.2*((x - w/2)^2 + (y-w/2)^2) for x in 0:w, y in 0:w];

julia> f[3:5, 3:5] .= 40; f[3:5, 8:10] .= 60; f[8:10, 3:5] .= 80; f[8:10, 8:10] .= 100;

julia> f_minima = local_minima(f); # Calculate all local minima of `f`
```
The resulting image contains the labeled local minima.
"""
local_minima

# autogenerate in-place maxtree operations with "connectivity" keyarg
for (fun, rev) in [(:area_opening!, false), (:area_closing!, true),
                   (:diameter_opening!, false), (:diameter_closing!, true),
                   (:local_maxima!, false), (:local_minima!, true)]
    @eval begin
        $fun(output::GenericGrayImage, image::GenericGrayImage;
             connectivity::Integer=1, kwargs...) =
            $fun(output, image,
                 MaxTree(image, connectivity=connectivity, rev=$rev); kwargs...)
    end
end

# autogenerate maxtree operations (simple wrappers of in-place methods)
for fun in [:area_opening, :area_closing,
            :diameter_opening, :diameter_closing,
            :local_maxima, :local_minima]
    fun! = Symbol(fun, "!")
    @eval begin
        $fun(image::GenericGrayImage; kwargs...) =
             $fun!(similar(image), image; kwargs...)
        $fun(image::GenericGrayImage, maxtree::MaxTree; kwargs...) =
             $fun!(similar(image), image, maxtree; kwargs...)
    end
end

"""
    SEDiamond{N}(axes, [dims]; [r])

A (holy) trait type for the N-dimensional diamond shape structuring element. This is a
special case of [`SEMask`](@ref SEMask) that ImageMorphology algorithms
might provide optimized implementation.

It is recommended to use [`strel_diamond`](@ref) and [`strel_type`](@ref):

```jldoctest; setup=:(using ImageMorphology; using ImageMorphology.StructuringElements)
julia> se = strel_diamond((3, 3)) # C4 connectivity
3×3 SEDiamondArray{2, 2, UnitRange{$Int}, 0} with indices -1:1×-1:1:
 0  1  0
 1  1  1
 0  1  0

julia> strel_type(se)
SEDiamond{2, 2, UnitRange{$Int}}((-1:1, -1:1), (1, 2), 1)

julia> se = centered(collect(se)) # converted to normal centered array
3×3 OffsetArray(::Matrix{Bool}, -1:1, -1:1) with eltype Bool with indices -1:1×-1:1:
 0  1  0
 1  1  1
 0  1  0

julia> strel_type(se)
SEMask{2}()
```
"""
struct SEDiamond{N,K,R<:AbstractUnitRange{Int}} <: MorphologySE{N}
    axes::NTuple{N,R}
    dims::Dims{K}
    r::Int # radius
    function SEDiamond{N,K,R}(axes::NTuple{N,R}, dims::Dims{K}, r) where {N,K,R<:AbstractUnitRange{Int}}
        if !all(r -> first(r) == -last(r), axes)
            throw(ArgumentError("axes must be symmetric along each dimension"))
        end
        _is_unique_tuple(dims) || throw(ArgumentError("dims should be unique"))
        N >= K || throw(ArgumentError("`axes` length should be at least $K"))
        if !all(i -> i <= N, dims)
            throw(ArgumentError("all `dims` values should be less than or equal to $N"))
        end
        return new{N,K,R}(axes, dims, r)
    end
end
function SEDiamond{N}(ax::NTuple{N,R}, dims=ntuple(identity, N); r=maximum(length.(ax)) ÷ 2) where {N,R}
    return SEDiamond{N,length(dims),R}(ax, dims, r)
end

# Helper array type to build a consistant array interface for SEs
"""
    SEDiamondArray(se::SEDiamond)

The instantiated array object of [`SEDiamond`](@ref).
"""
struct SEDiamondArray{N,K,R<:AbstractUnitRange{Int},S} <: MorphologySEArray{N}
    axes::NTuple{N,R}
    dims::Dims{K}
    r::Int # radius
    _rdims::Dims{S}
end
function SEDiamondArray(se::SEDiamond{N,K,R}) where {N,K,R}
    _rdims = _cal_rdims(Val(N), se.dims)
    return SEDiamondArray{N,K,R,length(_rdims)}(se.axes, se.dims, se.r, _rdims)
end
strel_type(A::SEDiamondArray{N}) where {N} = SEDiamond{N}(A.axes, A.dims; r=A.r)
function strel_size(se::SEDiamondArray)
    return ntuple(i -> in(i, se.dims) ? 1 + 2 * se.r : 1, strel_ndims(se))
end

@inline Base.axes(A::SEDiamondArray) = A.axes
@inline Base.size(A::SEDiamondArray) = map(length, axes(A))
@inline Base.IndexStyle(::SEDiamondArray) = IndexCartesian()
Base.@propagate_inbounds function Base.getindex(A::SEDiamondArray{N,K}, inds::Int...) where {N,K}
    # for remaining dimensions, check if it is at the center position
    ri = _tuple_getindex(inds, A._rdims)
    all(iszero, ri) || return false
    # for masked dimensions, compare if the city-block distance to center is within radius
    mi = _tuple_getindex(inds, A.dims)
    r = isempty(mi) ? 0 : sum(abs, mi)
    return ifelse(r > A.r, false, true)
end

_tuple_getindex(t::Tuple, inds::Dims) = ntuple(i -> t[inds[i]], length(inds))
function _cal_rdims(::Val{N}, dims::NTuple{K}) where {N,K}
    return Dims{N - K}(filter(i -> !in(i, dims), 1:N))
end
_is_unique_tuple(t::Tuple) = any(i -> t[i] in t[1:(i - 1)], 2:length(t)) ? false : true

"""
    strel_diamond(A::AbstractArray, [dims]; r=1)
    strel_diamond(size, [dims]; [r])

Construct the N-dimensional structuring element (SE) for a diamond shape.

If image `A` is provided, then the SE size will be `(2r+1, 2r+1, ...)` with default
half-size `r=1`. If `size` is provided, the default `r` will be `maximum(size)÷2`. The
default `dims` will be all dimensions, that is, `(1, 2, ..., length(size))`.

```jldoctest; setup=:(using ImageMorphology; using ImageMorphology.StructuringElements)
julia> img = rand(64, 64);

julia> strel_diamond(img) # default size for image input is (3, 3)
3×3 SEDiamondArray{2, 2, UnitRange{$Int}, 0} with indices -1:1×-1:1:
 0  1  0
 1  1  1
 0  1  0

julia> strel_diamond(img; r=2) # equivalent to `strel_diamond((5,5))`
5×5 SEDiamondArray{2, 2, UnitRange{$Int}, 0} with indices -2:2×-2:2:
 0  0  1  0  0
 0  1  1  1  0
 1  1  1  1  1
 0  1  1  1  0
 0  0  1  0  0

julia> strel_diamond(img, (1,)) # mask along dimension 1
3×1 SEDiamondArray{2, 1, UnitRange{$Int}, 1} with indices -1:1×0:0:
 1
 1
 1

julia> strel_diamond((3,3), (1,)) # 3×3 mask along dimension 1
3×3 SEDiamondArray{2, 1, UnitRange{$Int}, 1} with indices -1:1×-1:1:
 0  1  0
 0  1  0
 0  1  0
```

!!! note "specialization and performance"
    The diamond shape `SEDiamond` is a special type for which many morphology algorithms may
    provide much more efficient implementations. For this reason, if one tries to collect an
    `SEDiamondArray` into other array types (e.g. `Array{Bool}` via `collect`), then a
    significant performance drop is very likely to occur.

See also [`strel`](@ref) and [`strel_box`](@ref).
"""
function strel_diamond(img::AbstractArray{T,N}, dims=coords_spatial(img); r::Union{Nothing,Int}=nothing) where {T,N}
    dims = _to_dims(Val(N), dims)
    sz, r = if isnothing(r)
        ntuple(i -> !isempty(dims) && in(i, dims) ? 3 : 1, N), 1
    else
        ntuple(i -> !isempty(dims) && in(i, dims) ? 2r + 1 : 1, N), r
    end
    return strel_diamond(sz, dims; r)
end
function strel_diamond(sz::Dims{N}, dims=ntuple(identity, N); kw...) where {N}
    dims = _to_dims(Val(N), dims)
    all(isodd, sz) || throw(ArgumentError("size should be odd integers"))
    ax = map(r -> (-r):r, sz .÷ 2)
    return SEDiamondArray(SEDiamond{N}(ax, dims; kw...))
end

# Tuple(1) is not inferable before Julia 1.9
# we want to support Colon input
@inline _to_dims(::Val{N}, i::Int) where {N} = (i,)
@inline _to_dims(::Val{N}, dims::Dims) where {N} = dims
@inline _to_dims(::Val{N}, ::Union{Colon,Tuple{Colon}}) where {N} = ntuple(identity, N)
@inline _to_dims(::Val{N}, v) where {N} = Tuple(v) # fallback

# ---
# title: "`mgradient`"
# id: op_mgradient
# cover: assets/mgradient.png
# ---

# There are three commonly used morphological gradient definitions: the beucher gradident
# `dilate(img) - erode(img)`, the external half-gradient `dilate(img) - img`, and the
# internal half-gradident `img - erode(img)`.

using ImageMorphology
using TestImages
using ImageBase
using ImageShow

img = restrict(testimage_dip3e("fig0940")) # rice
img01 = @. Gray(img > 0.5)
mosaic(img, img01; nrow=1)

# ## Beucher gradient

# The default mode is beucher gradient defined as `dilate(img) - erode(img)`.

mosaic(mgradient(img), mgradient(img01); nrow=1)

# There are two nice properties of the beucher gradient:
#
# - it is always positive if the structuring element is symmetric
# - it is a self-complementary operator -- `mgradient(img) == mgradient(complement.(img))`

all(mgradient(rand(32, 32)) .> 0) # always positive

#-

A = rand(32, 32)
mgradient(A) == mgradient(1 .- A) # self-complementary

# ## Half gradient

# If we look closely, we can see that the beucher gradient boundary is always two-pixel wide
# -- one pixel per each side.

A = falses(7, 7)
A[3:5, 3:5] .= true
A

#-

Int.(mgradient(A))

# This is because `dilate` extends the boundary for one pixel, while `erode` shrinks for one
# pixel. This observation introduces so-called _half-gradients_.
#
# The _external half-gradient_, also known as _half-gradient by dilation_, is defined as
# `dilate(img) - img`:

Int.(mgradient(A; mode=:external)) # external boundary

# The _internal half-gradient_, also known as _half-gradient by erosion_, is defined as
# `img - erode(img)`:

Int.(mgradient(A; mode=:internal)) # internal boundary

# Note that the result of internal gradient is inside the original image, and that of
# external gradient is outside the original image. Also, external gradient and internal
# are complementary to each other:

A = rand(32, 32)
mgradient(A; mode=:external) == mgradient(1 .- A; mode=:internal)

# ## Thick gradient

# The gradient thickness is controlled by the SE size, or the `r` parameter. When `r>1`, it
# is usually called _thick gradient_.

mosaic([mgradient(img01; r) for r in 1:3]; nrow=1)

# ## See also

# There are many useful gradient definitions in image processing. For instance, ImageBase.jl
# provides the finite-difference version of gradients `fdiff` and `fgradient`.
# ImageFiltering.jl provides `sobel`, `prewitt` and other gradient filters.

fout = abs.(ImageBase.FiniteDiff.fdiff(img; dims=1))
mout = mgradient(img; dims=1)
mosaic(fout, mout; nrow=1)


# For a comprehensive and more accurate documentation, please check the [`mgradient`](@ref)
# reference page.

# save cover image #src
using FileIO #src
mkpath("assets") #src
img = Gray.(restrict(testimage("blobs"))) #src
save("assets/mgradient.png", mgradient(img; r=2)) #src

"""
    label = label_components(A; [dims=coords_spatial(A)], [r=1], [bkg])
    label = label_components(A, se; [bkg])

Find and label the connected components of array `A` where the connectivity is defined by
structuring element `se`. Each component is assigned a unique integer value as its label
with `0` representing the background defined by `bkg`.

$(_docstring_se)

# Examples

```jldoctest; setup=:(using ImageMorphology)
julia> A = [false true false true  false;
            true false false  true  true]
2×5 Matrix{Bool}:
 0  1  0  1  0
 1  0  0  1  1

julia> label_components(A) # default diamond shape C4 connectivity
2×5 Matrix{$Int}:
 0  2  0  3  0
 1  0  0  3  3

julia> label_components(A; dims=2) # only the rows are considered
2×5 Matrix{$Int}:
 0  2  0  3  0
 1  0  0  4  4

julia> label_components(A, strel_box((3, 3))) # box shape C8 connectivity
2×5 Matrix{$Int}:
 0  1  0  2  0
 1  0  0  2  2
```

The in-place version is [`label_components!`](@ref). See also [`component_boxes`](@ref),
[`component_lengths`](@ref), [`component_indices`](@ref), [`component_centroids`](@ref) for
basic properties of the labeled components.
"""
label_components(A; dims=coords_spatial(A), r=1, kwargs...) = label_components(A, strel_diamond(A, dims; r); kwargs...)
label_components(A, se; kwargs...) = label_components!(similar(A, Int), A, se; kwargs...)

"""
    label_components!(out, A; [dims], [r] [bkg])
    label_components!(out, A, se; [bkg])

The in-place version of [`label_components`](@ref).
"""
function label_components!(out, A; dims=coords_spatial(A), r=1, kwargs...)
    if !(axes(out) == axes(A))
        msg = "axes of input and output must match, got $(axes(out)) and $(axes(A))"
        hint = if eltype(A) <: Bool || eltype(A) <: CartesianIndex
            "The second argument seems to be a structuring element, it is expected to be the input array."
        else
            ""
        end
        throw(DimensionMismatch("$msg. $hint"))
    end
    return label_components!(out, A, strel_diamond(A, dims; r); kwargs...)
end

function label_components!(out::AbstractArray{T}, A::AbstractArray, se; bkg=zero(eltype(A))) where {T<:Integer}
    axes(out) == axes(A) || throw_dmm(axes(out), axes(A))
    se = _maybe_build_symmetric_strel(se) # compat patch
    is_symmetric(se) || throw(ArgumentError("Non-symmetric structuring element is not supported yet"))
    upper_se, _ = strel_split(CartesianIndex, se)
    fill!(out, zero(T))
    sets = DisjointMinSets{T}()
    sizehint!(sets.parents, floor(Int, sqrt(length(A))))
    @inbounds for i in CartesianIndices(A)
        val = A[i]
        val == bkg && continue
        label = typemax(T)    # sentinel value
        for Δi in upper_se
            ii = i + Δi
            checkbounds(Bool, A, ii) || continue
            if A[ii] == val
                newlabel = out[ii]
                label = if ((label == typemax(T)) | (label == newlabel))
                    newlabel
                else
                    union!(sets, label, newlabel)
                end
            end
        end
        if label == typemax(T)
            label = push!(sets)
        end
        out[i] = label
    end
    # Now parse sets to find the labels
    newlabel = minlabel(sets)
    @inbounds for i in eachindex(A, out)
        if A[i] != bkg
            out[i] = newlabel[find_root!(sets, out[i])]
        end
    end
    return out
end

function _maybe_build_symmetric_strel(iter)
    # NOTE(johnnychen94): label_components! (<v0.4) used to accept only the splited upper
    # half part as `se`. We should still support it with a deprecation warning.
    new_se = strel(CartesianIndex, strel(Bool, iter)) # remove the center position
    sym_se = union(.-new_se, new_se)
    if length(sym_se) == 2length(new_se)
        msg =
            "`label_components!` now requires a complete symmetric structuring element," *
            " but the provided structuring element is only the upper half." *
            " This is a deprecated behavior and will be removed in a future version."
        Base.depwarn(msg, :label_components!)
        return sym_se
    else
        return iter
    end
end

function throw_dmm(ax1, ax2)
    throw(DimensionMismatch("axes of input and output must match, got $ax1 and $ax2"))
end

# Copied directly from DataStructures.jl, but specialized
# to always make the parent be the smallest label
struct DisjointMinSets{T<:Integer}
    parents::Vector{T}

    DisjointMinSets{T}(n::Integer) where {T} = new([T(1):T(n);])
end
DisjointMinSets{T}() where {T<:Integer} = DisjointMinSets{T}(T(0))
DisjointMinSets() = DisjointMinSets{INt}()

Base.@propagate_inbounds function find_root!(sets::DisjointMinSets, m::Integer)
    p = sets.parents[m]   # don't use @inbounds here, it might not be safe
    @inbounds if sets.parents[p] != p
        sets.parents[m] = p = find_root_unsafe!(sets, p)
    end
    return p
end

# an unsafe variant of the above
function find_root_unsafe!(sets::DisjointMinSets, m::Integer)
    @inbounds p = sets.parents[m]
    @inbounds if sets.parents[p] != p
        sets.parents[m] = p = find_root_unsafe!(sets, p)
    end
    return p
end

Base.@propagate_inbounds function union!(sets::DisjointMinSets, m::Integer, n::Integer)
    mp = find_root!(sets, m)
    np = find_root!(sets, n)
    if mp < np
        sets.parents[np] = mp
        return mp
    elseif np < mp
        sets.parents[mp] = np
        return np
    end
    return mp
end

function Base.push!(sets::DisjointMinSets)
    m = length(sets.parents) + 1
    m >= typemax(eltype(sets.parents)) && error("labels exhausted, use a larger integer type")
    push!(sets.parents, m)
    return m
end

function minlabel(sets::DisjointMinSets)
    out = Vector{Int}(undef, length(sets.parents))
    k = 0
    @inbounds for i in 1:length(sets.parents)
        if sets.parents[i] == i
            k += 1
        end
        out[i] = k
    end
    return out
end

"""
    boxes = component_boxes(labeled_array)

Calculates the minimal bounding boxes for each label including the background label. The
labels can be computed by [`label_components`](@ref).

Each bounding box is represented as a `CartesianIndices`. `boxes` is shifted to 0-based
indexing vector so that background region is `boxes[0]`.

```jldoctest; setup=:(using ImageMorphology)
julia> A = [2 2 2 2 2; 1 1 1 0 1; 1 0 2 1 1; 1 1 2 2 2; 1 0 2 2 2]
5×5 Matrix{$Int}:
 2  2  2  2  2
 1  1  1  0  1
 1  0  2  1  1
 1  1  2  2  2
 1  0  2  2  2

julia> label = label_components(A) # four disjoint components
5×5 Matrix{$Int}:
 1  1  1  1  1
 2  2  2  0  4
 2  0  3  4  4
 2  2  3  3  3
 2  0  3  3  3

julia> boxes = component_boxes(label) # get bounding boxes of all regions
5-element OffsetArray(::Vector{CartesianIndices{2, Tuple{UnitRange{$Int}, UnitRange{$Int}}}}, 0:4) with eltype CartesianIndices{2, Tuple{UnitRange{$Int}, UnitRange{$Int}}} with indices 0:4:
 CartesianIndices((2:5, 2:4))
 CartesianIndices((1:1, 1:5))
 CartesianIndices((2:5, 1:3))
 CartesianIndices((3:5, 3:5))
 CartesianIndices((2:3, 4:5))

julia> A[boxes[1]] # crop the image region with label 1
1×5 Matrix{$Int}:
 2  2  2  2  2

julia> A[boxes[4]] # crop the image region with label 4
2×2 Matrix{$Int}:
 0  1
 1  1
```
"""
function component_boxes(A::AbstractArray{T,N}) where {T<:Integer,N}
    mn, mx = extrema(A)
    if !(mn == 0 || mn == 1)
        throw(ArgumentError("The input labeled array should contain background label `0` as the minimum value"))
    end
    boxes = if mn == 1
        OffsetArray(Matrix{CartesianIndex{N}}(undef, mx, 2), 0, 0)
    elseif mn == 0
        OffsetArray(Matrix{CartesianIndex{N}}(undef, 1 + mx, 2), -1, 0)
    end
    R = CartesianIndices(A)
    boxes[:, 1] .= Ref(last(R))
    boxes[:, 2] .= Ref(first(R))

    @inbounds for i in R
        label_idx = A[i]
        # this actually does a few unnecessary comparison, but it's relatively harmless as
        # the main computation is limited by memory
        boxes[label_idx, 1] = min(i, boxes[label_idx, 1])
        boxes[label_idx, 2] = max(i, boxes[label_idx, 2])
    end

    # convert to CartesianIndices
    return boxes = [boxes[i, 1]:boxes[i, 2] for i in axes(boxes, 1)]
end

"""
    counts = component_lengths(labeled_array)

Count the number of each labels in the input labeled array. `counts` is shifted to 0-based
indexing vector so that the number of background pixels is `counts[0]`.

```jldoctest; setup=:(using ImageMorphology)
julia> A = [2 2 2 2 2; 1 1 1 0 1; 1 0 2 1 1; 1 1 2 2 2; 1 0 2 2 2]
5×5 Matrix{$Int}:
 2  2  2  2  2
 1  1  1  0  1
 1  0  2  1  1
 1  1  2  2  2
 1  0  2  2  2

julia> label = label_components(A) # four disjoint components
5×5 Matrix{$Int}:
 1  1  1  1  1
 2  2  2  0  4
 2  0  3  4  4
 2  2  3  3  3
 2  0  3  3  3

julia> component_lengths(label)
5-element OffsetArray(::Vector{$Int}, 0:4) with eltype $Int with indices 0:4:
 3
 5
 7
 7
 3
```

For gray images, labels can be computed by [`label_components`](@ref).
"""
function component_lengths(A::AbstractArray{T}) where {T<:Integer}
    mn, mx = extrema(A)
    if !(mn == 0 || mn == 1)
        throw(ArgumentError("The input labeled array should contain background label `0` as the minimum value"))
    end
    counts = zeros(Int, 0:mx)
    for i in eachindex(A)
        counts[A[i]] += 1
    end
    return counts
end

"""
    indices = component_indices([T], labeled_array)

Get the indices of each label in the input labeled array. `indices` is shifted to 0-based
indexing vector so that the indices of background pixels is `indices[0]`.

The optional type `T` can be either `Int`/`IndexLinear()` or
`CartesianIndex`/`IndexCartesian()` that is used to specify the type of the indices. The
default choice is `IndexStyle(labeled_array)`.

```jldoctest; setup=:(using ImageMorphology)
julia> A = [2 2 2 2 2; 1 1 1 0 1; 1 0 2 1 1; 1 1 2 2 2; 1 0 2 2 2]
5×5 Matrix{$Int}:
 2  2  2  2  2
 1  1  1  0  1
 1  0  2  1  1
 1  1  2  2  2
 1  0  2  2  2

julia> label = label_components(A) # four disjoint components
5×5 Matrix{$Int}:
 1  1  1  1  1
 2  2  2  0  4
 2  0  3  4  4
 2  2  3  3  3
 2  0  3  3  3

julia> indices = component_indices(label)
5-element OffsetArray(::Vector{Vector{$Int}}, 0:4) with eltype Vector{$Int} with indices 0:4:
 [8, 10, 17]
 [1, 6, 11, 16, 21]
 [2, 3, 4, 5, 7, 9, 12]
 [13, 14, 15, 19, 20, 24, 25]
 [18, 22, 23]

julia> indices = component_indices(CartesianIndex, label)
5-element OffsetArray(::Vector{Vector{CartesianIndex{2}}}, 0:4) with eltype Vector{CartesianIndex{2}} with indices 0:4:
 [CartesianIndex(3, 2), CartesianIndex(5, 2), CartesianIndex(2, 4)]
 [CartesianIndex(1, 1), CartesianIndex(1, 2), CartesianIndex(1, 3), CartesianIndex(1, 4), CartesianIndex(1, 5)]
 [CartesianIndex(2, 1), CartesianIndex(3, 1), CartesianIndex(4, 1), CartesianIndex(5, 1), CartesianIndex(2, 2), CartesianIndex(4, 2), CartesianIndex(2, 3)]
 [CartesianIndex(3, 3), CartesianIndex(4, 3), CartesianIndex(5, 3), CartesianIndex(4, 4), CartesianIndex(5, 4), CartesianIndex(4, 5), CartesianIndex(5, 5)]
 [CartesianIndex(3, 4), CartesianIndex(2, 5), CartesianIndex(3, 5)]
```

For gray images, labels can be computed by [`label_components`](@ref).
"""
component_indices(A) = component_indices(IndexStyle(A), A)
component_indices(::Type{T}, A) where {T<:Integer} = component_indices(IndexLinear(), A)
component_indices(::Type{T}, A) where {T<:CartesianIndex} = component_indices(IndexCartesian(), A)
component_indices(::IndexCartesian, A) = _component_indices(A, CartesianIndices(A))
component_indices(::IndexLinear, A) = _component_indices(A, LinearIndices(A))

function _component_indices(A::AbstractArray{<:Integer,N}, R::AbstractArray{T,N}) where {T,N}
    mn, mx = extrema(A)
    if !(mn == 0 || mn == 1)
        throw(ArgumentError("The input labeled array should contain background label `0` as the minimum value"))
    end
    indices = OffsetVector([T[] for _ in 0:mx], -1)
    @inbounds for i in R
        push!(indices[A[i]], i)
    end
    return indices
end

"""
    centroids = component_centroids(labeled_array)

Compute the centroid of each label in the input labeled array. `centroids` is shifted to
0-based indexing vector so that the centroid of background pixels is `centroids[0]`.

The centroid of a finite set `X`, also known as geometric center, is calculated using
`sum(X)/length(X)`. For label `i`, all (Cartesian) indices of pixels with label `i` are used
to build the set `X`

```jldoctest; setup=:(using ImageMorphology)
julia> A = [2 2 2 2 2; 1 1 1 0 1; 1 0 2 1 1; 1 1 2 2 2; 1 0 2 2 2]
5×5 Matrix{$Int}:
 2  2  2  2  2
 1  1  1  0  1
 1  0  2  1  1
 1  1  2  2  2
 1  0  2  2  2

julia> label = label_components(A) # four disjoint components
5×5 Matrix{$Int}:
 1  1  1  1  1
 2  2  2  0  4
 2  0  3  4  4
 2  2  3  3  3
 2  0  3  3  3

julia> component_centroids(label)
5-element OffsetArray(::Vector{Tuple{Float64, Float64}}, 0:4) with eltype Tuple{Float64, Float64} with indices 0:4:
 (3.3333333333333335, 2.6666666666666665)
 (1.0, 3.0)
 (3.142857142857143, 1.5714285714285714)
 (4.285714285714286, 3.857142857142857)
 (2.6666666666666665, 4.666666666666667)
```

For gray images, labels can be computed by [`label_components`](@ref).
"""
function component_centroids(A::AbstractArray{<:Integer,N}) where {N}
    mn, mx = extrema(A)
    if !(mn == 0 || mn == 1)
        throw(ArgumentError("The input labeled array should contain background label `0` as the minimum value"))
    end
    n = fill(zero(CartesianIndex{N}), mn:mx)
    counts = fill(0, mn:mx)
    @inbounds for I in CartesianIndices(size(A))
        v = A[I]
        n[v] += I
        counts[v] += 1
    end
    return map((v, l) -> v.I ./ l, n, counts)
end

# deprecated
"`component_subscripts(labeled_array)` -> an array of pixels for each label, including the background label 0"
function component_subscripts(img::AbstractArray{Int})
    Base.depwarn("`component_subscripts` is deprecated. Use `component_indices(CartesianIndex, A)` instead.", :component_subscripts)
    n = [Tuple[] for i in 0:maximum(img)]
    s = CartesianIndices(size(img))
    for i in 1:length(img)
        push!(n[img[i] + 1], s[i])
    end
    return n
end

"""
    label_flatzones(img; [dims])
    label_flatzones(img; se)

Find the flat zones in image 'img'. Flat zones are defined as
connected (respect to se) voxels that have the same value.

The `dims` keyword is used to specify the dimension to process by constructing the box shape
structuring element [`strel_box(img; dims)`](@ref strel_box). For generic structuring
element, the half-size is expected to be either `0` or `1` along each dimension.

The output `labeled image` is an integer array.
"""
function label_flatzones(img; dims=coords_spatial(img))
    return label_flatzones(img, strel_box(img, dims))
end

function label_flatzones(img, se)
    return label_flatzones!(similar(img, Int), img, se)
end

function label_flatzones!(out, img; dims=coords_spatial(img))
    return label_flatzones!(out, img, strel_box(img, dims))
end

function label_flatzones!(out, img, se)
    return _generic_naive_labeling!(out, img, se)
end

"""
    label_lambdaflatzones(img; [dims])
    label_lambdaflatzones(img; se)

Find the lambda flat zones in image 'img'. Lambda Flat zones are defined as
connected (respect to se) voxels that have diff(value)<lambda.

The `dims` keyword is used to specify the dimension to process by constructing the box shape
structuring element [`strel_box(img; dims)`](@ref strel_box). For generic structuring
element, the half-size is expected to be either `0` or `1` along each dimension.

The output `labeled image` is an integer array.
"""

function label_lambdaflatzones(img, lambda; dims=coords_spatial(img))
    return label_lambdaflatzones(img, lambda, strel_box(img, dims))
end

function label_lambdaflatzones(img, lambda, se)
    return label_lambdaflatzones!(similar(img, Int), img, lambda, se)
end

function label_lambdaflatzones!(out, img, lambda; dims=coords_spatial(img))
    return label_lambdaflatzones!(out, img, lambda, strel_box(img, dims))
end

function label_lambdaflatzones!(out, img, lambda, se)
    return _generic_naive_labeling!(out, img, se, (x) -> true, (x, y) -> abs(x - y) <= lambda)
end

function _generic_naive_labeling!(out, img, se, can_be_labelled=(x) -> true, is_connected=(x, y) -> x == y)
    N = ndims(img)

    axes(out) == axes(img) || throw(DimensionMismatch("images should have the same axes"))

    se_size = strel_size(se)
    if length(se_size) != N
        msg = "the input structuring element is not for $N dimensional array, instead it is for $(length(se_size)) dimensional array"
        throw(DimensionMismatch(msg))
    end
    if !all(x -> in(x, (1, 3)), strel_size(se))
        msg = "structuring element with half-size larger than 1 is invalid"
        throw(DimensionMismatch(msg))
    end
    se = strel(CartesianIndex, se)

    fill!(out, 0)
    visited = similar(Array{Bool}, axes(img))
    fill!(visited, false)

    propagationfront = Queue{CartesianIndex{N}}() #Use queue to store propagation front

    R = CartesianIndices(axes(img))
    curr_label = 1
    for i in R
        # compute the "connected" zones of the image
        @inbounds if !visited[i] #candidate point aka not visited yet, start "connected" zones
            # mark point as visited
            @inbounds visited[i] = true
            @inbounds out[i] = curr_label
            push!(propagationfront, i)
            while !isempty(propagationfront)
                #get indice from propagationfront
                idx_front = popfirst!(propagationfront)
                # get value at current point
                @inbounds centervalue = img[idx_front]
                if can_be_labelled(centervalue) # eg could be specialize for no background
                    #examine neighborhood points
                    for Δi in se # examine neighborhoods
                        ii = idx_front + Δi
                        if checkbounds(Bool, R, ii) #check that we are in the image
                            @inbounds nl_value = img[ii]
                            # is this pixel is connected ?
                            if is_connected(nl_value, centervalue)
                                # yes, propagate the "connected" zones to this pixel
                                @inbounds if !visited[ii]
                                    push!(propagationfront, ii)
                                    # mark it as visited
                                    visited[ii] = true
                                    #propagate label
                                    out[ii] = curr_label
                                end
                            end
                        end
                    end #for all neighborValue
                end
            end # propagation front empty
            curr_label += 1 #increment label
            curr_label >= typemax(Int) && error("labels exhausted")
        end # test we can visit current point
    end # loop along idx image
    return out
end

"""
    closing(img; dims=coords_spatial(img), r=1)
    closing(img, se)

Perform the morphological closing on `img`. The closing operation is defined as dilation
followed by an erosion: `erode(dilate(img, se), se)`.

$(_docstring_se)

# Examples

```jldoctest; setup = :(using ImageMorphology)
julia> img = falses(7,7); img[2, 2] = true; img[3:5, 3:5] .= true; img[4, 4] = false; img
7×7 BitMatrix:
 0  0  0  0  0  0  0
 0  1  0  0  0  0  0
 0  0  1  1  1  0  0
 0  0  1  0  1  0  0
 0  0  1  1  1  0  0
 0  0  0  0  0  0  0
 0  0  0  0  0  0  0

julia> closing(img)
7×7 BitMatrix:
 1  1  0  0  0  0  0
 1  1  0  0  0  0  0
 0  0  1  1  1  0  0
 0  0  1  1  1  0  0
 0  0  1  1  1  0  0
 0  0  0  0  0  0  0
 0  0  0  0  0  0  0

julia> closing(img, strel_diamond(img)) # # use diamond shape SE
7×7 BitMatrix:
 0  0  0  0  0  0  0
 0  1  0  0  0  0  0
 0  0  1  1  1  0  0
 0  0  1  1  1  0  0
 0  0  1  1  1  0  0
 0  0  0  0  0  0  0
 0  0  0  0  0  0  0
```

## See also

- [`opening!`](@ref) is the in-place version of this function.
- [`closing`](@ref) is the dual operator of `opening` in the sense that
  `complement.(opening(img)) == closing(complement.(img))`.
"""
closing(img; kwargs...) = closing!(similar(img), img, similar(img); kwargs...)
closing(img, se) = closing!(similar(img), img, se, similar(img))

"""
    closing!(out, img, buffer; [dims], [r])
    closing!(out, img, se, buffer)

The in-place version of [`closing`](@ref) with input image `img` and output image `out`. The
intermediate dilation result is stored in `buffer`.
"""
function closing!(out, img, buffer; dims=coords_spatial(img), r=nothing)
    return closing!(out, img, strel_box(img, dims; r), buffer)
end
function closing!(out, img, se, buffer)
    dilate!(buffer, img, se)
    erode!(out, buffer, se)
    return out
end
closing!(out::AbstractArray{<:Color3}, img, se, buffer) = throw(ArgumentError("color image is not supported"))

# ---
# title: "`dilate`"
# id: op_dilate
# cover: assets/dilate.png
# ---

# The dilation operator `dilate` is essentially a max filter. This is a basic term in
# mathematical morphology -- many operations are built on top of `dilate` and the
# [`erode`](@ref) operator.

using ImageMorphology
using TestImages
using ImageBase
using ImageShow

img = restrict(testimage_dip3e("fig1005")) # wirebond mask

# For each pixel, dilation is the maximum of the pixels in the neighborhood. In mathematics,
# `dilate(A, Ω)` is defined as ``\delta_A[p] = \sup\{A[p+o] | o \in \Omega\}`` where `Ω` is
# the [structuring element](@ref concept_se).

# The simplest usage is `dilate(img; [dims], [r])`, where `dims` and `r` controls the
# neighborhood shape.

out1 = dilate(img) # default: all spatial dimensions, r=1, a box-shape SE
out2 = dilate(img; dims=(2,)) # only apply to the second dimension
out3 = dilate(img; r=5) # half-size r=5
mosaic(out1, out2, out3; nrow=1)

# It uses the [`strel_box`](@ref) to create a box-shaped structuring element. You can also
# provide a custom SE via the `dilate(img, se)` interface.

out1 = dilate(img, strel_box((3, 3))) # default se for`dilate(img)`
se = centered(Bool[1 1 1; 1 1 0; 0 0 0]) # match top-left region
out2 = dilate(img, se)
mosaic(out1, out2; nrow=1)

# An in-place version `dilate!` is also provided, for instance

out1 = similar(img)
dilate!(out1, img)

out2 = similar(img)
dilate!(out2, img, strel_diamond((3, 3)))
#md nothing #hide

# ## See also

# [`erode`](@ref op_erode) is the dual operator of `dilate` in the following sense:

complement.(dilate(img)) == erode(complement.(img))

# For bool arrays and [symmetric SEs](@ref concept_symmetric), dilation becomes equivalent
# to the minkowski addition on sets: ``A \oplus B = \{ a+b | a \in A, b \in B \}``.

# For a comprehensive and more accurate documentation, please check the [`dilate`](@ref)
# reference page.

# save cover image #src
using FileIO #src
mkpath("assets") #src
img = Gray.(restrict(testimage("blobs"))) #src
save("assets/dilate.png", dilate(img; r=1)) #src

using Base.Checked

#=
    maybe_floattype(T)

To keep consistant with Base `diff` that Int array outputs Int array. It is sometimes
useful to only promote types for Bool and FixedPoint. In most of the time, `floattype`
should be the most reliable way.
=#
maybe_floattype(::Type{T}) where {T} = T
maybe_floattype(::Type{Bool}) = floattype(Bool)
maybe_floattype(::Type{T}) where {T<:FixedPoint} = floattype(T)
maybe_floattype(::Type{CT}) where {CT<:Color} = base_color_type(CT){maybe_floattype(eltype(CT))}

#=
A helper to eagerly check if particular function makes sense for `extreme_filter` semantics.
For instance, `max(::RGB, ::RGB)` is not well-defined and we should early throw errors so that
our users don't get encrypted error messages.
=#
require_select_function(f, ::Type{T}) where {T} = require_select_function(f, T, T)
function require_select_function(f, ::Type{T1}, ::Type{T2}) where {T1,T2}
    if !_is_select_function(f, T1, T2)
        hint = "does `f(x::T1, y::T2)` work as expected?"
        throw(ArgumentError("function `$f` is not a well-defined select function on type `$T1` and `$T2`: $hint"))
    end
end
_is_select_function(f, ::Type{T}) where {T} = _is_select_function(f, T, T)

_is_select_function(f, ::Type{T1}, ::Type{T2}) where {T1,T2} = _is_select_function_trial(f, T1, T2)
function _is_select_function(f, ::Type{T1}, ::Type{T2}) where {T1<:Real,T2<:Real}
    f in (min, max) && return true
    return _is_select_function_trial(f, T1, T2)
end
function _is_select_function(f, ::Type{CT1}, ::Type{CT2}) where {CT1<:AbstractGray,CT2<:AbstractGray}
    f in (min, max) && return true
    return _is_select_function_trial(f, CT1, CT2)
end
function _is_select_function(f, ::Type{CT1}, ::Type{CT2}) where {CT1<:Colorant,CT2<:Colorant}
    # min/max is not well-defined on generic color space
    f in (min, max) && return false
    return _is_select_function_trial(f, CT1, CT2)
end
function _is_select_function_trial(f, ::Type{T1}, ::Type{T2}) where {T1,T2}
    # for generic case, just run a trial and see if it doesn't error
    try
        f(zero(T1), zero(T2))
        return true
    catch
        return false
    end
end

saturating_add(x::T, y::T) where {T<:FixedPoint} =
    T(x.i + ifelse(x.i < 0, max(y.i, typemin(x.i) - x.i), min(y.i, typemax(x.i) - x.i)), 0)
saturating_add(x::T, y::T) where {T<:FixedPoint{<:Unsigned}} = T(x.i + min(~x.i, y.i), 0)

saturating_sub(x::T, y::T) where {T<:FixedPoint} =
    T(x.i - ifelse(x.i < 0, min(y.i, x.i - typemin(x.i)), max(y.i, x.i - typemax(x.i))), 0)
saturating_sub(x::T, y::T) where {T<:FixedPoint{<:Unsigned}} = T(x.i - min(x.i, y.i), 0)

"""
    out = erode(img; dims=coords_spatial(img), r=1)
    out = erode(img, se)

Perform a min-filter over the neighborhood of `img`, specified by structuring element `se`.

$(_docstring_se)

# Examples

```jldoctest; setup = :(using ImageMorphology)
julia> img = trues(5, 5); img[3, [2, 4]] .= false; img
5×5 BitMatrix:
 1  1  1  1  1
 1  1  1  1  1
 1  0  1  0  1
 1  1  1  1  1
 1  1  1  1  1

julia> erode(img)
5×5 BitMatrix:
 1  1  1  1  1
 0  0  0  0  0
 0  0  0  0  0
 0  0  0  0  0
 1  1  1  1  1

julia> erode(img; dims=1)
5×5 BitMatrix:
 1  1  1  1  1
 1  0  1  0  1
 1  0  1  0  1
 1  0  1  0  1
 1  1  1  1  1

julia> erode(img, strel_diamond(img)) # use diamond shape SE
5×5 BitMatrix:
 1  1  1  1  1
 1  0  1  0  1
 0  0  0  0  0
 1  0  1  0  1
 1  1  1  1  1
```

## See also

- [`erode!`](@ref) is the in-place version of this function
- [`dilate`](@ref) is the dual operator of `erode` in the sense that
  `complement.(dilate(img)) == erode(complement.(img))`.

!!! note "symmetricity"
    If `se` is symmetric with repsect to origin, i.e., `se[b] == se[-b]` for any `b`, then
    erosion becomes the Minkowski difference: A⊖B={a-b|a∈A, b∈B}.
"""
erode(img::AbstractArray; kwargs...) = erode!(similar(img), img; kwargs...)
erode(img::AbstractArray, se::AbstractArray) = erode!(similar(img), img, se)

"""
    erode!(out, img; [dims], [r])
    erode!(out, img, se)

The in-place version of [`erode`](@ref) with input image `img` and output image `out`.
"""
function erode!(out, img; dims=coords_spatial(img), r=nothing)
    return erode!(out, img, strel_box(img, dims; r))
end
erode!(out, img, se::AbstractArray) = extreme_filter!(min, out, img, se)
erode!(out::AbstractArray{<:Color3}, img, se::AbstractArray) = throw(ArgumentError("color image is not supported"))

# ---
# title: "`mlaplacian`"
# id: op_mlaplacian
# cover: assets/mlaplacian.png
# ---

# Laplacian operator is defined as the difference between external gradient and internal
# gradient -- `mgradient(img; mode=:external) - mgradient(img; mode=:internal)`.

using ImageMorphology
using TestImages
using ImageBase
using ImageShow

img = restrict(testimage_dip3e("fig0940")) # rice
img01 = @. Gray(img > 0.5)
mosaic(img, img01; nrow=1)

#-

mosaic(mlaplacian(img), mlaplacian(img01); nrow=1)

# Note that laplacian can produce negative values:

A = falses(7, 7)
A[3:5, 3:5] .= true
A[4, 4] = false
Int.(mlaplacian(A))

# ## See also

# ImageBase.jl provides the finite-difference version of laplace operator `flaplacian`.
# ImageFiltering.jl provides `Laplacian` and `LaplacianOfGaussian` kernels.

fout = abs.(ImageBase.FiniteDiff.flaplacian(img))
mout = abs.(mlaplacian(img))
mosaic(fout, mout; nrow=1)

# For a comprehensive and more accurate documentation, please check the [`mlaplacian`](@ref)
# reference page.

# save cover image #src
using FileIO #src
mkpath("assets") #src
img = Gray.(restrict(testimage("blobs"))) #src
save("assets/mlaplacian.png", abs.(mlaplacian(img; r=2))) #src

"""
    upper, lower = strel_split([T], se)

Split a symmetric structuring element into its upper and lower half parts based on its
center point.

For each element `o` in `strel(CartesianIndex, upper)`, its negative `-o` is an element of
`strel(CartesianIndex, lower)`. This function is not the inverse of [`strel_chain`](@ref).

The splited non-symmetric SE parts will be represented as array of `T`, where `T` is either
a `Bool` or `CartesianIndex`. By default, `T = eltype(se)`.

```jldoctest strel_split; setup=:(using ImageMorphology; using ImageMorphology.StructuringElements)
julia> se = strel_diamond((3, 3))
3×3 SEDiamondArray{2, 2, UnitRange{$Int}, 0} with indices -1:1×-1:1:
 0  1  0
 1  1  1
 0  1  0

julia> upper, lower = strel_split(se);

julia> upper
3×3 OffsetArray(::Matrix{Bool}, -1:1, -1:1) with eltype Bool with indices -1:1×-1:1:
 0  1  0
 1  1  0
 0  0  0

julia> lower
3×3 OffsetArray(::Matrix{Bool}, -1:1, -1:1) with eltype Bool with indices -1:1×-1:1:
 0  0  0
 0  1  1
 0  1  0
```

If the `se` is represented as displacement offset array, then the splited result will also
be displacement offset array:

```jldoctest strel_split
julia> se = strel(CartesianIndex, se)
4-element Vector{CartesianIndex{2}}:
 CartesianIndex(0, -1)
 CartesianIndex(-1, 0)
 CartesianIndex(1, 0)
 CartesianIndex(0, 1)

julia> upper, lower = strel_split(se);

julia> upper
2-element Vector{CartesianIndex{2}}:
 CartesianIndex(0, -1)
 CartesianIndex(-1, 0)

julia> lower
2-element Vector{CartesianIndex{2}}:
 CartesianIndex(1, 0)
 CartesianIndex(0, 1)
```
"""
strel_split(se) = strel_split(eltype(se), se)
function strel_split(T, se)
    se = strel(Bool, se)
    require_symmetric_strel(se)
    R = LinearIndices(se)
    c = R[OffsetArrays.center(R)...]

    upper = copy(se)
    lower = copy(se)
    upper[(c + 1):end] .= false
    lower[begin:(c - 1)] .= false

    return strel(T, upper), strel(T, lower)
end

"""
    is_symmetric(se)

Check if a given structuring element array `se` is symmetric with respect to its center
pixel.

More formally, this checks if `mask[I] == mask[-I]` for any valid `I ∈
CartesianIndices(mask)` in the connectivity mask represetation `mask = strel(Bool, se)`.
"""
function is_symmetric(se::AbstractArray)
    # first check the axes, and then the values
    se = centered(strel(Bool, se))
    all(r -> first(r) == -last(r), axes(se)) || return false
    R = CartesianIndices(map(r -> 0:maximum(r), axes(se)))
    return all(R) do o
        @inbounds se[o] == se[-o]
    end
end
is_symmetric(se::SEBoxArray) = true
is_symmetric(se::SEDiamondArray) = true

#=
Some morphological operation only makes sense for symmetric structuring elements.
Here we provide a checker in spirit of Base.require_one_based_idnexing.
=#
require_symmetric_strel(se) = is_symmetric(se) || throw(ArgumentError("structuring element must be symmetric with respect to its center"))

mlaplacian_ref(img, dims, r) = mlaplacian_ref(img, strel_box(img, dims; r))
mlaplacian_ref(img, se) = float.(dilate(img, se)) .+ float.(erode(img, se)) .- 2 .* float.(img)

@testset "mlaplacian" begin
    test_ranges = [Bool, 1:10, Float64, Gray{N0f8}, Gray{Float64}]
    for T in test_ranges
        for N in (1, 2, 3)
            sz = ntuple(_ -> 32, N)
            img = rand(T, sz...)

            out = mlaplacian(img)
            @test out == mlaplacian(img, strel_box(img, ntuple(identity, N); r=1))
            @test out == mlaplacian_ref(img, ntuple(identity, N), 1)

            @test mlaplacian(img; dims=(1,), r=2) == mlaplacian_ref(img, (1,), 2)

            se = rand_se_mask(3, N; symmetric=true)
            @test mlaplacian(img, se) == mlaplacian_ref(img, se)
        end
    end

    img = rand(1:5, 7, 7)
    out = similar(img)
    mlaplacian!(out, img, similar(img))
    @test out == mlaplacian(img)

    img = rand(RGB, 7, 7)
    @test_throws ArgumentError("color image is not supported") mlaplacian(img)

    img = rand(1:10, 7, 7)
    se = Bool[1 0 0; 0 1 0; 0 0 0]
    msg = "structuring element must be symmetric with respect to its center"
    @test_throws ArgumentError(msg) mlaplacian(img, se)
end

@testset "strel" begin
    @testset "offset to mask" begin
        se = [CartesianIndex(-1), CartesianIndex(1)]
        se_mask = @inferred strel(Bool, se)
        @test axes(se_mask) == (-1:1,)
        @test se_mask == centered(Bool[1, 1, 1])

        se = [CartesianIndex(-1, -1), CartesianIndex(1, 1)]
        @test strel(se) === se
        se_mask = @inferred strel(Bool, se)
        @test axes(se_mask) == (-1:1, -1:1)
        @test se_mask == centered(Bool[1 0 0; 0 1 0; 0 0 1])
        # internally, Bool is converted to SEMask
        se_mask = @inferred strel(ImageMorphology.SEMask{2}(), se)
        @test se_mask == centered(Bool[1 0 0; 0 1 0; 0 0 1])

        se = CartesianIndices((-1:1, -1:1))
        se_mask = @inferred strel(Bool, se)
        @test se_mask == centered(trues((3, 3)))

        se = CartesianIndices((1:2, -1:1))
        se_mask = @inferred strel(Bool, se)
        @test axes(se_mask) == (-2:2, -1:1)
        @test se_mask == centered(Bool[0 0 0; 0 0 0; 0 1 0; 1 1 1; 1 1 1])

        se = @inferred strel(Bool, CartesianIndex{2}[])
        @test se == centered(reshape(Bool[1], (1, 1))) # v1.7: Bool[1;;]

        # invalid cases
        se = [CartesianIndex(1), CartesianIndex(1, 1)]
        @test_throws ErrorException strel(se)
    end

    @testset "mask to offset" begin
        se = centered(Bool[1, 0, 1])
        se_offsets = @inferred strel(CartesianIndex, se)
        @test se_offsets == [CartesianIndex(-1), CartesianIndex(1)]
        @test se_offsets == strel(CartesianIndex, centered(Bool[1, 1, 1]))

        se = centered(Bool[1 0 0; 0 1 0; 0 0 1])
        se_offsets = @inferred strel(CartesianIndex, se)
        @test se_offsets == [CartesianIndex(-1, -1), CartesianIndex(1, 1)]
        # internally, CartesianIndex is converted to SEOffset
        se_offsets = @inferred strel(ImageMorphology.SEOffset{2}(), se)
        @test se_offsets == [CartesianIndex(-1, -1), CartesianIndex(1, 1)]

        se = centered(trues((3, 3)))
        se_offsets = @inferred strel(CartesianIndex, se)
        @test se_offsets == filter(x -> !iszero(x), vec(CartesianIndices((-1:1, -1:1))))

        se = @inferred strel(CartesianIndex, centered(falses(3, 3)))
        @test isempty(se)

        # test deprecation
        msg = @capture_err strel(CartesianIndex, trues(3, 3))
        @test isempty(msg) || contains(msg, "connectivity mask is expected to be a centered bool array")
        # but only for 1-based array
        se = OffsetArray(trues(3, 3), -1, -1)
        msg = "`connectivity` must be symmetric bool array"
        @test_throws ArgumentError(msg) strel(CartesianIndex, se)
    end

    @testset "center point" begin
        for se in centered.([Bool[1 0 0; 0 1 0; 0 0 1], Bool[1 0 0; 0 0 0; 0 0 1]])
            # center point is always excluded in offsets
            se_offsets = @inferred strel(CartesianIndex, se)
            @test se_offsets == [CartesianIndex(-1, -1), CartesianIndex(1, 1)]
            # but included in mask
            se_mask = @inferred strel(Bool, se_offsets)
            @test se_mask == centered(Bool[1 0 0; 0 1 0; 0 0 1])
        end
    end
end

@testset "strel_chain" begin
    se1 = centered(Bool[0 1 0; 0 1 0; 0 1 0])
    se2 = centered(Bool[0 0 0; 1 1 1; 0 0 0])
    se = @inferred strel_chain(se1, se2)
    @test se isa ImageMorphology.SEChainArray
    @test eltype(se) == Bool
    @test axes(se) == (-1:1, -1:1)
    @test se == strel_box((3, 3))
    @test se == strel_chain([se1, se2]) == strel_chain((se1, se2))
    @test se === strel_chain(se)
    @test strel_size(se) == (3, 3)

    for f in Any[dilate, erode]
        se1 = centered(rand(Bool, 3, 3))
        se2 = centered(rand(Bool, 3, 3))
        img = rand(64, 64)
        out_pipe = f(f(img, se1), se2)
        out_se = f(img, strel_chain(se1, se2))
        R = CartesianIndices(img)[2:(end - 1), 2:(end - 1)] # inner region
        @test out_pipe[R] == out_se[R]
    end
end

@testset "strel_product" begin
    se1 = centered(Bool[1, 1, 1])
    se2 = centered(Bool[1, 1, 1])
    se = strel_product(se1, se2)
    @test_broken @inferred strel_product(se1, se2) # if necessary, fix this inference issue
    @test se isa ImageMorphology.SEChainArray
    @test se == strel_box((3, 3))

    se_list = [centered(rand(Bool, sz...)) for sz in Any[(3,), (3, 3), (3, 3, 3)]]
    se = strel_product(se_list)
    @test ndims(se) == 6
end

@testset "strel_diamond" begin
    @testset "N=1" begin
        img = rand(5)
        se = @inferred strel_diamond(img)
        @test se isa ImageMorphology.SEDiamondArray
        @test eltype(se) == Bool
        @test axes(se) == (-1:1,)
        @test se == centered(Bool[1, 1, 1])

        se = @inferred strel_diamond((5,); r=1)
        @test se == centered(Bool[0, 1, 1, 1, 0])

        se = @inferred strel_diamond((5,))
        @test se == centered(Bool[1, 1, 1, 1, 1])
    end

    @testset "N=2" begin
        img = rand(5, 5)
        se = @inferred strel_diamond(img)
        @test se isa ImageMorphology.SEDiamondArray
        @test eltype(se) == Bool
        @test axes(se) == (-1:1, -1:1)
        @test se == centered(Bool[0 1 0; 1 1 1; 0 1 0])
        @test se == strel_diamond((3, 3), (1, 2); r=1)
        @test se == strel_diamond(img, (1, 2); r=1)
        @test se == strel_diamond(img, :) == strel_diamond(img, (:,))

        se = @inferred strel_diamond(img, (1,))
        @test se == @inferred strel_diamond(img, 1)
        @test se == centered(reshape(Bool[1, 1, 1], (3, 1)))

        se = @inferred strel_diamond((5, 5), (2, 1))
        @test se == strel_diamond((5, 5), 1:2) # not inferable

        se = @inferred strel_diamond((5, 5))
        @test se == centered(Bool[0 0 1 0 0; 0 1 1 1 0; 1 1 1 1 1; 0 1 1 1 0; 0 0 1 0 0])

        se = @inferred strel_diamond((3, 5))
        @test se == centered(Bool[0 1 1 1 0; 1 1 1 1 1; 0 1 1 1 0])

        se = @inferred strel_diamond((3, 5), (1,))
        @test se == @inferred strel_diamond((3, 5), 1)
        @test se == centered(Bool[0 0 1 0 0; 0 0 1 0 0; 0 0 1 0 0])

        se = @inferred strel_diamond((3, 5), (2,))
        @test se == centered(Bool[0 0 0 0 0; 1 1 1 1 1; 0 0 0 0 0])

        se = @inferred strel_diamond((3, 5); r=2)
        @test se == centered(Bool[0 1 1 1 0; 1 1 1 1 1; 0 1 1 1 0])
    end

    @testset "N=3" begin
        img = rand(5, 5, 5)
        se = @inferred strel_diamond(img)
        @test se isa ImageMorphology.SEDiamondArray
        @test eltype(se) == Bool
        @test axes(se) == (-1:1, -1:1, -1:1)
        @test se[:, :, -1] == se[:, :, 1] == centered(Bool[0 0 0; 0 1 0; 0 0 0])
        @test se[:, :, 0] == strel_diamond((3, 3))

        se = @inferred strel_diamond((3, 3, 3), (1, 2))
        @test se[:, :, -1] == se[:, :, 1] == centered(falses((3, 3)))
        @test se[:, :, 0] == strel_diamond((3, 3))
    end

    @testset "strel conversion" begin
        se = strel_diamond((3, 3))
        se_offsets = @inferred strel(CartesianIndex, se)
        @test se_offsets == [CartesianIndex(0, -1), CartesianIndex(-1, 0), CartesianIndex(1, 0), CartesianIndex(0, 1)]
        se_mask = @inferred strel(Bool, se)
        # not BitMatrix as SEDiamondArray provides more information of what the SE is
        @test se_mask isa ImageMorphology.SEDiamondArray
        @test se_mask === se
    end

    # edge cases
    img = rand(5, 5)
    err = ArgumentError("`axes` length should be at least 2")
    @test_throws err strel_diamond((3,), (1, 2))
    err = ArgumentError("size should be odd integers")
    @test_throws err strel_diamond((2, 3))
    err = ArgumentError("dims should be unique")
    @test_throws err strel_diamond((3, 3), (1, 1))
    err = ArgumentError("all `dims` values should be less than or equal to 2")
    @test_throws err strel_diamond((3, 3), (5,))
end

@testset "strel_box" begin
    @testset "N=1" begin
        img = rand(5)
        se = @inferred strel_box(img)
        @test se isa ImageMorphology.SEBoxArray
        @test eltype(se) == Bool
        @test se == centered(Bool[1, 1, 1])

        se = @inferred strel_box((5,))
        @test se == centered(Bool[1, 1, 1, 1, 1])

        se = @inferred strel_box((5,); r=1)
        @test se == centered(Bool[0, 1, 1, 1, 0])
    end

    @testset "N=2" begin
        img = rand(5, 5)
        se = @inferred strel_box(img)
        @test se isa ImageMorphology.SEBoxArray
        @test eltype(se) == Bool
        @test se == centered(Bool[1 1 1; 1 1 1; 1 1 1])
        @test se == strel_box(img; r=1)
        @test se == strel_box(img, :) == strel_box(img, (:,))

        se = @inferred strel_box(img, (1,))
        @test se == @inferred strel_box((3, 1), (1,))
        @test se == @inferred strel_box((3, 1), 1)

        se = @inferred strel_box(img; r=2)
        @test se == centered(trues((5, 5)))

        se = @inferred strel_box(img; r=(1, 2))
        @test se == centered(trues((3, 5)))

        se = @inferred strel_box((5, 5), (2, 1))
        @test se == @inferred strel_box((5, 5), 1:2)

        se = @inferred strel_box((3, 5))
        @test se == centered(Bool[1 1 1 1 1; 1 1 1 1 1; 1 1 1 1 1])

        se = @inferred strel_box((3, 5); r=1)
        @test se == centered(Bool[0 1 1 1 0; 0 1 1 1 0; 0 1 1 1 0])

        se = @inferred strel_box((3, 5); r=(1, 0))
        @test se == @inferred strel_box((3, 5), (1,))
        @test se == @inferred strel_box((3, 5), 1)
        @test se == centered(Bool[0 0 1 0 0; 0 0 1 0 0; 0 0 1 0 0])

        se = @inferred strel_box((3, 5); r=(0, 1))
        @test se == centered(Bool[0 0 0 0 0; 0 1 1 1 0; 0 0 0 0 0])

        se = @inferred strel_box((3, 5), (2,))
        @test se == centered(Bool[0 0 0 0 0; 1 1 1 1 1; 0 0 0 0 0])

        se = @inferred strel_box((3, 5); r=2)
        @test se == centered(Bool[1 1 1 1 1; 1 1 1 1 1; 1 1 1 1 1])
    end

    @testset "N=3" begin
        img = rand(5, 5, 5)
        se = @inferred strel_box(img)
        @test se isa ImageMorphology.SEBoxArray
        @test eltype(se) == Bool
        @test se[:, :, -1] == se[:, :, 1] == centered(trues((3, 3)))
        @test se[:, :, 0] == strel_box((3, 3))

        se = @inferred strel_box((3, 3, 3), (1, 2))
        @test axes(se) == (-1:1, -1:1, -1:1)
        @test se[:, :, 0] == strel_box((3, 3))
    end

    @testset "strel conversion" begin
        se = strel_box((3, 3))
        se_offsets = @inferred strel(CartesianIndex, se)
        @test se_offsets == filter(i -> !iszero(i), vec(CartesianIndices((-1:1, -1:1))))
        se_mask = @inferred strel(Bool, se)
        # not BitMatrix as SEBoxArray provides more information of what the SE is
        @test se_mask isa ImageMorphology.SEBoxArray
        @test se_mask === se
    end
end

@testset "strel_split" begin
    se = strel_diamond((3, 3))
    upper, lower = ImageMorphology.strel_split(se)
    @test upper == centered(Bool[0 1 0; 1 1 0; 0 0 0])
    @test lower == centered(Bool[0 0 0; 0 1 1; 0 1 0])
    se = strel(CartesianIndex, se)
    upper, lower = ImageMorphology.strel_split(se)
    @test upper == [CartesianIndex(0, -1), CartesianIndex(-1, 0)]
    @test lower == [CartesianIndex(1, 0), CartesianIndex(0, 1)]

    # non-symmetric is not allowed
    se = collect(strel_diamond((3, 3)))
    se[1, 1] = true
    msg = "structuring element must be symmetric with respect to its center"
    @test_throws ArgumentError(msg) ImageMorphology.strel_split(se)
end

@testset "strel_type" begin
    @test strel_type(strel_diamond((3, 3))) isa ImageMorphology.SEDiamond
    @test strel_type(strel_box((3, 3))) isa ImageMorphology.SEBox
    @test strel_type([CartesianIndex(1, 2)]) isa ImageMorphology.SEOffset
    @test strel_type(CartesianIndices((-1:1, -1:1))) isa ImageMorphology.SEOffset
    @test strel_type(trues(3, 3)) isa ImageMorphology.SEMask

    msg = "invalid structuring element data type: $(Vector{CartesianIndex})"
    @test_throws ErrorException(msg) strel_type(CartesianIndex[])
end

@testset "strel_size" begin
    se = strel_diamond((5, 5), (1,))
    @test strel_size(se) == strel_size(centered(collect(se))) == (5, 1)

    se = strel_box((5, 5), (2,))
    @test strel_size(se) == strel_size(centered(collect(se))) == (1, 5)

    se = [CartesianIndex(-2, -2), CartesianIndex(1, 1)]
    @test strel_size(se) == (5, 5)
end

@testset "centered" begin
    se = strel_diamond((3, 3))
    @test centered(se) === se
    se = strel_box((3, 3))
    @test centered(se) === se
end

module StructuringElements

export strel, strel_type, strel_size, strel_ndims
export SEMask, MorphologySE, SEOffset
export is_symmetric, require_symmetric_strel
export strel_split
export strel_box, SEBox, SEBoxArray
export strel_diamond, SEDiamond, SEDiamondArray
export strel_chain, strel_product, SEChain, SEChainArray

# TODO(johnnychen94): remove ImageCore dependency
using ImageCore: coords_spatial

using OffsetArrays
using OffsetArrays: centered

abstract type MorphologySE{N} end
abstract type MorphologySEArray{N} <: AbstractArray{Bool,N} end

OffsetArrays.centered(A::MorphologySEArray) = A

"""
    SEMask{N}()

A (holy) trait type for representing structuring element as connectivity mask. This
connectivity mask SE is a bool array where `true` indicates that pixel position is connected
to the center point.

```jldoctest; setup=:(using ImageMorphology)
julia> se = centered(Bool[0 1 0; 1 1 1; 0 1 0]) # commonly known as C4 connectivity
3×3 OffsetArray(::Matrix{Bool}, -1:1, -1:1) with eltype Bool with indices -1:1×-1:1:
 0  1  0
 1  1  1
 0  1  0

julia> strel_type(se)
ImageMorphology.StructuringElements.SEMask{2}()
```

See also [`SEOffset`](@ref StructuringElements.SEOffset) for the displacement offset
representation. More details can be found on he documentation page [Structuring
Element](@ref concept_se).
"""
struct SEMask{N} <: MorphologySE{N} end

"""
    SEOffset{N}()

A (holy) trait type for representing structuring element as displacement offsets. This
displacement offsets SE is an array of `CartesianIndex` where each element stores the
displacement offset from the center point.

```jldoctest; setup=:(using ImageMorphology)
julia> se = [CartesianIndex(-1, 0), CartesianIndex(0, -1), CartesianIndex(1, 0), CartesianIndex(0, 1)]
4-element Vector{CartesianIndex{2}}:
 CartesianIndex(-1, 0)
 CartesianIndex(0, -1)
 CartesianIndex(1, 0)
 CartesianIndex(0, 1)

julia> strel_type(se)
ImageMorphology.StructuringElements.SEOffset{2}()
```

See also [`SEMask`](@ref StructuringElements.SEMask) for the connectivity mask representation.
More details can be found on he documentation page [Structuring Element](@ref concept_se).
"""
struct SEOffset{N} <: MorphologySE{N} end

include("strel.jl")
# SE constructors
include("strel_chain.jl")
include("strel_box.jl")
include("strel_diamond.jl")

include("utils.jl")

end

"""
    ThinAlgo

A thinning algorithm.
"""
abstract type ThinAlgo end

"""
    struct GuoAlgo <: ThinAlgo end

The Guo algorithm evaluates three conditions in order to determine which pixels of
the image should be removed.

The three conditions are explained in the page 361 of **Guo, Z., & Hall, R. W. (1989).
Parallel thinning with two-subiteration algorithms. Communications of the ACM, 32(3), 359-373.**
"""
struct GuoAlgo <: ThinAlgo end

"""
    thinning(img::AbstractArray{Bool}; algo::ThinAlgo=GuoAlgo())

Applies a binary blob thinning operation to achieve a skeletization of the input image.

See also: [`GuoAlgo`](@ref)
"""
function thinning(img::AbstractArray{Bool}; algo::ThinAlgo=GuoAlgo())
    # dispatch appropriate implementation
    return thinning_impl(img, algo)
end

function thinning_impl(img::AbstractArray{Bool,2}, algo::GuoAlgo)
    # pad input image
    prev = falses(size(img) .+ 2)
    prev[2:(end - 1), 2:(end - 1)] = img

    # preallocate memory for the mask
    mask = falses(size(prev))

    # perform single iteration
    it = 1
    curr = copy(prev)
    guo_iteration!(mask, curr, isodd(it))
    curr[mask] .= false

    # loop if necessary
    while prev != curr
        it += 1
        prev .= curr
        guo_iteration!(mask, curr, isodd(it))
        curr[mask] .= false
    end

    # unpad result
    return curr[2:(end - 1), 2:(end - 1)]
end

# update mask with Guo iteration on padded image
function guo_iteration!(mask::AbstractArray{Bool,2}, img::AbstractArray{Bool,2}, odd_iteration::Bool)
    # start clean
    mask .= false

    # loop over pixels and update mask
    @inbounds for j in 2:(size(img, 2) - 1), i in 2:(size(img, 1) - 1)
        img[i, j] || continue
        p1 = img[i - 1, j - 1]
        p2 = img[i - 1, j]
        p3 = img[i - 1, j + 1]
        p4 = img[i, j + 1]
        p5 = img[i + 1, j + 1]
        p6 = img[i + 1, j]
        p7 = img[i + 1, j - 1]
        p8 = img[i, j - 1]
        C = (!p2 && (p3 || p4)) + (!p4 && (p5 || p6)) + (!p6 && (p7 || p8)) + (!p8 && (p1 || p2))
        N1 = (p1 || p2) + (p3 || p4) + (p5 || p6) + (p7 || p8)
        N2 = (p2 || p3) + (p4 || p5) + (p6 || p7) + (p8 || p1)
        N = min(N1, N2)
        if odd_iteration
            O = (p2 || p3 || !p5) && p4
        else
            O = (p6 || p7 || !p1) && p8
        end
        if C == 1 && (2 ≤ N ≤ 3) && !O
            mask[i, j] = true
        end
    end
end

@testset "low_leveling" begin
    ref = ([
        2 2 2
        5 5 5
        1 1 1])

    marker = ([
        1 1 1
        3 3 3
        4 4 4])

    expected = ([
        2 2 2
        4 4 4
        1 1 1])
    out = low_leveling(ref, marker)
    @test out == expected

    ref = ([
        5 0 0 0 0 0 5
        0 5 0 0 0 5 0
        0 0 5 5 5 0 0
        0 0 5 5 5 0 0
        0 0 5 5 5 0 0
        0 5 0 0 0 5 0
        5 0 0 0 0 0 5])

    marker = ([
        0 0 0 0 0 0 0
        0 0 0 0 0 0 0
        0 0 6 6 6 0 0
        0 0 6 6 6 0 0
        0 0 6 6 6 0 0
        0 0 0 0 0 0 0
        0 0 0 0 0 0 0])

    expected = ([
        5 0 0 0 0 0 5
        0 5 0 0 0 5 0
        0 0 5 5 5 0 0
        0 0 5 5 5 0 0
        0 0 5 5 5 0 0
        0 5 0 0 0 5 0
        5 0 0 0 0 0 5])
    out = low_leveling(ref, marker)
    @test out == expected

    out = similar(ref)
    out = low_leveling!(out, ref, marker)
    @test out == expected

    msg = "the input structuring element is not for 1 dimensional array, instead it is for 2 dimensional array"
    @test_throws DimensionMismatch(msg) low_leveling(rand(10), rand(10), strel_box((3, 3)))

    se = strel_diamond((7, 7))
    msg = "structuring element with half-size larger than 1 is invalid"
    @test_throws DimensionMismatch(msg) low_leveling(rand(10, 10), rand(10, 10), se)

    se = strel_diamond((3, 3))
    msg = "images should have the same axes"
    @test_throws DimensionMismatch(msg) low_leveling(rand(10, 10), rand(5, 5), se)
end

@testset "high_leveling" begin
    ref = ([
        2 2 2
        5 5 5
        1 1 1])

    marker = ([
        1 1 1
        3 3 3
        4 4 4])

    expected = ([
        2 2 2
        5 5 5
        3 3 3])

    out = high_leveling(ref, marker)
    @test out == expected

    ref = ([
        5 0 0 0 0 0 5
        0 5 0 0 0 5 0
        0 0 5 5 5 0 0
        0 0 5 5 5 0 0
        0 0 5 5 5 0 0
        0 5 0 0 0 5 0
        5 0 0 0 0 0 5])

    marker = ([
        0 0 0 0 0 0 0
        0 0 0 0 0 0 0
        0 0 4 4 4 0 0
        0 0 4 4 4 0 0
        0 0 4 4 4 0 0
        0 0 0 0 0 0 0
        0 0 0 0 0 0 0])

    expected = ([
        5 0 0 0 0 0 5
        0 5 0 0 0 5 0
        0 0 5 5 5 0 0
        0 0 5 5 5 0 0
        0 0 5 5 5 0 0
        0 5 0 0 0 5 0
        5 0 0 0 0 0 5])

    out = high_leveling(ref, marker)
    @test out == expected

    out = similar(marker)
    out = high_leveling!(out, ref, marker)
    @test out == expected

    msg = "the input structuring element is not for 1 dimensional array, instead it is for 2 dimensional array"
    @test_throws DimensionMismatch(msg) high_leveling(rand(10), rand(10), strel_box((3, 3)))

    se = strel_diamond((7, 7))
    msg = "structuring element with half-size larger than 1 is invalid"
    @test_throws DimensionMismatch(msg) high_leveling(rand(10, 10), rand(10, 10), se)

    se = strel_diamond((3, 3))
    msg = "images should have the same axes"
    @test_throws DimensionMismatch(msg) high_leveling(rand(10, 10), rand(5, 5), se)
end

@testset "leveling" begin

    ref = ([1 1 2 1 1 4 4 4 4 4 0 0 0 0 0])
    marker = ([0 0 0 0 0 0 6 6 6 6 6 0 0 2 0])
    expected = ([1 1 1 1 1 4 4 4 4 4 0 0 0 0 0])
    out = leveling(ref, marker)
    @test out == expected

    ref = ([1 1 1 1 5 5 5 5])
    marker = ([4 4 4 4 2 2 2 2])
    expected = ([2 2 2 2 4 4 4 4])
    out = leveling(ref, marker)
    @test out == expected

    out = similar(marker)
    out = leveling!(out, ref, marker)
    @test out == expected
end

using ImageCore.MappedArrays

"""
    hmaxima(img, h; [dims])
    hmaxima(img, h; se)

Compute regional maxima of height h.

For grayscale image `img`, the hmaxima transformation suppresses all regional maxima whose
height is below a given threshold level `h`.

The `dims` keyword is used to specify the dimension to process by constructing the box shape
structuring element [`strel_box(img; dims)`](@ref strel_box). For generic structuring
element, the half-size is expected to be either `0` or `1` along each dimension.

# Examples

```jldoctest; setup=:(using ImageMorphology, ImageMorphology.FixedPointNumbers)
julia> img = UInt8[3 3 3 3 3 3 3 3 3 3; 3 4 4 4 3 3 4 4 4 3; 3 4 5 4 3 3 4 9 4 3; 3 4 4 4 3 3 4 4 4 3; 3 3 3 3 3 3 3 3 3 3]
5×10 Matrix{UInt8}:
 0x03  0x03  0x03  0x03  0x03  0x03  0x03  0x03  0x03  0x03
 0x03  0x04  0x04  0x04  0x03  0x03  0x04  0x04  0x04  0x03
 0x03  0x04  0x05  0x04  0x03  0x03  0x04  0x09  0x04  0x03
 0x03  0x04  0x04  0x04  0x03  0x03  0x04  0x04  0x04  0x03
 0x03  0x03  0x03  0x03  0x03  0x03  0x03  0x03  0x03  0x03

julia> out = hmaxima(reinterpret(N0f8, img), reinterpret(N0f8, UInt8(3)))
5×10 Array{N0f8,2} with eltype N0f8:
 0.012  0.012  0.012  0.012  0.012  0.012  0.012  0.012  0.012  0.012
 0.012  0.012  0.012  0.012  0.012  0.012  0.016  0.016  0.016  0.012
 0.012  0.012  0.012  0.012  0.012  0.012  0.016  0.024  0.016  0.012
 0.012  0.012  0.012  0.012  0.012  0.012  0.016  0.016  0.016  0.012
 0.012  0.012  0.012  0.012  0.012  0.012  0.012  0.012  0.012  0.012

julia> ref_img = UInt8[3 3 3 3 3 3 3 3 3 3; 3 3 3 3 3 3 4 4 4 3; 3 3 3 3 3 3 4 6 4 3; 3 3 3 3 3 3 4 4 4 3; 3 3 3 3 3 3 3 3 3 3]
5×10 Matrix{UInt8}:
 0x03  0x03  0x03  0x03  0x03  0x03  0x03  0x03  0x03  0x03
 0x03  0x03  0x03  0x03  0x03  0x03  0x04  0x04  0x04  0x03
 0x03  0x03  0x03  0x03  0x03  0x03  0x04  0x06  0x04  0x03
 0x03  0x03  0x03  0x03  0x03  0x03  0x04  0x04  0x04  0x03
 0x03  0x03  0x03  0x03  0x03  0x03  0x03  0x03  0x03  0x03

julia> eltype(out) == N0f8
true

julia> out == reinterpret(N0f8, ref_img)
true
```
    
# See also

The inplace version of this function is `hmaxima!`.

# References

- [1] L. Vincent, “Morphological grayscale reconstruction in image analysis: applications
  and efficient algorithms,” IEEE Trans. on Image Process., vol. 2, no. 2, pp. 176–201, Apr.
  1993, doi: 10.1109/83.217222.
- [2] P. Soille, Morphological Image Analysis. Berlin, Heidelberg: Springer Berlin
  Heidelberg, 2004. doi: 10.1007/978-3-662-05088-0.
"""
function hmaxima(img, h, se)
    return _hmaxima!(similar(img), img, h, se)
end

function hmaxima(img, h; dims=coords_spatial(img))
    return _hmaxima!(similar(img), img, h, strel_box(img, dims))
end

function hmaxima!(out, img, h; dims=coords_spatial(img))
    return _hmaxima!(out, img, h, strel_box(img, dims))
end

function _hmaxima!(out, img, h, se)
    # tmp = map(x -> saturating_sub(x, h), img) 
    tmp = mappedarray(x -> saturating_sub(x, h), img)
    return mreconstruct!(dilate, out, reinterpret(eltype(img), tmp), img, se)
end

"""
    hminima(img, h; [dims])
    hminima(img, h; se)

Compute regional minima of depth h.

For grayscale image `img`, the hminima transformation suppresses all regional minima whose
depth is below a given threshold level `h`.

The `dims` keyword is used to specify the dimension to process by constructing the box shape
structuring element [`strel_box(img; dims)`](@ref strel_box). For generic structuring
element, the half-size is expected to be either `0` or `1` along each dimension.

# Examples

```jldoctest; setup=:(using ImageMorphology, ImageMorphology.FixedPointNumbers)
julia> img = UInt8[8 8 8 8 8 8 8 8 8 8; 8 7 7 7 8 8 7 7 7 8; 8 7 6 7 8 8 7 3 7 8; 8 7 7 7 8 8 7 7 7 8; 8 8 8 8 8 8 8 8 8 8]
5×10 Matrix{UInt8}:
 0x08  0x08  0x08  0x08  0x08  0x08  0x08  0x08  0x08  0x08
 0x08  0x07  0x07  0x07  0x08  0x08  0x07  0x07  0x07  0x08
 0x08  0x07  0x06  0x07  0x08  0x08  0x07  0x03  0x07  0x08
 0x08  0x07  0x07  0x07  0x08  0x08  0x07  0x07  0x07  0x08
 0x08  0x08  0x08  0x08  0x08  0x08  0x08  0x08  0x08  0x08

julia> out = hminima(reinterpret(N0f8, img), reinterpret(N0f8, UInt8(3)))
5×10 Array{N0f8,2} with eltype N0f8:
 0.031  0.031  0.031  0.031  0.031  0.031  0.031  0.031  0.031  0.031
 0.031  0.031  0.031  0.031  0.031  0.031  0.027  0.027  0.027  0.031
 0.031  0.031  0.031  0.031  0.031  0.031  0.027  0.024  0.027  0.031
 0.031  0.031  0.031  0.031  0.031  0.031  0.027  0.027  0.027  0.031
 0.031  0.031  0.031  0.031  0.031  0.031  0.031  0.031  0.031  0.031

julia> ref_img = UInt8[8 8 8 8 8 8 8 8 8 8; 8 8 8 8 8 8 7 7 7 8; 8 8 8 8 8 8 7 6 7 8; 8 8 8 8 8 8 7 7 7 8; 8 8 8 8 8 8 8 8 8 8]
5×10 Matrix{UInt8}:
 0x08  0x08  0x08  0x08  0x08  0x08  0x08  0x08  0x08  0x08
 0x08  0x08  0x08  0x08  0x08  0x08  0x07  0x07  0x07  0x08
 0x08  0x08  0x08  0x08  0x08  0x08  0x07  0x06  0x07  0x08
 0x08  0x08  0x08  0x08  0x08  0x08  0x07  0x07  0x07  0x08
 0x08  0x08  0x08  0x08  0x08  0x08  0x08  0x08  0x08  0x08

julia> eltype(out) == N0f8
true

julia> out == reinterpret(N0f8, ref_img)
true

# See also

The inplace version of this function is `hminima!`.

# References

- [1] L. Vincent, “Morphological grayscale reconstruction in image analysis: applications
  and efficient algorithms,” IEEE Trans. on Image Process., vol. 2, no. 2, pp. 176–201, Apr.
  1993, doi: 10.1109/83.217222.
- [2] P. Soille, Morphological Image Analysis. Berlin, Heidelberg: Springer Berlin
  Heidelberg, 2004. doi: 10.1007/978-3-662-05088-0.
"""
function hminima(img, h, se)
    return _hminima!(similar(img), img, h, se)
end

function hminima(img, h; dims=coords_spatial(img))
    return _hminima!(similar(img), img, h, strel_box(img, dims))
end

function hminima!(out, img, h; dims=coords_spatial(img))
    return _hminima!(out, img, h, strel_box(img, dims))
end

function _hminima!(out, img, h, se)
    # tmp = map(x -> saturating_add(x, h), img)
    tmp = mappedarray(x -> saturating_add(x, h), img)
    return mreconstruct!(erode, out, reinterpret(eltype(img), tmp), img, se)
end

"""
    regional_maxima(img; [dims])
    regional_maxima(img; se)

Determines all regional maxima of the `image`.

For grayscale image `img`, A regional maximum is defined as the connected set of pixels that have the
same value, which is greater than the values of all pixels in direct neighborhood of the set.

The `dims` keyword is used to specify the dimension to process by constructing the box shape
structuring element [`strel_box(img; dims)`](@ref strel_box). For generic structuring
element, the half-size is expected to be either `0` or `1` along each dimension.

#Note
This implementation is faster than maxtree local_maxima approach if maxtree not precomputed

# See also

The inplace version of this function is `regional_maxima!`.

# References

- [1] L. Vincent, “Morphological grayscale reconstruction in image analysis: applications
    and efficient algorithms,” IEEE Trans. on Image Process., vol. 2, no. 2, pp. 176–201, Apr.
    1993, doi: 10.1109/83.217222.
- [2] P. Soille, Morphological Image Analysis. Berlin, Heidelberg: Springer Berlin
    Heidelberg, 2004. doi: 10.1007/978-3-662-05088-0.
"""
function regional_maxima(img, se)
    return _regional_maxima!(similar(img, Bool), img, se)
end

function regional_maxima(img; dims=coords_spatial(img))
    return _regional_maxima!(similar(img, Bool), img, strel_box(img, dims))
end

function regional_maxima!(out, img; dims=coords_spatial(img))
    return _regional_maxima!(out, img, strel_box(img, dims))
end

function _regional_maxima!(out, img, se)
    #print(reinterpret(eltype(img), (Unsigned)1))
    h = reinterpret(eltype(img), (UInt8)(1))
    out = ((img - hmaxima(img, h, se))) .> 0.0
    return out
end


"""
    regional_minima(img; [dims])
    regional_minima(img; se)

Deetermines all regional minimum of the `image`.

For grayscale image `img`, A regional minimum is defined as the connected set of pixels that have the
same value, which is lower than the values of all pixels in direct neighborhood of the set.

The `dims` keyword is used to specify the dimension to process by constructing the box shape
structuring element [`strel_box(img; dims)`](@ref strel_box). For generic structuring
element, the half-size is expected to be either `0` or `1` along each dimension.

#Note
This implementation is faster than maxtree local_minima approach if maxtree not precomputed

# See also

The inplace version of this function is `regional_minima!`.

# References

- [1] L. Vincent, “Morphological grayscale reconstruction in image analysis: applications
    and efficient algorithms,” IEEE Trans. on Image Process., vol. 2, no. 2, pp. 176–201, Apr.
    1993, doi: 10.1109/83.217222.
- [2] P. Soille, Morphological Image Analysis. Berlin, Heidelberg: Springer Berlin
    Heidelberg, 2004. doi: 10.1007/978-3-662-05088-0.
"""
function regional_minima(img, se)
    return _regional_minima!(similar(img, Bool), img, se)
end

function regional_minima(img; dims=coords_spatial(img))
    return _regional_minima!(similar(img, Bool), img, strel_box(img, dims))
end

function regional_minima!(out, img; dims=coords_spatial(img))
    return _regional_minima!(out, img, strel_box(img, dims))
end

function _regional_minima!(out, img, se)
    h = reinterpret(eltype(img), (UInt8)(1))
    out = ((hminima(img, h, se) - img)) .> 0.0
    return out
end

"""
    filled_img = imfill(img::AbstractArray{Bool}, interval; dims=coords_spatial(img))
    filled_img = imfill(img::AbstractArray{Bool}, interval, connectivity)

Connected components of an image is found using flood-fill algorithm and returns a copy of
the original image after filling objects that falls in the range of interval.
For filling objects, represent the holes (part to be filled) with `true` in your array.

Parameters:
-  img            = Input image (Boolean array type)
-  interval       = objects of size (# of voxels) in this range will be filled with `false`
-  connectivity   = a Boolean-valued connectivity pattern, see [`label_components`](@ref).

# Examples

```jldoctest; setup=:(using ImageMorphology)
julia> img = Bool[0 0 1 1 0 0;
                  0 1 0 1 1 0;
                  0 0 1 1 0 0]
3×6 Matrix{Bool}:
 0  0  1  1  0  0
 0  1  0  1  1  0
 0  0  1  1  0  0

julia> imfill(.!(img), 0:3)
3×6 BitMatrix:
 1  1  0  0  1  1
 1  0  0  0  0  1
 1  1  0  0  1  1

julia> .!(ans)
3×6 BitMatrix:
 0  0  1  1  0  0
 0  1  1  1  1  0
 0  0  1  1  0  0
```
"""
function imfill(img::AbstractArray{Bool}, interval::Tuple{Real,Real}, connectivity::AbstractArray{Bool})
    return _imfill(img, interval, label_components(img, connectivity))
end
function imfill(img::AbstractArray{Bool}, interval::Tuple{Real,Real}; dims=coords_spatial(img))
    return _imfill(img, interval, label_components(img; dims=dims))
end
function imfill(img::AbstractArray{Bool}, interval, args...; kwargs...)
    return imfill(img, (minimum(interval)::Real, maximum(interval)::Real), args...; kwargs...)
end

function _imfill(img::AbstractArray{Bool}, interval::Tuple{Real,Real}, labels)
    if interval[1] > interval[2] || interval[1] < 0 || interval[2] < 0
        msg = "Interval must be non-negative and in format (min_range,max_range)"
        throw(DomainError(interval, msg))
    end
    count_labels = component_lengths(labels)

    new_img = similar(img)
    for ind in eachindex(img)
        if img[ind] == true && interval[1] <= count_labels[labels[ind]] <= interval[2]
            new_img[ind] = false
        else
            new_img[ind] = img[ind]
        end
    end

    return new_img
end

#! format: off
@deprecate imfill(img::AbstractArray{Bool}, interval::Tuple{Real,Real}, dims::Union{Dims, AbstractVector{Int}}) imfill(img, interval; dims=dims)

@deprecate dilate!(img; kwargs...) dilate!(img, copy(img); kwargs...)
@deprecate erode!(img; kwargs...) erode!(img, copy(img); kwargs...)

@deprecate opening!(img; kwargs...) opening!(img, copy(img), similar(img); kwargs...)
@deprecate closing!(img; kwargs...) closing!(img, copy(img), similar(img); kwargs...)

Base.@deprecate_binding morphogradient mgradient
Base.@deprecate_binding morpholaplace mlaplacian

@deprecate extremefilt!(A, select; kwargs...) extreme_filter!(select, A, copy(A); kwargs...)

import .FeatureTransform: feature_transform
@deprecate feature_transform(img, weights; kwargs...) feature_transform(img; weights=weights, kwargs...)

@testset "Convex Hull" begin
    A = zeros(50, 30)
    A = convert(Array{Bool}, A)
    A[25, 1] = 1
    A[1, 10] = 1
    A[10, 10] = 1
    A[10, 30] = 1
    A[40, 30] = 1
    A[40, 10] = 1
    A[50, 10] = 1
    B = @inferred convexhull(A)
    C = CartesianIndex{}[]
    push!(C, CartesianIndex{}(25, 1))
    push!(C, CartesianIndex{}(1, 10))
    push!(C, CartesianIndex{}(10, 30))
    push!(C, CartesianIndex{}(40, 30))
    push!(C, CartesianIndex{}(50, 10))
    @test typeof(B) == Array{CartesianIndex{2},1}
    @test sort(B) == sort(C)

    A = [
        0.0,
        0.0,
        1.0,
        0.0,
        0.0,
        0.0,
        1.0,
        1.0,
        0.0,
        0.0,
        1.0,
        0.0,
        0.0,
        1.0,
        1.0,
        0.0,
        0.0,
        0.0,
        0.0,
        0.0,
        0.0,
        0.0,
        1.0,
        0.0,
        0.0,
    ]
    A = reshape(A, 5, 5)
    A = convert(Array{Bool}, A)
    B = B = @inferred convexhull(A)
    C = CartesianIndex{}[]
    push!(C, CartesianIndex{}(1, 3))
    push!(C, CartesianIndex{}(3, 1))
    push!(C, CartesianIndex{}(3, 5))
    push!(C, CartesianIndex{}(5, 3))
    @test typeof(B) == Array{CartesianIndex{2},1}
    @test sort(B) == sort(C)
end

const MAX_OR_MIN = Union{typeof(max),typeof(min)}

"""
    extreme_filter(f, A; r=1, [dims]) -> out
    extreme_filter(f, A, Ω) -> out

Filter the array `A` using select function `f(x, y)` for each Ω-neighborhood. The name
"extreme" comes from the fact that typical select function `f` choice is `min` and `max`.

For each pixel `p` in `A`, the select function `f` is applied to its Ω-neighborhood
iteratively in a `f(...(f(f(A[p], A[p+Ω[1]]), A[p+Ω[2]]), ...)` manner. For instance, in the
1-dimensional case, `out[p] = f(f(A[p], A[p-1]), A[p+1])` for each `p` is the default
behavior.

The Ω-neighborhood is defined by the `dims` or `Ω` argument. The `r` and `dims` keywords
specifies the box shape neighborhood `Ω` using [`strel_box`](@ref). The `Ω` is also known as
structuring element (SE), it can be either displacement offsets or bool array mask, please
refer to [`strel`](@ref) for more details.

# Examples

```jldoctest extreme_filter; setup=:(using ImageMorphology)
julia> M = [4 6 5 3 4; 8 6 9 4 8; 7 8 4 9 6; 6 2 2 1 7; 1 6 5 2 6]
5×5 Matrix{$Int}:
 4  6  5  3  4
 8  6  9  4  8
 7  8  4  9  6
 6  2  2  1  7
 1  6  5  2  6

julia> extreme_filter(max, M) # max-filter using 4 direct neighbors along both dimensions
5×5 Matrix{$Int}:
 8  9  9  9  8
 8  9  9  9  9
 8  9  9  9  9
 8  8  9  9  9
 6  6  6  7  7

julia> extreme_filter(max, M; dims=1) # max-filter along the first dimension (column)
5×5 Matrix{$Int}:
 8  6  9  4  8
 8  8  9  9  8
 8  8  9  9  8
 7  8  5  9  7
 6  6  5  2  7
```

`Ω` can be either an `AbstractArray{Bool}` mask array with `true` element indicating
connectivity, or a `AbstractArray{<:CartesianIndex}` array with each element indicating the
displacement offset to its center element.

```jldoctest extreme_filter
julia> Ω_mask = centered(Bool[1 1 0; 1 1 0; 1 0 0]) # custom neighborhood in mask format
3×3 OffsetArray(::Matrix{Bool}, -1:1, -1:1) with eltype Bool with indices -1:1×-1:1:
 1  1  0
 1  1  0
 1  0  0

julia> out = extreme_filter(max, M, Ω_mask)
5×5 Matrix{$Int}:
 4  8  6  9  4
 8  8  9  9  9
 8  8  9  9  9
 7  8  8  9  9
 6  6  6  5  7

julia> Ω_offsets = strel(CartesianIndex, Ω_mask) # custom neighborhood as displacement offset
4-element Vector{CartesianIndex{2}}:
 CartesianIndex(-1, -1)
 CartesianIndex(0, -1)
 CartesianIndex(1, -1)
 CartesianIndex(-1, 0)

julia> out == extreme_filter(max, M, Ω_offsets) # both versions work equivalently
true
```

See also the in-place version [`extreme_filter!`](@ref). Another function in ImageFiltering
package `ImageFiltering.mapwindow` provides similar functionality.
"""
extreme_filter(f, A; r=nothing, dims=coords_spatial(A)) = extreme_filter(f, A, strel_box(A, dims; r))
extreme_filter(f, A, Ω::AbstractArray) = extreme_filter!(f, similar(A), A, Ω)

"""
    extreme_filter!(f, out, A; [r], [dims])
    extreme_filter!(f, out, A, Ω)

The in-place version of [`extreme_filter`](@ref) where `out` is the output array that gets
modified.
"""
extreme_filter!(f, out, A; r=nothing, dims=coords_spatial(A)) = extreme_filter!(f, out, A, strel_box(A, dims; r))
function extreme_filter!(f, out, A, Ω)
    axes(out) == axes(A) || throw(DimensionMismatch("axes(out) must match axes(A)"))
    require_select_function(f, eltype(A))
    return _extreme_filter!(strel_type(Ω), f, out, A, Ω)
end

_extreme_filter!(::MorphologySE, f, out, A, Ω) = _extreme_filter_generic!(f, out, A, Ω)
_extreme_filter!(::SEDiamond, f, out, A, Ω) = _extreme_filter_diamond!(f, out, A, Ω)
function _extreme_filter!(::MorphologySE, f::MAX_OR_MIN, out, A::AbstractArray{T}, Ω) where {T<:Union{Gray{Bool},Bool}}
    # NOTE(johnnychen94): empirical choice based on benchmark results (intel i9-12900k)
    true_ratio = gray(sum(A) / length(A)) # this usually takes <2% of the time but gives a pretty good hint to do the decision
    true_ratio == 1 && (out .= true; return out)
    true_ratio == 0 && (out .= false; return out)
    use_bool = prod(strel_size(Ω)) > 9 || (f === max && true_ratio > 0.8) || (f === min && true_ratio < 0.2)
    if use_bool
        return _extreme_filter_bool!(f, out, A, Ω)
    else
        return _extreme_filter_generic!(f, out, A, Ω)
    end
end
function _extreme_filter!(::SEDiamond, f::MAX_OR_MIN, out, A::AbstractArray{T}, Ω) where {T<:Union{Gray{Bool},Bool}}
    rΩ = strel_size(Ω) .÷ 2
    if ndims(A) == 2 && all(rΩ[1] .== rΩ)
        # super fast implementation and wins in all cases
        return _extreme_filter_diamond!(f, out, A, Ω)
    end

    # NOTE(johnnychen94): empirical choice based on benchmark results (intel i9-12900k)
    true_ratio = gray(sum(A) / length(A)) # this usually takes <2% of the time but gives a pretty good hint to do the decision
    true_ratio == 1 && (out .= true; return out)
    true_ratio == 0 && (out .= false; return out)
    use_bool = (f === max && true_ratio > 0.4) || (f === min && true_ratio < 0.6)
    if use_bool
        return _extreme_filter_bool!(f, out, A, Ω)
    else
        return _extreme_filter_diamond!(f, out, A, Ω)
    end
end
function _extreme_filter!(::SEBox, f::MAX_OR_MIN, out, A::AbstractArray{T}, Ω) where {T<:Union{Gray{Bool},Bool}}
    rΩ = strel_size(Ω) .÷ 2
    if ndims(A) == 2 && all(rΩ[1] .== rΩ)
        # super fast implementation and wins in all cases
        return _extreme_filter_box!(f, out, A, Ω)
    end

    return _extreme_filter_bool!(f, out, A, Ω)
end


###
# Implementation details
###

function _extreme_filter_generic!(f, out, A, Ω)
    @debug "call the generic `extreme_filter` implementation" fname = _extreme_filter_generic!
    Ω = strel(CartesianIndex, Ω)
    δ = CartesianIndex(strel_size(Ω) .÷ 2)

    R = CartesianIndices(A)
    R_inner = (first(R) + δ):(last(R) - δ)

    # NOTE(johnnychen94): delibrately duplicate the kernel codes here for inner loop and
    # boundary loop, because keeping the big function body allows Julia to do further
    # optimization and thus significantly improves the overall performance.
    @inbounds for p in R_inner
        # for interior points, boundary check is unnecessary
        s = A[p]
        for o in Ω
            v = A[p + o]
            s = f(s, v)
        end
        out[p] = s
    end
    @inbounds for p in EdgeIterator(R, R_inner)
        # for edge points, skip if the offset exceeds the boundary
        s = A[p]
        for o in Ω
            q = p + o
            checkbounds(Bool, A, q) || continue
            s = f(s, A[q])
        end
        out[p] = s
    end
    return out
end

# optimized implementation for SEDiamond -- a typical case of separable filter
function _extreme_filter_diamond!(f, out, A, Ω::SEDiamondArray{N}) where {N}
    rΩ = strel_size(Ω) .÷ 2
    if N == 2 && f isa MAX_OR_MIN && all(rΩ[1] .== rΩ)
        iter = rΩ[1]
        return _extreme_filter_diamond_2D!(f, out, A, iter)
    else
        return _extreme_filter_diamond_generic!(f, out, A, Ω)
    end
end

function _extreme_filter_diamond_generic!(f, out, A, Ω::SEDiamondArray)
    @debug "call the optimized `extreme_filter` implementation for SEDiamond SE" fname = _extreme_filter_diamond!
    rΩ = strel_size(Ω) .÷ 2
    r = maximum(rΩ)

    # To avoid the result affected by loop order, we need two arrays
    src = (out === A) || (r > 1) ? copy(A) : A
    out .= src

    # applying radius=r filter is equivalent to applying radius=1 filter r times
    for i in 1:r
        Ω = strel_diamond(A, Ω.dims)
        rΩ = strel_size(Ω) .÷ 2
        inds = axes(A)
        for d in 1:ndims(A)
            # separately apply to each dimension
            if size(out, d) == 1 || rΩ[d] == 0
                continue
            end
            Rpre = CartesianIndices(inds[1:(d - 1)])
            Rpost = CartesianIndices(inds[(d + 1):end])
            _extreme_filter_C2!(f, out, src, Rpre, inds[d], Rpost)
        end

        if r > 1 && i < r
            src .= out
        end
    end
    return out
end

# fast version for C2 connectivity along each dimension
@noinline function _extreme_filter_C2!(f, dst, src, Rpre, inds, Rpost)
    # manually unroll the loop for r=1 case
    # for r>1 case, it is equivalently to apply r times
    @inbounds for Ipost in Rpost, Ipre in Rpre
        # loop inner region
        for i in (first(inds) + 1):(last(inds) - 1)
            a1 = src[Ipre, i - 1, Ipost]
            a2 = dst[Ipre, i, Ipost]
            a3 = src[Ipre, i + 1, Ipost]
            dst[Ipre, i, Ipost] = f(f(a1, a2), a3)
        end
        # process two edge points
        i = first(inds)
        a2 = dst[Ipre, i, Ipost]
        a3 = src[Ipre, i + 1, Ipost]
        dst[Ipre, i, Ipost] = f(a2, a3)

        i = last(inds)
        a1 = src[Ipre, i - 1, Ipost]
        a2 = dst[Ipre, i, Ipost]
        dst[Ipre, i, Ipost] = f(a1, a2)
    end
    return dst
end

# Shift vector of size N up or down by 1 accorded to dir, pad with v
const SafeArrayTypes{T,N,NA} = Union{Array{T,N},Base.SubArray{T,N,Array{T,NA}}}
function _unsafe_padded_copyto!(dest::SafeArrayTypes{T,1}, src::SafeArrayTypes{T,1}, dir, N, v) where {T}
    # ptr level optimized implementation for Real types
    # short-circuit all check so unsafe
    if dir
        unsafe_store!(pointer(dest), v)
        unsafe_copyto!(pointer(dest, 2), pointer(src, 1), N - 1)
    else
        unsafe_copyto!(pointer(dest, 1), pointer(src, 2), N - 1)
        unsafe_store!(pointer(dest), v, N)
    end
    return dest
end
function _unsafe_padded_copyto!(dest::AbstractVector, src::AbstractVector, dir, N, v)
    if dir
        dest[begin] = v
        copyto!(dest, 2, src, 1, N - 1)
    else
        dest[end] = v
        copyto!(dest, 1, src, 2, N - 1)
    end
    return dest
end

# ptr level optimized implementation for Real types
# short-circuit all check
# call LoopVectorization directly
function _unsafe_shift_arith!(
    f::MAX_OR_MIN,
    out::AbstractVector,
    tmp::AbstractVector,
    tmp2::AbstractVector,
    A::AbstractVector,
) #tmp external to reuse external allocation
    if f === min
        padd = typemax(eltype(out))
    else
        padd = typemin(eltype(out))
    end
    N = length(out)
    #in  src  = [1,2,3,4], padd, N=4
    #out tmp  = [padd,1,2,3]
    #out tmp2 = [1,2,3,padd]
    _unsafe_padded_copyto!(tmp, A, true, N, padd)
    _unsafe_padded_copyto!(tmp2, A, false, N, padd)
    @turbo warn_check_args = false for i in eachindex(out, A, tmp, tmp2)
        out[i] = f(f(A[i], tmp[i]), tmp2[i])
    end
    return out
end

@static if Sys.WORD_SIZE == 64
    # optimized `extreme_filter` implementation for SEDiamond SE and 2D images
    # Similar approach could be found in
    # Žlaus, Danijel & Mongus, Domen. (2018). In-place SIMD Accelerated Mathematical Morphology. 76-79. 10.1145/3206157.3206176.
    # see https://www.researchgate.net/publication/325480366_In-place_SIMD_Accelerated_Mathematical_Morphology
    function _extreme_filter_diamond_2D!(f::MAX_OR_MIN, out::AbstractArray{T}, A, iter) where {T}
        @debug "call the AVX-enabled `extreme_filter` implementation for 2D SEDiamond" fname = _extreme_filter_diamond_2D!
        out_actual = out

        out = OffsetArrays.no_offset_view(out)
        A = OffsetArrays.no_offset_view(A)

        src = if (out === A) || (iter > 1)
            # To avoid the result affected by loop order, we need two arrays
            T.(A)
        elseif eltype(A) != T
            # To avoid incorrect result, we need to ensure the eltypes are the same
            # https://github.com/JuliaImages/ImageMorphology.jl/issues/104
            T.(A)
        else
            A
        end
        # NOTE(johnnychen94): we don't need to do `out .= src` here because it is write-only;
        # all values are generated from the read-only `src`.

        # LoopVectorization currently doesn't understand Gray and N0f8 types, thus we
        # reinterpret to its raw data type UInt8
        src = rawview(channelview(src))
        out = rawview(channelview(out))

        # creating temporaries
        ySize, xSize = size(A)
        tmp = similar(out, eltype(out), ySize)
        tmp2 = similar(tmp)
        tmp3 = similar(tmp)

        # applying radius=r filter is equivalent to applying radius=1 filter r times
        for i in 1:iter
            # NOTE(johnnychen94): this implementation is essentially equivalent to the
            # following loop. Here we buffer the getindex to further improve the performance
            # by explicitly introducing SIMD buffers.

            # for y in 2:(size(src, 2) - 1), x in 2:(size(src, 1) - 1)
            #     tmp = f(f(src[x, y], src[x - 1, y]), src[x + 1, y])
            #     out[x, y] = f(f(tmp, src[x, y - 1]), src[x, y + 1])
            # end

            #compute first edge column
            #translate to clipped connection, x neighborhood of interest, ? neighborhood we don't care, . center
            # x ?
            # . x
            # x ?
            viewprevious = view(src, :, 1)
            # dilate/erode col 1
            _unsafe_shift_arith!(f, tmp2, tmp, tmp3, viewprevious)
            viewnext = view(src, :, 2)
            viewout = view(out, :, 1)
            # inf/sup between dilate/erode col 1 0 and col 2
            LoopVectorization.vmap!(f, viewout, viewnext, tmp2)
            #next->current
            viewcurrent = view(src, :, 2)
            for c in 3:xSize
                # viewprevious c-2
                # viewcurrent  c-1
                # viewnext     c
                # ? x ?
                # x . x
                # ? x ?
                viewout = view(out, :, c - 1)
                viewnext = view(src, :, c)
                # dilate(x-1)/erode(x-1)
                _unsafe_shift_arith!(f, tmp2, tmp, tmp3, viewcurrent)
                @turbo warn_check_args = false for i in eachindex(viewout, viewprevious, tmp2)
                    #sup(x-2,dilate(x-1)),inf(x-2,erode(x-1))
                    #sup(sup(x-2,dilate(x-1),x) || inf(inf(x-2,erode(x-1),x)
                    viewout[i] = f(f(viewprevious[i], tmp2[i]), viewnext[i])
                end
                #current->previous
                viewprevious = view(src, :, c - 1)
                #next->current
                viewcurrent = view(src, :, c)
            end
            #end last column
            #translate to clipped connection
            # ? x
            # x .
            # ? x
            # dilate/erode col x
            viewout = view(out, :, xSize)
            _unsafe_shift_arith!(f, tmp2, tmp, tmp3, viewcurrent)
            LoopVectorization.vmap!(f, viewout, tmp2, viewprevious)
            if iter > 1 && i < iter
                src .= out
            end
        end

        return out_actual
    end
else
    # FIXME(johnnychen94): unknown segfault happens to 32bit machine
    # https://github.com/JuliaImages/ImageMorphology.jl/pull/106
    function _extreme_filter_diamond_2D!(f::MAX_OR_MIN, out::AbstractArray, A, iter)
        return _extreme_filter_diamond_generic!(f, out, A, strel_diamond(A; r=iter))
    end
end

function _extreme_filter_box!(f, out, A, Ω::SEBoxArray{N}) where {N}
    rΩ = strel_size(Ω) .÷ 2
    if N == 2 && f isa MAX_OR_MIN && all(rΩ[1] .== rΩ)
        iter = rΩ[1]
        return _extreme_filter_box_2D!(f, out, A, iter)
    else
        return _extreme_filter_generic!(f, out, A, Ω)
    end
end

@static if Sys.WORD_SIZE == 64
    # optimized `extreme_filter` implementation for SEBox SE and 2D images
    # Similar approach could be found in
    # Žlaus, Danijel & Mongus, Domen. (2018). In-place SIMD Accelerated Mathematical Morphology. 76-79. 10.1145/3206157.3206176.
    # see https://www.researchgate.net/publication/325480366_In-place_SIMD_Accelerated_Mathematical_Morphology
    function _extreme_filter_box_2D!(f::MAX_OR_MIN, out::AbstractArray{T}, A, iter) where {T}
        @debug "call the AVX-enabled `extreme_filter` implementation for 2D SEBox" fname = _extreme_filter_box_2D!
        out_actual = out

        out = OffsetArrays.no_offset_view(out)
        A = OffsetArrays.no_offset_view(A)

        src = if (out === A) || (iter > 1)
            # To avoid the result affected by loop order, we need two arrays
            T.(A)
        elseif eltype(A) != T
            # To avoid incorrect result, we need to ensure the eltypes are the same
            # https://github.com/JuliaImages/ImageMorphology.jl/issues/104
            T.(A)
        else
            A
        end
        # NOTE(johnnychen94): we don't need to do `out .= src` here because it is write-only;
        # all values are generated from the read-only `src`.

        # LoopVectorization currently doesn't understand Gray and N0f8 types, thus we
        # reinterpret to its raw data type UInt8
        src = rawview(channelview(src))
        out = rawview(channelview(out))

        #creating temporaries
        ySize, xSize = size(A)
        tmp = similar(out, eltype(out), ySize)
        tmp2 = similar(tmp)
        tmp3 = similar(tmp)
        tmp4 = similar(tmp)
        tmp5 = similar(tmp)

        # applying radius=r filter is equivalent to applying radius=1 filter r times
        for i in 1:iter
            #compute first edge column
            #translate to clipped connection, x neighborhood of interest, ? neighborhood we don't care, . center
            # x x
            # . x
            # x x
            viewprevious = view(src, :, 1)
            # dilate/erode col 1
            _unsafe_shift_arith!(f, tmp2, tmp, tmp5, viewprevious)
            viewnext = view(src, :, 2)
            viewout = view(out, :, 1)
            # dilate/erode col 2
            _unsafe_shift_arith!(f, tmp3, tmp, tmp5, viewnext)
            #sup(dilate col 1,dilate col 0) or inf(erode col 1,erode col 0)
            LoopVectorization.vmap!(f, viewout, tmp3, tmp2)
            #next->current
            viewcurrent = view(src, :, 2)
            for c in 3:xSize
                # Invariant of the loop
                # temp2 contains dilation/erosion of previous col x-2
                # temp3 contains dilation/erosion of current col x-1
                # temp4 contains dilation/erosion of next col ie x
                # viewprevious c-2
                # viewcurrent  c-1
                # viewnext     c
                # x x x
                # x . x
                # x x x
                viewout = view(out, :, c - 1)
                viewnext = view(src, :, c)
                # dilate(x)/erode(x)
                _unsafe_shift_arith!(f, tmp4, tmp, tmp5, viewnext)
                @turbo warn_check_args = false for i in eachindex(viewout, tmp4, tmp3, tmp2)
                    #sup(x-2,dilate(x-1)),inf(x-2,erode(x-1))
                    #sup(dilate(x-2),dilate(x-1),dilate(y)) or inf(erode(x-2),erode(x-1),erode(x))
                    viewout[i] = f(f(tmp2[i], tmp3[i]), tmp4[i])
                end
                #swap
                tmp4, tmp3 = tmp3, tmp4
                tmp4, tmp2 = tmp2, tmp4
            end
            #end last column
            #translate to clipped connection
            # x x
            # x .
            # x x
            # dilate/erode col x
            viewout = view(out, :, xSize)
            _unsafe_shift_arith!(f, tmp4, tmp, tmp5, viewcurrent)
            LoopVectorization.vmap!(f, viewout, tmp2, tmp3)
            if iter > 1 && i < iter
                src .= out
            end
        end

        return out_actual
    end
else
    # FIXME(johnnychen94): unknown segfault happens to 32bit machine
    # https://github.com/JuliaImages/ImageMorphology.jl/pull/106
    function _extreme_filter_box_2D!(f::MAX_OR_MIN, out::AbstractArray, A, iter)
        return _extreme_filter_generic!(f, out, A, strel_box(A; r=iter))
    end
end

# optimized implementation for Bool inputs with max/min select function
# 1) use &&, || instead of max, min
# 2) short-circuit the result to avoid unnecessary indexing and computation
function _extreme_filter_bool!(f, out, A::AbstractArray{Bool}, Ω)
    @debug "call the optimized max/min `extreme_filter` implementation for boolean array" fname = _extreme_filter_bool!
    Ω = strel(CartesianIndex, Ω)
    δ = CartesianIndex(strel_size(Ω) .÷ 2)

    R = CartesianIndices(A)
    R_inner = (first(R) + δ):(last(R) - δ)

    select = _fast_select(f)
    @inbounds for p in R_inner
        out[p] = select(A, p, Ω)
    end
    for p in EdgeIterator(R, R_inner)
        out[p] = select(A, p, Ω)
    end
    return out
end
function _extreme_filter_bool!(f, out, A::AbstractArray{Gray{Bool}}, Ω)
    return _extreme_filter_bool!(f, out, reinterpret(Bool, A), Ω)
end
_fast_select(::typeof(max)) = _maximum_fast
_fast_select(::typeof(min)) = _minimum_fast
Base.@propagate_inbounds function _maximum_fast(A::AbstractArray{Bool}, p, Ω)
    rst = A[p]
    for o in Ω
        # the complicated control flow ruins the SIMD and thus for small Ω, the performance
        # will be worse
        q = p + o
        @boundscheck checkbounds(Bool, A, q) || continue
        x = A[q]
        x && return true
        rst = rst || x
    end
    return rst
end
Base.@propagate_inbounds function _minimum_fast(A::AbstractArray{Bool}, p, Ω)
    rst = A[p]
    for o in Ω
        # the complicated control flow ruins the SIMD and thus for small Ω, the performance
        # will be worse
        q = p + o
        @boundscheck checkbounds(Bool, A, q) || continue
        x = A[q]
        x || return false
        rst = rst && x
    end
    return rst
end

bothat_ref(img, dims, r) = bothat_ref(img, strel_box(img, dims; r))
bothat_ref(img, se) = float.(closing(img, se)) - float.(img)

@testset "bothat" begin
    test_ranges = [Bool, 1:10, Float64, Gray{N0f8}, Gray{Float64}]
    for T in test_ranges
        for N in (1, 2, 3)
            sz = ntuple(_ -> 32, N)
            img = rand(T, sz...)

            out = bothat(img)
            @test out == bothat(img, strel_box(img, ntuple(identity, N); r=1))
            @test out == bothat_ref(img, ntuple(identity, N), 1)

            @test bothat(img; dims=(1,), r=2) == bothat_ref(img, (1,), 2)

            se = centered(rand(Bool, ntuple(_ -> 3, N)))
            @test bothat(img, se) == bothat_ref(img, se)
        end
    end

    img = rand(1:5, 7, 7)
    out = similar(img)
    bothat!(out, img, similar(img))
    @test out == bothat(img)

    img = rand(RGB, 7, 7)
    @test_throws ArgumentError("color image is not supported") bothat(img)
end

# ---
# title: "`extreme_filter`"
# id: op_extreme_filter
# cover: assets/extreme_filter.png
# ---

# The `extreme_filter` function is the core operation in ImageMorphology. Many other
# morphological operations such as [`dilate`](@ref) and [`erode`](@ref) are direct usages of
# it. The cover image shows a pixel jitter using random select function.

# This page gives an overview of the `extreme_filter` function as a tutorial. It might not
# exactly show every details. For a comprehensive and more accurate documentation, please
# check the [`extreme_filter`](@ref) page.

using ImageMorphology
using ImageFiltering
using TestImages
using ImageBase
using ImageShow
using Random #hide
Random.seed!(1234); #hide

# ## Definition
#
# Below is the basic interface for this function
#
# ```julia
# extreme_filter(f, A, se)
# ```
#
# For each pixel `p` in A, a select function `f(x, y)` will be applied iteratively to
# its neighborhood. The neighborhood is defined by the structuring element `se`. In plain
# Julia codes, this is as simple as:
#
# ```julia
# # For illustration purposes only; you should use `extreme_filter` in practice
# function simple_extreme_filter(f, A, se)
#     se = strel(CartesianIndex, se)
#     R = CartesianIndices(A)
#     for p in R
#         x = A[p]
#         for o in se
#             q = p + o
#             q in R || continue
#             x = f(x, A[q])
#         end
#         A[p] = x
#     end
# end
# ```
#
# !!! tip "structuring element"
#     Structuring element defines the shape of each pixel's neighborhood. If you haven't
#     used [`strel`](@ref) before or don't know what `se` means. It is recommended to read
#     the concept introduction page "[Structuring element](@ref concept_se)" first.

# The name "extreme" comes from the fact that `max` and `min` are typical examples of the
# select function `f`.

# ## Examples

# To illustrate how it works, let's load the wirebond mask image and apply the extreme
# filter to it.

img = restrict(testimage_dip3e("fig1005")) # wirebond mask

#-

se = strel_diamond((3, 3)) # a dimond shape structuring element

# We use `max` as the select function -- applying `max` gives the [dilation](@ref op_dilate) operation:

extreme_filter(max, img, se)

# with the SE size controls the degree of dilation:

imgs = [extreme_filter(max, img, strel_diamond((n, n))) for n in 3:2:13]
mosaic(imgs; nrow=1)

# and `dims` controls the dimension to be dilated:

img_d1 = extreme_filter(max, img, strel_diamond((13, 13), (1,)))
img_d2 = extreme_filter(max, img, strel_diamond((13, 13), (2,)))
img_d12 = extreme_filter(max, img, strel_diamond((13, 13))) # (1, 2)
mosaic(img, img_d1, img_d2, img_d12; nrow=1)

# The `extreme_filter` can be used to build many operations, including the basic dilation,
# erosion, and some other operators. Here we just list a few for inspiration:

se = strel_diamond((7, 7))
img_1 = extreme_filter(max, img, se) # dilate
img_2 = extreme_filter(min, img, se) # erode
img_3 = extreme_filter((x, y) -> rand() > 0.5 ? x : y, img, se) # jitter
## or pipe the filters
img_4 = extreme_filter(max, extreme_filter(min, img), se) # opening
img_5 = extreme_filter(min, extreme_filter(max, img), se) # closing
mosaic(img, img_1, img_2, img_3, img_4, img_5; nrow=1)


# Many of the above operations are already implemented in ImageMorphology.

## the `mapwindow` function

# There is a very similar function to `extreme_filter` called `mapwindow(f, img, window)`
# from [ImageFiltering.jl](https://github.com/JuliaImages/ImageFiltering.jl). The main
# difference is that `f` in `mapwindow` applies to the entire neighborhood instead of two
# points in `extreme_filter`.

## currently, mapwindow only supports the box-shaped neighborhood
img1 = extreme_filter(max, img, strel_box((7, 7)))
img2 = mapwindow(maximum, img, (7, 7))
img1 == img2

# save cover image #src
using FileIO #src
mkpath("assets") #src
img = Gray.(restrict(testimage("blobs"))) #src
save("assets/extreme_filter.png", extreme_filter((x, y) -> rand() > 0.5 ? x : y, img; r=1)) #src

# ---
# title: "`tophat`"
# id: op_tophat
# cover: assets/tophat.png
# ---

# The (white) tophat operator is defined as `img - opening(img)`. Intuitively, this filter
# can be used to extract small white elements and details from an image.

using ImageMorphology
using TestImages
using ImageBase
using ImageShow

#-

img = restrict(testimage_dip3e("fig1005")) # wirebond mask

out1 = tophat(img) # default: all spatial dimensions, r=1, a box-shape SE
out2 = tophat(img; dims=(2,)) # only apply to the second dimension
out3 = tophat(img; r=5) # half-size r=5
out4 = tophat(img, strel_diamond((5, 5))) # generic SE -- this version doesn't accept `r` and `dims`

mosaic(img, out1, out2, out3, out4; nrow=1)


# ## See also

# To extract black small details, use [`bothat`](@ref op_bothat).

bothat(img) == tophat(complement.(img))

# For a comprehensive and more accurate documentation, please check the [`tophat`](@ref)
# reference page.

# save cover image #src
using FileIO #src
mkpath("assets") #src
img = Gray.(restrict(testimage("blobs"))) #src
save("assets/tophat.png", tophat(img; r=2)) #src

# Usage:
#     julia benchmark/run_benchmarks.jl
using BenchmarkTools
using ImageCore
using ImageMorphology
using ImageBinarization
using ImageTransformations
using ImageFiltering
using TestImages

on_CI = haskey(ENV, "GITHUB_ACTIONS")

cameraman = Gray{N0f8}.(testimage("cameraman"))
blobs = binarize(Gray.(testimage("blobs")), Otsu()) .> 0.5

tst_sizes = on_CI ? (256,) : (256, 512)
tst_types = (Gray{N0f8}, Gray{Float32})

const SUITE = BenchmarkGroup()

SUITE["extreme_filter"] = BenchmarkGroup()
let grp = SUITE["extreme_filter"]
    for T in [tst_types..., Int]
        grp[T] = BenchmarkGroup()
        for sz in tst_sizes
            tst_img = rand(T, sz, sz)

            grp[T]["$sz×$sz"] = BenchmarkGroup()
            se = strel_diamond((3, 3))
            grp[T]["$sz×$sz"]["r1_diamond"] = @benchmarkable extreme_filter(max, $tst_img, $se)
            se = strel_box((3, 3))
            grp[T]["$sz×$sz"]["r1_box"] = @benchmarkable extreme_filter(max, $tst_img, $se)
            se = centered(collect(se))
            grp[T]["$sz×$sz"]["r1_generic"] = @benchmarkable extreme_filter(max, $tst_img, $se)
            se = strel_diamond((11, 11))
            grp[T]["$sz×$sz"]["r5_diamond"] = @benchmarkable extreme_filter(max, $tst_img, $se)
            se = strel_box((11, 11))
            grp[T]["$sz×$sz"]["r5_box"] = @benchmarkable extreme_filter(max, $tst_img, $se)
            se = centered(collect(se))
            grp[T]["$sz×$sz"]["r5_generic"] = @benchmarkable extreme_filter(max, $tst_img, $se)
        end
    end
end
let grp = SUITE["extreme_filter"]
    T = Bool
    grp[T] = BenchmarkGroup()
    for sz in tst_sizes
        grp[T]["$sz×$sz"] = BenchmarkGroup()
        for (cname, cr) in [("worst", 0.95), ("best", 0.05), ("random", 0.5)]
            tst_img = fill(zero(T), sz, sz)
            tst_img[rand(sz, sz) .>= cr] .= true

            se = strel_diamond((3, 3))
            grp[T]["$sz×$sz"]["r1_diamond_$cname"] = @benchmarkable extreme_filter(max, $tst_img, $se)
            se = centered(collect(se))
            grp[T]["$sz×$sz"]["r1_bool_$cname"] = @benchmarkable extreme_filter(max, $tst_img, $se)

            se = strel_diamond((11, 11))
            grp[T]["$sz×$sz"]["r5_diamond_$cname"] = @benchmarkable extreme_filter(max, $tst_img, $se)
            se = centered(collect(se))
            grp[T]["$sz×$sz"]["r5_bool_$cname"] = @benchmarkable extreme_filter(max, $tst_img, $se)
        end
    end
end

SUITE["dilatation_and_erosion"] = BenchmarkGroup()
let grp = SUITE["dilatation_and_erosion"]
    grp["erode"] = BenchmarkGroup()
    grp["opening"] = BenchmarkGroup()
    for T in tst_types
        grp["erode"][T] = BenchmarkGroup()
        grp["opening"][T] = BenchmarkGroup()
        for sz in tst_sizes
            tst_img = T.(imresize(T.(cameraman), (sz, sz)))
            grp["erode"][T]["$sz×$sz"] = @benchmarkable erode($tst_img)
            grp["opening"][T]["$sz×$sz"] = @benchmarkable opening($tst_img)
        end
    end
end

SUITE["mreconstruct"] = BenchmarkGroup()
let grp = SUITE["mreconstruct"]
    @assert eltype(blobs) == Bool
    erode_blobs = erode(blobs)
    grp["Bool"] = @benchmarkable mreconstruct(dilate, $erode_blobs, $blobs)
    for T in tst_types
        grp["$T"] = @benchmarkable mreconstruct(dilate, $(T.(erode_blobs)), $(T.(blobs)))
    end
end

SUITE["connected"] = BenchmarkGroup()
let grp = SUITE["connected"]
    grp["label_components"] = @benchmarkable label_components($blobs)
    grp["label_flatzones"] = @benchmarkable label_flatzones($cameraman, trues(3,3))
    grp["label_lambdaflatzones"] = @benchmarkable label_lambdaflatzones($cameraman, trues(3,3),Gray{N0f8}(1.0/255.0))
end

SUITE["Maxtree"] = BenchmarkGroup()
let grp = SUITE["Maxtree"]
    grp["area_opening"] = BenchmarkGroup()
    for sz in tst_sizes
        tst_img = (imresize((cameraman), (sz, sz)))
        B = similar(tst_img)
        grp["area_opening"]["$sz×$sz"] = @benchmarkable area_opening($B, min_area=50)
    end
end

SUITE["convexhull"] = BenchmarkGroup()
let grp = SUITE["convexhull"]
    grp["convexhull"] = @benchmarkable convexhull($blobs)
end

SUITE["feature_transform"] = BenchmarkGroup()
let grp = SUITE["feature_transform"]
    grp["feature_transform"] = @benchmarkable feature_transform($blobs)
end

SUITE["leveling"] = BenchmarkGroup()
let grp = SUITE["leveling"]
    gaus = Gray{N0f8}.(imfilter(cameraman, Kernel.gaussian(5)))
    grp["low_leveling"] = @benchmarkable low_leveling(cameraman, $gaus)
    grp["high_leveling"] = @benchmarkable high_leveling(cameraman, $gaus)
    grp["leveling"] = @benchmarkable leveling(cameraman, $gaus)
end

SUITE["extremum"] = BenchmarkGroup()
let grp = SUITE["extremum"]
    grp["hmaxima"] = BenchmarkGroup()
    for sz in tst_sizes
        tst_img = reinterpret(N0f8, imresize((cameraman), (sz, sz)))
        grp["hmaxima"]["$sz×$sz"] = @benchmarkable hmaxima($tst_img, reinterpret(N0f8, (UInt8)(3)))
    end
    grp["regional_maxima"] = BenchmarkGroup()
    for sz in tst_sizes
        tst_img = reinterpret(N0f8, imresize((cameraman), (sz, sz)))
        grp["regional_maxima"]["$sz×$sz"] = @benchmarkable regional_maxima($tst_img)
    end
end

struct SEChain{N} <: MorphologySE{N}
    data::Vector{<:AbstractArray{Bool}}
end

struct SEChainArray{N,AT<:AbstractArray{Bool,N}} <: MorphologySEArray{N}
    data::Vector{<:AbstractArray{Bool}}
    _data::AT # pre-calculated chained data as mask
    function SEChainArray{N}(data::Vector{<:AbstractArray{Bool}}) where {N}
        # TODO(johnnychen94): defer the calculation of chained data until it is needed since
        # this is mainly used for visualization purposes
        _data = _strel_chain(data)
        return new{N,typeof(_data)}(data, _data)
    end
end
function SEChainArray(data::Vector{<:AbstractArray{Bool}})
    data = convert(Vector, data)
    N = maximum(ndims.(data))
    return SEChainArray{N}(data)
end
SEChainArray(data::Tuple) = SEChainArray(collect(data))
strel_type(A::SEChainArray{N}) where {N} = SEChain{N}(A.data)
strel_size(A::SEChainArray) = size(A._data)

Base.axes(A::SEChainArray) = axes(A._data)
Base.size(A::SEChainArray) = size(A._data)
Base.@propagate_inbounds Base.getindex(A::SEChainArray, inds::Int...) = getindex(A._data, inds...)

"""
    strel_chain(A, B, ...)
    strel_chain(As)

For structuring elements of the same dimensions, chain them together to build a bigger one.

The output dimension is the same as the inputs dimensions. See also [`strel_product`](@ref)
that cartesian producting each SE.

!!! note "structuring element decomposition"
    For some morphological operations `f` such as dilation and erosion, if `se` can be
    decomposed into smaller ones `se1, se2, ..., seN`, then `f(img, se)` is equivalent to
    `f(...f(f(img, se1), se2), ..., seN)`. Because applying `f` to smaller SEs is more
    efficient than to the original big one, this trick is used widely in image morphology.

```jldoctest; setup=:(using ImageMorphology; using ImageMorphology.StructuringElements)
julia> img = rand(512, 512);

julia> se1, se2 = [centered(rand(Bool, 3, 3)) for _ in 1:2];

julia> se = strel_chain(se1, se2);

julia> out_se = dilate(img, se);

julia> out_pipe = dilate(dilate(img, se1), se2);

julia> out_se[2:end-1, 2:end-1] == out_pipe[2:end-1, 2:end-1] # except for the boundary
true
```
"""
strel_chain(se, se_rest...) = strel_chain([se, se_rest...])
strel_chain(se_list::Vector{<:AbstractArray{T,N}}) where {T,N} = SEChainArray{N}(se_list)
strel_chain(se_list::Tuple) = SEChainArray(se_list)
strel_chain(se) = se

function _strel_chain(data::AbstractVector{<:AbstractArray})
    isempty(data) && throw(ArgumentError("data cannot be empty"))
    data = strel.(CartesianIndex, data)
    out = first(data)
    for i in axes(data, 1)[2:end]
        # TODO: preallocating the output can reduce a few more
        out = _simple_dilate(out, data[i])
    end
    out = strel(Bool, strel(CartesianIndex, out))
    return out
end

# a simple dilate function that automatically extends the boundary and dimension
function _simple_dilate(A::AbstractArray{T,N}, B::AbstractArray{T,N}) where {T,N}
    r = strel_size(B) .÷ 2
    sz = max.(strel_size(A), strel_size(B))
    out_sz = @. sz + 2r
    out = centered(falses(out_sz))

    R = strel(CartesianIndex, A)
    offsets = strel(CartesianIndex, B)
    i = zero(eltype(R))
    out[i] = true
    for o in offsets
        out[i + o] = true
    end
    for i in R
        out[i] = true
        for o in offsets
            out[i + o] = true
        end
    end

    # remove unnecessary zero boundaries
    return strel(CartesianIndex, out)
end

"""
    strel_product(A, B, ...)
    strel_product(se_list)

Cartesian product of multiple structuring elements; the output dimension `ndims(out) ==
sum(ndims, se_list)`.

See also [`strel_chain`](@ref) that chains SEs in the same dimension.

```jldoctest; setup=:(using ImageMorphology; using ImageMorphology.StructuringElements)
julia> strel_product(strel_diamond((5, 5)), centered(Bool[1, 1, 1]))
5×5×3 SEChainArray{3, OffsetArrays.OffsetArray{Bool, 3, BitArray{3}}} with indices -2:2×-2:2×-1:1:
[:, :, -1] =
 0  0  1  0  0
 0  1  1  1  0
 1  1  1  1  1
 0  1  1  1  0
 0  0  1  0  0

[:, :, 0] =
 0  0  1  0  0
 0  1  1  1  0
 1  1  1  1  1
 0  1  1  1  0
 0  0  1  0  0

[:, :, 1] =
 0  0  1  0  0
 0  1  1  1  0
 1  1  1  1  1
 0  1  1  1  0
 0  0  1  0  0
```
"""
strel_product(se, se_rest...) = strel_product([se, se_rest...])

# TODO(johnnychen94): fix the type instability if it really matters in practice
function strel_product(se_list)
    N = sum(ndims, se_list)
    new_se_list = Array{Bool,N}[]
    ni = 0
    for se in se_list
        pre_ones = ntuple(_ -> one(Int), max(0, ni))
        post_ones = ntuple(_ -> one(Int), max(0, N - ndims(se) - ni))
        new_se = reshape(se, pre_ones..., size(se)..., post_ones...)
        push!(new_se_list, convert(Array{Bool,N}, new_se))
        ni += ndims(se)
    end
    return SEChainArray{N}(map(centered, new_se_list))
end

using Documenter
using DemoCards
using ImageMorphology
using OffsetArrays
using ImageBase, ImageShow, TestImages

operators, operators_cb, demo_assets = makedemos("operators")

prettyurls = get(ENV, "CI", nothing) == "true"
assets = Any[demo_assets]

pages = Any[
    "index.md",
    "structuring_element.md",
    operators,
    "reference.md"
]

makedocs(;
    modules=[ImageMorphology, OffsetArrays],
    format=Documenter.HTML(; prettyurls, assets, size_threshold=1_000_000),
    sitename="ImageMorphology",
    pages,
	checkdocs=:exports,
    doctest=false
)
operators_cb()

deploydocs(;
    forcepush = true,
    push_preview = true,
    repo="github.com/JuliaImages/ImageMorphology.jl.git"
)

using ImageMorphology
using ImageCore
using ImageCore.PaddedViews
using Test
using OffsetArrays
using ImageMetadata
using Suppressor

@test isempty(detect_ambiguities(ImageMorphology))

if Base.VERSION >= v"1.8"
	using Documenter
    doctest(ImageMorphology; manual=false)
end

include("testutils.jl")

include("structuring_element.jl")
include("utils.jl")
include("extreme_filter.jl")
include("extremum.jl")
include("convexhull.jl")
include("connected.jl")
include("ops/dilate.jl")
include("ops/erode.jl")
include("ops/opening.jl")
include("ops/closing.jl")
include("ops/tophat.jl")
include("ops/bothat.jl")
include("ops/mgradient.jl")
include("ops/mlaplacian.jl")
include("ops/mreconstruct.jl")
include("ops/underbuild.jl")
include("ops/overbuild.jl")
include("isboundary.jl")
include("thinning.jl")
include("imfill.jl")
include("maxtree.jl")
include("feature_transform.jl")
include("leveling.jl")
include("clearborder.jl")

@info "Beginning deprecation tests, warnings are expected"
include("deprecations.jl")

# multithreaded.jl runs on CI

@testset "underbuild" begin
    # heavy numerical tests are put in the `mreconstruct` testset
    marker, mask = rand(32, 32), rand(32, 32)
    @test underbuild(marker, mask) ==
        mreconstruct(dilate, marker, mask)
    @test underbuild(marker, mask; dims=1) ==
        mreconstruct(dilate, marker, mask; dims=1)
    @test underbuild(marker, mask, strel_diamond(marker)) ==
        mreconstruct(dilate, marker, mask, strel_diamond(marker))
    @test underbuild!(similar(marker), marker, mask) ==
        mreconstruct!(dilate, similar(marker), marker, mask)
    @test underbuild!(similar(marker), marker, mask; dims=1) ==
        mreconstruct!(dilate, similar(marker), marker, mask; dims=1)
    @test underbuild!(similar(marker), marker, mask, strel_diamond(marker)) ==
        mreconstruct!(dilate, similar(marker), marker, mask, strel_diamond(marker))
end

@testset "Feature transform/Anisotropic images" begin
    function ind2cart(F)
        s = CartesianIndices(axes(F))
        return map(i -> CartesianIndex(s[i]), F)
    end

    A, w = [false false; false true], (3, 1)
    F = feature_transform(A, w)
    @test F == ind2cart([4 4; 4 4])
    D = distance_transform(F, w)
    @test D ≈ [sqrt(10) 3.0; 1.0 0.0]

    A, w = [false false; false true], (1, 3)
    F = feature_transform(A, w)
    @test F == ind2cart([4 4; 4 4])
    D = distance_transform(F, w)
    @test D ≈ [sqrt(10) 1.0; 3.0 0.0]

    A, w = [true false; false true], (3, 1)
    F = feature_transform(A, w)
    @test F == ind2cart([1 1; 4 4])
    D = distance_transform(F, w)
    @test D == [0 1; 1 0]

    A, w = [true false; false true], (1, 3)
    F = feature_transform(A, w)
    @test F == ind2cart([1 4; 1 4])
    D = distance_transform(F, w)
    @test D == [0 1; 1 0]
end

"""
    dilate(img; dims=coords_spatial(img), r=1)
    dilate(img, se)

Perform a max-filter over the neighborhood of `img`, specified by structuring element `se`.

$(_docstring_se)

# Examples

```jldoctest; setup = :(using ImageMorphology)
julia> img = falses(5, 5); img[3, [2, 4]] .= true; img
5×5 BitMatrix:
 0  0  0  0  0
 0  0  0  0  0
 0  1  0  1  0
 0  0  0  0  0
 0  0  0  0  0

julia> dilate(img)
5×5 BitMatrix:
 0  0  0  0  0
 1  1  1  1  1
 1  1  1  1  1
 1  1  1  1  1
 0  0  0  0  0

julia> dilate(img; dims=1)
5×5 BitMatrix:
 0  0  0  0  0
 0  1  0  1  0
 0  1  0  1  0
 0  1  0  1  0
 0  0  0  0  0

julia> dilate(img, strel_diamond(img)) # use diamond shape SE
5×5 BitMatrix:
 0  0  0  0  0
 0  1  0  1  0
 1  1  1  1  1
 0  1  0  1  0
 0  0  0  0  0
```

## See also

- [`dilate!`](@ref) is the in-place version of this function
- [`erode`](@ref) is the dual operator of `dilate` in the sense that
  `complement.(dilate(img)) == erode(complement.(img))`.

!!! note "symmetricity"
    If `se` is symmetric with repsect to origin, i.e., `se[b] == se[-b]` for any `b`, then
    dilation becomes the Minkowski sum: A⊕B={a+b|a∈A, b∈B}.

"""
dilate(img::AbstractArray; kwargs...) = dilate!(similar(img), img; kwargs...)
dilate(img::AbstractArray, se::AbstractArray) = dilate!(similar(img), img, se)

"""
    dilate!(out, img; [dims], [r])
    dilate!(out, img, se)

The in-place version of [`dilate`](@ref) with input image `img` and output image `out`.
"""
function dilate!(out, img; dims=coords_spatial(img), r=nothing)
    return dilate!(out, img, strel_box(img, dims; r))
end
dilate!(out, img, se::AbstractArray) = extreme_filter!(max, out, img, se)
dilate!(out::AbstractArray{<:Color3}, img, se::AbstractArray) = throw(ArgumentError("color image is not supported"))

# To run it locally, BenchmarkCI should be added to root project
using BenchmarkCI
on_CI = haskey(ENV, "GITHUB_ACTIONS")

judgement = BenchmarkCI.judge()
if on_CI
    BenchmarkCI.postjudge()
else
    ciresult = BenchmarkCI.CIResult(; judgement=judgement)
    output_file = "benchmark_result.md"
    @info "benchmark finished" output_file
    open(output_file, "w") do io
        BenchmarkCI.printcommentmd(io, ciresult)
    end
end

"""
    mreconstruct(op, marker, mask; [dims])
    mreconstruct(op, marker, mask, se)

Morphological reconstruction of `marker` image by operation `op`.

The `op` argument is either `erode` or `dilate`, indicating reconstruction by erosion or by
dilation. The `mask` argument has the same shape as `marker` and is used to restrict the
output value range.

The `dims` keyword is used to specify the dimension to process by constructing the box shape
structuring element [`strel_box(marker; dims)`](@ref strel_box). For generic structuring
element, the half-size is expected to be either `0` or `1` along each dimension.

By definition, the reconstruction is done by applying `marker = select.(op(marker; dims),
mask)` repeatly until reaching stability. For dilation `op, select = dilate, min` and for
erosion `op, select = erode, max`.

# Examples

```jldoctest; setup=:(using ImageMorphology)
julia> marker = [0 0 0 0 0; 0 9 0 0 0; 0 0 0 0 0; 0 0 0 5 0; 0 0 0 0 0; 0 9 0 0 0]
6×5 Matrix{$Int}:
 0  0  0  0  0
 0  9  0  0  0
 0  0  0  0  0
 0  0  0  5  0
 0  0  0  0  0
 0  9  0  0  0

julia> mask = [9 0 0 0 0; 0 8 7 1 0; 0 9 0 4 0; 0 0 0 4 0; 0 0 6 5 6; 0 0 9 8 9]
6×5 Matrix{$Int}:
 9  0  0  0  0
 0  8  7  1  0
 0  9  0  4  0
 0  0  0  4  0
 0  0  6  5  6
 0  0  9  8  9

julia> mreconstruct(dilate, marker, mask) # equivalent to underbuild(marker, mask)
6×5 Matrix{$Int}:
 8  0  0  0  0
 0  8  7  1  0
 0  8  0  4  0
 0  0  0  4  0
 0  0  4  4  4
 0  0  4  4  4
```

# See also

The inplace version of this function is [`mreconstruct!`](@ref). There are also aliases
[`underbuild`](@ref) for reconstruction by dilation and [`overbuild`](@ref) for
reconstruction by erosion.

# References

- [1] L. Vincent, “Morphological grayscale reconstruction in image analysis: applications
  and efficient algorithms,” IEEE Trans. on Image Process., vol. 2, no. 2, pp. 176–201, Apr.
  1993, doi: 10.1109/83.217222.
- [2] P. Soille, Morphological Image Analysis. Berlin, Heidelberg: Springer Berlin
  Heidelberg, 2004. doi: 10.1007/978-3-662-05088-0.
"""
function mreconstruct(op, marker, mask; dims=coords_spatial(mask))
    return mreconstruct(op, marker, mask, strel_box(marker, dims))
end
function mreconstruct(op, marker, mask, se)
    axes(marker) == axes(mask) || throw(DimensionMismatch("`marker` and `mask` should have the same axes"))
    # This ensures that we support mixed types, e.g. marker as Matrix{Gray{N0f8}} and mask as Matrix{Float64}
    OT = ImageCore.MosaicViews.promote_wrapped_type(eltype(marker), eltype(mask))
    return mreconstruct!(op, similar(mask, OT), marker, mask, se)
end

"""
    mreconstruct!(op, out, marker, mask; [dims])

The in-place version of morphological reconstruction [`mreconstruct`](@ref).
"""
function mreconstruct!(op, out, marker, mask; dims=coords_spatial(mask))
    return mreconstruct!(op, out, marker, mask, strel_box(marker, dims))
end
function mreconstruct!(op, out, marker, mask, se)
    return _mreconstruct!(_prepare_reconstruct_ops(op), out, marker, mask, se)
end

_prepare_reconstruct_ops(::op) where {op} = error("operation `$(op.instance)` is not supported for `mreconstruct`")
_prepare_reconstruct_ops(::typeof(dilate)) = (max, min)
_prepare_reconstruct_ops(::typeof(erode)) = (min, max)
@inline _should_push(::typeof(max)) = <
@inline _should_push(::typeof(min)) = >

# Single-CPU version, references are [1] and section 6.2 of [2]
function _mreconstruct!((select_se, select_marker), out, marker, mask, se)
    N = ndims(marker)

    axes(out) == axes(marker) == axes(mask) || throw(DimensionMismatch("images should have the same axes"))
    require_select_function(select_se, eltype(mask), eltype(marker))
    require_select_function(select_marker, eltype(mask), eltype(marker))

    # For generic structuring element, the half-size should to be either `0` or `1` along
    # each dimension. See also section 6.2.3 of [2].
    se_size = strel_size(se)
    if length(se_size) != N
        msg = "the input structuring element is not for $N dimensional array, instead it is for $(length(se_size)) dimensional array"
        throw(DimensionMismatch(msg))
    end
    if !all(x -> in(x, (1, 3)), strel_size(se))
        # center cropping the input se using [-1:1, -1:1, ...]
        inds_str = join(ntuple(_ -> 3, N), "×")
        @warn "structuring element with half-size larger than 1 is invalid, only the center $inds_str values are used"
        inds = ntuple(i -> (-1:1), N)
        se = centered(strel(Bool, strel(CartesianIndex, se))[inds...])
    end
    se = strel(CartesianIndex, se)

    # The original algorithm assume that the marker < mask for erosion and marker > mask for
    # dilation. This assertion is not always true in practice.
    @. out = select_marker(marker, mask)

    queue = Queue{CartesianIndex{N}}()
    se = strel(CartesianIndex, se)
    upper_se, lower_se = strel_split(se)

    # NOTE we could pad the array with -Inf to speedup forward/backward scan
    # forward scan
    R = CartesianIndices(axes(marker))
    for i in R
        @inbounds curr_val = out[i]
        for Δi in upper_se # examine neighborhoods
            ii = i + Δi
            if checkbounds(Bool, R, ii) #check that we are in the image
                @inbounds curr_val = select_se(curr_val, out[ii])
            end
        end
        @inbounds out[i] = select_marker(curr_val, mask[i])
    end
    # backward scan
    should_push = _should_push(select_se)
    for i in reverse(R)
        @inbounds curr_val = out[i]
        for Δi in lower_se # examine neighborhoods
            ii = i + Δi
            if checkbounds(Bool, R, ii) #check that we are in the image
                @inbounds curr_val = select_se(curr_val, out[ii])
            end
        end
        @inbounds out[i] = select_marker(curr_val, mask[i])
        for Δi in lower_se # examine neighborhoods
            ii = i + Δi
            if checkbounds(Bool, R, ii) #check that we are in the image
                @inbounds if should_push(out[ii], out[i]) && should_push(out[ii], mask[ii])
                    push!(queue, i)
                end
            end
        end
    end
    # Loop until all pixel have been examined
    while !isempty(queue)
        curr_idx = popfirst!(queue)
        for Δi in se # examine neighborhoods
            ii = curr_idx + Δi
            if checkbounds(Bool, R, ii) #check that we are in the image
                @inbounds if should_push(out[ii], out[curr_idx]) && mask[ii] != out[ii]
                    out[ii] = select_marker(out[curr_idx], mask[ii])
                    push!(queue, ii)
                end
            end
        end
    end
    return out
end

# ---
# title: "`overbuild`"
# id: op_overbuild
# cover: assets/overbuild.png
# ---

# `overbuild` is reconstruction by erosion, it is an alias for `mreconstruct` when `op=erode`.

using ImageMorphology
using TestImages
using ImageBase
using ImageShow

img = restrict(Gray.(testimage("blob")))
nothing # hide

# `overbuild` accepts two images as inputs: `marker` and `mask`.

out = overbuild(img .- 0.2, img)
mosaic(img, out; nrow=1)

# ## See also

# [`overbuild`](@ref op_overbuild) is the dual operator of `underbuild` in the following sense:

marker, mask = rand(32, 32), rand(32, 32)
complement.(overbuild(marker, mask)) == overbuild(complement.(marker), complement.(mask))

# For more details, please refer to [`mreconstruct`](@ref op_mreconstruct).

# save cover image #src
using FileIO #src
mkpath("assets") #src
img = Gray.(restrict(testimage("blobs"))) #src
save("assets/overbuild.png", overbuild(img .- 0.2, img)) #src

@testset "clearborder" begin
    #Case when given border width is more than image size
    img = [
        1 0 1 1 1 1
         0 1 1 1 0 0
         1 1 0 0 0 1
         0 1 0 1 0 1
         1 1 0 0 0 1
         0 0 1 1 0 0
    ]
    @test_throws ArgumentError clearborder(img, 7)

    #Normal Case
    img = [
        0 0 0 0 0 0 0 1 0
         0 0 0 0 1 0 0 0 0
         1 0 0 1 0 1 0 0 0
         0 0 1 1 1 1 1 0 0
         0 1 1 1 1 1 1 1 0
         0 0 0 0 0 0 0 0 0
    ]
    cleared_img = clearborder(img)
    check_img = copy(img)
    check_img[3, 1] = 0
    check_img[1, 8] = 0
    @test cleared_img == check_img

    cleared_img = clearborder(img, 2)
    @test cleared_img == fill!(similar(img), zero(eltype(img)))

    cleared_img = clearborder(img, 2, 10)
    @test cleared_img == 10 * fill!(similar(img), one(eltype(img)))

    #Multidimentional Case
    img = cat(
        [
            0 0 0 0
                 0 0 0 0
                 0 0 0 0
                 1 0 0 0
        ],
        [
            0 0 0 0
               0 1 1 0
               0 0 1 0
               0 0 0 0
        ],
        [
            0 0 0 0
               0 0 0 0
               0 0 0 0
               0 0 0 0
        ];
        dims=3,
    )
    cleared_img = clearborder(img)
    check_img = copy(img)
    check_img[4, 1, 1] = 0
    @test cleared_img == check_img

    cleared_img = clearborder(img, 2)
    @test cleared_img == fill!(similar(img), zero(eltype(img)))

    cleared_img = clearborder(img, 2, 10)
    @test cleared_img == 10 * fill!(similar(img), one(eltype(img)))

    #Grayscale input image Case
    img = [
        1 2 3 1 2
         3 3 5 4 2
         3 4 5 4 2
         3 3 2 1 2
    ]
    cleared_img = clearborder(img)
    check_img = [
        0 0 0 0 0
           0 0 5 4 0
           0 4 5 4 0
           0 0 0 0 0
    ]
    @test cleared_img == check_img
end

beucher_gradient_ref(img, dims, r) = beucher_gradient_ref(img, strel_box(img, dims; r))
beucher_gradient_ref(img, se) = float.(dilate(img, se)) .- float.(erode(img, se))
external_gradient_ref(img, dims, r) = external_gradient_ref(img, strel_box(img, dims; r))
external_gradient_ref(img, se) = float.(dilate(img, se)) .- img
internal_gradient_ref(img, dims, r) = internal_gradient_ref(img, strel_box(img, dims; r))
internal_gradient_ref(img, se) = img .- float.(erode(img, se))

@testset "mgradient" begin
    test_ranges = [Bool, 1:10, Float64, Gray{N0f8}, Gray{Float64}]
    modes = [
        (:beucher, beucher_gradient_ref),
        (:external, external_gradient_ref),
        (:internal, internal_gradient_ref),
    ]
    for (mode, ref_fun) in modes
        for T in test_ranges
            for N in (1, 2, 3)
                sz = ntuple(_ -> 32, N)
                img = rand(T, sz...)

                out = mgradient(img; mode)
                @test out == mgradient(img, strel_box(img, ntuple(identity, N); r=1); mode)
                @test out == ref_fun(img, ntuple(identity, N), 1)

                @test mgradient(img; dims=(1,), r=2, mode) == ref_fun(img, (1,), 2)

                se = rand_se_mask(3, N; symmetric=true)
                @test mgradient(img, se; mode) == ref_fun(img, se)
            end
        end
    end

    img = rand(1:5, 7, 7)
    out = similar(img)
    mgradient!(out, img, similar(img))
    @test out == mgradient(img)

    img = rand(RGB, 7, 7)
    @test_throws ArgumentError("color image is not supported") mgradient(img)

    img = rand(1:10, 7, 7)
    se = Bool[1 0 0; 0 1 0; 0 0 0]
    msg = "structuring element must be symmetric with respect to its center"
    @test_throws ArgumentError(msg) mlaplacian(img, se)
end

erode_ref(img, dims, r) = erode_ref(img, strel_box(img, dims; r))
erode_ref(img, se) = extreme_filter(min, img, se)

@testset "erode" begin
    test_types = [Bool, Int, Float64, Gray{N0f8}, Gray{Float64}]
    for T in test_types
        for N in (1, 2, 3)
            sz = ntuple(_ -> 32, N)
            img = rand(T, sz...)

            out = erode(img)
            @test out == erode(img, strel_box(img, ntuple(identity, N); r=1))
            @test out == erode_ref(img, ntuple(identity, N), 1)

            @test erode(img; dims=(1,), r=2) == erode_ref(img, (1,), 2)

            se = centered(rand(Bool, ntuple(_ -> 3, N)))
            @test erode(img, se) == erode_ref(img, se)
        end
    end

    img = rand(1:5, 7, 7)
    out = similar(img)
    erode!(out, img)
    @test out == erode(img)

    img = rand(RGB, 7, 7)
    @test_throws ArgumentError("color image is not supported") erode(img)

    # ImageMeta
    @testset "ImageMeta" begin
        A = rand(1:5, 7, 7)
        @test arraydata(erode(ImageMeta(A))) == erode(A)
        @test arraydata(erode(ImageMeta(A); dims=1:2)) == erode(A; dims=1:2)
    end
end

@testset "Connected components" begin
    @testset "label_components" begin
        @testset "interface" begin
            for T in (Bool, N0f8, Float64, Gray{N0f8})
                A = rand(T, 11, 11)
                @test label_components(A) == label_components(A, strel_diamond(A))
                @test label_components(A; r=2, dims=1) == label_components(A, strel_diamond(A, 1; r=2))

                label = similar(A, Int)
                label_components!(label, A)
                @test label_components(A) == label
                label_components!(label, A; r=2, dims=1)
                @test label_components(A; r=2, dims=1) == label
                label_components!(label, A, strel_box((3, 3)))
                @test label_components(A, strel_box((3, 3))) == label

                Ac = complement.(A)
                @test label_components(Ac; bkg=oneunit(T)) == label_components(A; bkg=zero(T))
            end

            A = rand(Bool, 11, 11)
            se = strel(CartesianIndex, centered(Bool[1 1 1; 1 1 0; 0 0 0]))
            label = @suppress_err label_components(A, se) # deprecated usage in v0.4
            @test label == label_components(A, strel_box((3, 3)))

            msg = "Non-symmetric structuring element is not supported yet"
            se = centered(Bool[1 1 1; 1 1 1; 1 1 0])
            @test_throws ArgumentError(msg) label_components(rand(Bool, 5, 5), se)

            msg = "axes of input and output must match, got (Base.OneTo(11), Base.OneTo(11)) and (-1:1, -1:1). The second argument seems to be a structuring element, it is expected to be the input array."
            @test_throws DimensionMismatch(msg) label_components!(rand(Bool, 11, 11), strel_diamond((3, 3)))

            msg = "labels exhausted, use a larger integer type"
            @test_throws ErrorException(msg) label_components!(zeros(Bool, 4, 4), rand(4, 4))
        end

        A = [
            true  true  false true
            true  false true  true
        ]
        lbltarget = [
            1 1 0 2
            1 0 2 2
        ]
        lbltarget1 = [
            1 2 0 4
            1 0 3 4
        ]
        @test label_components(A) == lbltarget
        @test label_components(A; dims=:) == lbltarget
        @test label_components(A; dims=1) == lbltarget1
        connectivity = centered([
            false true  false
            true  false true
            false true  false
        ])
        @test label_components(A, connectivity) == lbltarget
        connectivity = centered(trues(3, 3))
        lbltarget2 = [
            1 1 0 1
            1 0 1 1
        ]
        @test label_components(A, connectivity) == lbltarget2
    end

    @testset "component_boxes" begin
        A = rand(0:5, 11, 11)
        label = label_components(A, strel_box((5, 5)))
        boxes = component_boxes(label)
        @test eltype(boxes) <: CartesianIndices
        @test axes(boxes) == (0:maximum(label),)

        # the bounding box is the smallest region that contains the label value
        @test all(eachindex(boxes)) do i
            n1 = count(isequal(i), label[boxes[i]])
            n2 = count(isequal(i), label)
            n1 == n2
        end

        A = [2 2 2 2 2; 1 1 1 0 1; 1 0 2 1 1; 1 1 2 2 2; 1 0 2 2 2]
        label = label_components(A)
        boxes = component_boxes(label)
        @test boxes == OffsetArray(
            [
                CartesianIndices((2:5, 2:4)),
                CartesianIndices((1:1, 1:5)),
                CartesianIndices((2:5, 1:3)),
                CartesianIndices((3:5, 3:5)),
                CartesianIndices((2:3, 4:5)),
            ], -1)
        @test A[boxes[1]] == [2 2 2 2 2]
        @test A[boxes[4]] == [0 1; 1 1]

        label = zeros(Int, 5, 5)
        label[1] = -1
        msg = "The input labeled array should contain background label `0` as the minimum value"
        @test_throws ArgumentError(msg) component_boxes(label)

        boxes = component_boxes(ones(Int, 5, 5))
        @test length(boxes) == 1
    end

    @testset "component_indices" begin
        A = [2 2 2 2 2; 1 1 1 0 1; 1 0 2 1 1; 1 1 2 2 2; 1 0 2 2 2]
        label = label_components(A)
        indices = component_indices(label)
        @test IndexStyle(label) == IndexLinear()
        @test eltype(indices) == Vector{Int}
        @test axes(indices) == (0:maximum(label),)
        @test indices == OffsetVector([
                [8, 10, 17], [1, 6, 11, 16, 21], [2, 3, 4, 5, 7, 9, 12],
                [13, 14, 15, 19, 20, 24, 25], [18, 22, 23],
            ], -1)

        @test indices == component_indices(Int, label) == component_indices(IndexLinear(), label)

        indices = component_indices(CartesianIndex, label)
        @test eltype(indices) == Vector{CartesianIndex{ndims(A)}}
        @test axes(indices) == (0:maximum(label),)
        @test indices == [CartesianIndices(label)[R] for R in component_indices(Int, label)]
        @test indices == component_indices(IndexCartesian(), label)

        plabel = PaddedView(0, label, (0:6, 0:6))
        indices = component_indices(CartesianIndex, label)
        pindices = component_indices(plabel)
        @test IndexStyle(plabel) == IndexCartesian()
        @test eltype(pindices) == Vector{CartesianIndex{ndims(A)}}
        @test pindices[1:end] == indices[1:end] # they only differ in background indices

        label = zeros(Int, 5, 5)
        label[1] = -1
        msg = "The input labeled array should contain background label `0` as the minimum value"
        @test_throws ArgumentError(msg) component_indices(label)

        indices = component_indices(ones(Int, 5, 5))
        @test axes(indices, 1) == 0:1
        @test isempty(indices[0])
    end

    @testset "component_lengths" begin
        A = [2 2 2 2 2; 1 1 1 0 1; 1 0 2 1 1; 1 1 2 2 2; 1 0 2 2 2]
        label = label_components(A)
        counts = component_lengths(label)
        indices = component_indices(label)
        @test counts == length.(indices)
        @test axes(counts) == (0:maximum(label),)

        label = zeros(Int, 5, 5)
        label[1] = -1
        msg = "The input labeled array should contain background label `0` as the minimum value"
        @test_throws ArgumentError(msg) component_lengths(label)

        counts = component_lengths(ones(Int, 5, 5))
        @test axes(counts, 1) == 0:1
        @test counts[0] == 0
    end

    @testset "component_centroids" begin
        A = [2 2 2 2 2; 1 1 1 0 1; 1 0 2 1 1; 1 1 2 2 2; 1 0 2 2 2]
        label = label_components(A)
        centers = component_centroids(label)
        indices = component_indices(CartesianIndex, label)
        @test centers == [sum(X).I ./ length(X) for X in indices]
        @test axes(centers) == (0:maximum(label),)

        label = zeros(Int, 5, 5)
        label[1] = -1
        msg = "The input labeled array should contain background label `0` as the minimum value"
        @test_throws ArgumentError(msg) component_centroids(label)

        centers = component_centroids(ones(Int, 5, 5))
        @test axes(centers, 1) == 1:1
    end

    @testset "deprecations" begin
        A = [
            true  true  false true
            true  false true  true
        ]
        label = label_components(A)
        indices = @suppress_err component_subscripts(label)
        @test indices ==
            Array{Tuple}[[(2, 2), (1, 3)], [(1, 1), (2, 1), (1, 2)], [(2, 3), (1, 4), (2, 4)]]
    end

end

@testset "Label flat zones" begin
    A = ([
        1 1 8
        7 8 8
        7 4 5])

    expected = ([
        1 1 3
        2 3 3
        2 4 5])

    @test label_flatzones(A, strel_diamond((3, 3))) == expected

    A = ([
        1 8 8
        7 8 8
        7 4 5])

    expected = ([
        1 3 3
        2 3 3
        2 4 5])

    @test label_flatzones(A) == expected

    out = similar(A, Int)
    out = label_flatzones!(out, A)
    @test out == expected

    msg = "the input structuring element is not for 1 dimensional array, instead it is for 2 dimensional array"
    @test_throws DimensionMismatch(msg) label_flatzones(rand(10), strel_box((3, 3)))

    se = strel_diamond((7, 7))
    msg = "structuring element with half-size larger than 1 is invalid"
    @test_throws DimensionMismatch(msg) label_flatzones(rand(10, 10), se)
end

@testset "Label lambda flat zones" begin
    A = ([
        1 1 8
        7 8 8
        7 4 5])
    expected = ([
        1 1 2
        2 2 2
        2 3 3])

    @test label_lambdaflatzones(A, 1, strel_diamond((3, 3))) == expected

    A = ([
        1 8 8
        7 6 8
        7 4 5])

    expected = ([
        1 2 2
        2 2 2
        2 2 2])
    @test label_lambdaflatzones(A, 1) == expected

    out = similar(A, Int)
    out = label_lambdaflatzones!(out, A, 1)
    @test out == expected
end

# ---
# title: "`mreconstruct`"
# id: op_mreconstruct
# cover: assets/mreconstruct.png
# ---

# The morphological reconstruction operator is to repeatedly apply particular operator until
# the stability, i.e,. output unchanged. The most widely used ones are reconstruction by
# dilation and reconstruction by erosion.

using ImageMorphology
using TestImages
using ImageBase
using ImageShow
using IndirectArrays, FileIO #hide

img = Gray.(testimage("blob"))
nothing #hide

# Unlike other morphological operators such as `erode`, `mreconstruct` requires two image
# inputs. One is the marker image, and the other is the mask image. Usually, `mask` is the
# image we study on and the `marker` image is what we want to reconstruct from. A suitable
# marker image can be determined using[^1]:

# - knowledge about the expected result
# - known facts about the image or the physics of the object it represents
# - some transformations of the mask image itself
# - other image data, if available (i.e., multispectral and multitemporal images)
# - interaction with the user (i.e., markers are manually defined)

# Take reconstruction by dilation as an example, we build the marker image from the mask
# image, then repeatedly apply `marker = min.(dilate(marker), mask)`.

mask = img
marker = mask .- 0.3
mosaic(marker, mask; nrow=1)

# The following function is a naive implementation of this idea:

# ```julia
# # For illustration purposes only; you should use `mreconstruct` in practice
# function my_reconstruct(marker, mask)
#     # reconstruction by dilation
#     # For reconstruction by erosion, one can change `min` to `max` and `dilate` to `erode`
#     out = min.(mask, marker)
#     has_changed = true
#     while has_changed
#         old = out
#         out = min.(dilate(out), mask)
#         has_changed = !(old == out)
#     end
#     return out
# end
# ```

# The following GIF shows the intermediate result `out` of each iteration. The left side
# shows its actual gray value, and the right side shows the colored value to better
# visualize the progress.

function my_reconstruct_outs(marker, mask) #hide
    out = min.(mask, marker) #hide
    outs = [out] #hide
    has_changed = true #hide
    n = 1 #hide
    while has_changed #hide
        old = out #hide
        out = min.(dilate(out), mask) #hide
        n % 4 == 1 && push!(outs, out) #hide
        has_changed = !(old == out) #hide
        n = n + 1 #hide
    end #hide
    return outs #hide
end #hide
function with_color(img, orders, colormap) #hide
    return IndirectArray([orders[img[i]] for i in CartesianIndices(img)], colormap) #hide
end #hide
outs = my_reconstruct_outs(marker, mask) #hide
orders = Dict(x => i for (i, x) in enumerate(sort(mapreduce(unique, union, outs)))) #hide
colormap = ImageCore.Colors.distinguishable_colors(length(orders)) #hide
f = scaleminmax(RGB, 0, 1) #hide
save("assets/mreconstruct.gif",  #hide
     f.(cat([mosaic(frame, with_color(frame, orders, colormap); nrow=1) #hide
             for frame in (@view outs[1:1:end])]..., dims=3)); #hide
     fps=5) #hide
# ![alternative text](assets/mreconstruct.gif)

# This is how reconstruction happends and why it is called so -- it reconstructs the
# `marker` image with a reference image `mask`, this helps us investigate certain properties
# of the `mask` image. For instance, if we want to investigate the blobs only (dark region),
# we would want to apply reconstruction by dilation to it.

# The `mreconstruct(op, marker, mask)` function currently supports only `dilate` and `erode`
# as `op`, indicating reconstruction by dilation and reconstruction by erosion,
# respectively. There are also aliases [`underbuild`](@ref op_underbuild) and
# [`overbuild`](@ref op_overbuild).

## reconstruction by dilation -- `underbuild`
out1 = mreconstruct(dilate, img .- 0.3, img)
## reconstruction by erosion -- `overbuild`
out2 = mreconstruct(erode, img .+ 0.3, img)
mosaic(mask, out1, out2; nrow=1)

# The default structuring element it uses is the box-shaped SE. Like the other operators,
# you can pass `dims` keyword or positional argument `se` to `mreconstruct`. For instance,

mreconstruct(dilate, img .- 0.3, img; dims=1) # reconstruction along colomn
mreconstruct(dilate, img .- 0.3, img, strel_diamond(img)) # diamond shape SE
nothing #hide

# However, for generic structuring element, the half-size (or, radius) should be at most `1`
# for each dimension. This is because the algorithm is a growing process until stability,
# thus SE with half-size larger than `1` doesn't make a difference in practice.

# save cover image #src
using FileIO #src
img = Gray.(restrict(testimage("blobs"))) #src
save("assets/mreconstruct.png", mreconstruct(dilate, img .- 0.3, img)) #src

# [^1]: P. Soille, Morphological Image Analysis (Chapter 6.2.3). Berlin, Heidelberg: Springer Berlin Heidelberg, 2004. doi: 10.1007/978-3-662-05088-0.

"""
    strel([T], X::AbstractArray)

Convert structuring element (SE) `X` to appropriate presentation format with element type `T`.
This is a useful tool to generate SE that most ImageMorphology functions understand.

ImageMorphology currently supports two commonly used representations:

- `T=CartesianIndex`: offsets to its center point. The output type is
  `Vector{CartesianIndex{N}}`.
- `T=Bool`: connectivity mask where `true` indicates connected to its center point. The
  output type is `BitArray{N}`.

```jldoctest; setup=:(using ImageMorphology)
julia> se_mask = centered(Bool[1 1 0; 1 1 0; 0 0 0]) # connectivity mask
3×3 OffsetArray(::Matrix{Bool}, -1:1, -1:1) with eltype Bool with indices -1:1×-1:1:
 1  1  0
 1  1  0
 0  0  0

julia> se_offsets = strel(CartesianIndex, se_mask) # displacement offsets to its center point
3-element Vector{CartesianIndex{2}}:
 CartesianIndex(-1, -1)
 CartesianIndex(0, -1)
 CartesianIndex(-1, 0)

julia> se = strel(Bool, se_offsets)
3×3 OffsetArray(::BitMatrix, -1:1, -1:1) with eltype Bool with indices -1:1×-1:1:
 1  1  0
 1  1  0
 0  0  0
```

See also [`strel_diamond`](@ref) and [`strel_box`](@ref) for SE constructors for two
special cases.
"""
function strel end

strel(se) = strel(strel_type(se), se)

# convenient user interface without exporting MorphologySE
function strel(::Type{ET}, se::AbstractArray) where {ET<:CartesianIndex}
    return strel(SEOffset{strel_ndims(se)}(), se)
end
strel(::Type{ET}, se::AbstractArray) where {ET<:Bool} = strel(SEMask{strel_ndims(se)}(), se)

# conversion between different SE arrays
function strel(SET::MorphologySE, se::T) where {T}
    strel_type(se) == SET || error("unsupported conversion from type $T to $SET")
    return se
end

function strel(::SEMask{N}, offsets::AbstractArray{CartesianIndex{N}}) where {N}
    isempty(offsets) && return centered(trues(ntuple(_ -> 1, N)))
    mn, mx = extrema(offsets)
    r = ntuple(N) do i
        max(abs(mn.I[i]), abs(mx.I[i]))
    end
    sz = @. 2r + 1
    se = centered(falses(sz))
    se[offsets] .= true
    se[zero(eltype(offsets))] = true # always set center point to true
    return centered(BitArray(OffsetArrays.no_offset_view(se)))
end
strel(::SEMask{N}, mask::AbstractArray{Bool,N}) where {N} = mask

function strel(::SEOffset{N}, connectivity::AbstractArray{Bool,N}) where {N}
    all(isodd, size(connectivity)) || error("`connectivity` must be odd-sized")
    ax = axes(connectivity)
    is_symmetric = all(r -> first(r) == -last(r), ax)
    if !is_symmetric && all(first.(axes(connectivity)) .== 1)
        # To keep consistent with the "kernel" concept in ImageFiltering, we require
        # the connectivity mask to be centered as well.
        # This is a perhaps permanent depwarn to throw friendly message to the user
        # if they're used to use, e.g., `trues(3, 3)` as the input.
        msg = "connectivity mask is expected to be a centered bool array"
        hint = "Do you mean `centered(connectivity)`"
        Base.depwarn("$msg. $hint?", :strel)
    elseif !is_symmetric
        throw(ArgumentError("`connectivity` must be symmetric bool array"))
    end
    connectivity = centered(connectivity)
    # always skip center point
    return [i for i in CartesianIndices(connectivity) if connectivity[i] && !iszero(i)]
end

"""
    strel_type(x)

Infer the structuring element type for `x`.

!!! note "developer note"
    This function is used to dispatch special SE types, e.g., [`SEBoxArray`](@ref), to
    optimized implementation of particular morphology filter. In this sense it is required
    for custom SE array types to define this method.
"""
strel_type(se::MorphologySE) = se
strel_type(::AbstractArray{Bool,N}) where {N} = SEMask{N}()
strel_type(::AbstractVector{CartesianIndex{N}}) where {N} = SEOffset{N}()
strel_type(::CartesianIndices{N}) where {N} = SEOffset{N}()
strel_type(::T) where {T} = error("invalid structuring element data type: $T")

"""
    strel_size(x)

Calculate the minimal block size that contains the structuring element. The result
will be a tuple of odd integers.

```jldoctest; setup=:(using ImageMorphology; using ImageMorphology.StructuringElements)
julia> se = strel_diamond((5, 5); r=1)
5×5 SEDiamondArray{2, 2, UnitRange{$Int}, 0} with indices -2:2×-2:2:
 0  0  0  0  0
 0  0  1  0  0
 0  1  1  1  0
 0  0  1  0  0
 0  0  0  0  0

julia> strel_size(se) # is not (5, 5)
(3, 3)

julia> strel(Bool, strel(CartesianIndex, se)) # because it only checks the minimal enclosing block
3×3 OffsetArray(::BitMatrix, -1:1, -1:1) with eltype Bool with indices -1:1×-1:1:
 0  1  0
 1  1  1
 0  1  0

julia> se = [CartesianIndex(1, 1), CartesianIndex(-2, -2)];

julia> strel_size(se) # is not (4, 4)
(5, 5)

julia> strel(Bool, se) # because the connectivity mask has to be odd size
5×5 OffsetArray(::BitMatrix, -2:2, -2:2) with eltype Bool with indices -2:2×-2:2:
 1  0  0  0  0
 0  0  0  0  0
 0  0  1  0  0
 0  0  0  1  0
 0  0  0  0  0

julia> se = strel_diamond((5, 5), (1, ); r=1)
5×5 SEDiamondArray{2, 1, UnitRange{$Int}, 1} with indices -2:2×-2:2:
 0  0  0  0  0
 0  0  1  0  0
 0  0  1  0  0
 0  0  1  0  0
 0  0  0  0  0

julia> strel_size(se)
(3, 1)
```
"""
strel_size(se) = size(strel(Bool, strel(CartesianIndex, se)))

"""
    strel_ndims(x)::Int

Infer the dimension of the structuring element `x`
"""
strel_ndims(se) = strel_ndims(strel_type(se))
strel_ndims(::MorphologySE{N}) where {N} = N

"""
    bothat(img; dims=coords_spatial(img), r=1)
    bothat(img, se)

Performs morphological bottom-hat transform for given image, i.e., `closing(img, se) - img`.

$(_docstring_se)

This bottom-hat transform, also known as _black_ top-hat transform, can be used to extract
small black elements and details from an image. To extract white details, the _white_
top-hat transform [`tophat`](@ref) can be used.

# Examples

```jldoctest; setup = :(using ImageMorphology)
julia> img = falses(7, 7); img[3:5, 3:5] .= true; img[4, 6] = true; img[4, 4] = false; img
7×7 BitMatrix:
 0  0  0  0  0  0  0
 0  0  0  0  0  0  0
 0  0  1  1  1  0  0
 0  0  1  0  1  1  0
 0  0  1  1  1  0  0
 0  0  0  0  0  0  0
 0  0  0  0  0  0  0

julia> Int.(bothat(img))
7×7 Matrix{$Int}:
 0  0  0  0  0  0  0
 0  0  0  0  0  0  0
 0  0  0  0  0  0  0
 0  0  0  1  0  0  1
 0  0  0  0  0  0  0
 0  0  0  0  0  0  0
 0  0  0  0  0  0  0

julia> Int.(bothat(img, strel_diamond(img))) # use diamond shape SE
7×7 Matrix{$Int}:
 0  0  0  0  0  0  0
 0  0  0  0  0  0  0
 0  0  0  0  0  0  0
 0  0  0  1  0  0  0
 0  0  0  0  0  0  0
 0  0  0  0  0  0  0
 0  0  0  0  0  0  0
```

See also [`bothat!`](@ref) for the in-place version.
"""
bothat(img; kwargs...) = bothat!(similar(img, maybe_floattype(eltype(img))), img, similar(img); kwargs...)
bothat(img, se) = bothat!(similar(img, maybe_floattype(eltype(img))), img, se, similar(img))

"""
    bothat!(out, img, buffer; [dims], [r])
    bothat!(out, img, se, buffer)

The in-place version of [`bothat`](@ref) with input image `img` and output image `out`. The
intermediate dilation result is stored in `buffer`.
"""
function bothat!(out, img, buffer; dims=coords_spatial(img), r=nothing)
    return bothat!(out, img, strel_box(img, dims; r), buffer)
end
function bothat!(out, img, se, buffer)
    closing!(out, img, se, buffer)
    @. out = out - img
    return out
end
bothat!(out::AbstractArray{<:Color3}, img, se, buffer) = throw(ArgumentError("color image is not supported"))

"""
    SEBox{N}(axes; [r])

The N-dimensional structuring element with all elements connected. This is a special case of
[`SEMask`](@ref) that ImageMorphology algorithms might provide
optimized implementation.

It is recommended to use [`strel_box`](@ref) and [`strel_type`](@ref):

```jldoctest; setup=:(using ImageMorphology; using ImageMorphology.StructuringElements)
julia> se = strel_box((3, 3)) # C8 connectivity
3×3 SEBoxArray{2, UnitRange{$Int}} with indices -1:1×-1:1:
 1  1  1
 1  1  1
 1  1  1

julia> strel_type(se)
SEBox{2, UnitRange{$Int}}((-1:1, -1:1), (1, 1))

julia> se = centered(collect(se)) # converted to normal centered array
3×3 OffsetArray(::Matrix{Bool}, -1:1, -1:1) with eltype Bool with indices -1:1×-1:1:
 1  1  1
 1  1  1
 1  1  1

julia> strel_type(se)
SEMask{2}()
```
"""
struct SEBox{N,R} <: MorphologySE{N}
    axes::NTuple{N,R}
    r::Dims{N}
    function SEBox{N,R}(axes::NTuple{N,R}, r::Dims{N}) where {N,R<:AbstractUnitRange{Int}}
        if !all(r -> first(r) == -last(r), axes)
            throw(ArgumentError("axes must be symmetric along each dimension"))
        end
        return new{N,R}(axes, r)
    end
end
function SEBox{N}(ax::NTuple{N,R}; r=map(R -> length(R) ÷ 2, ax)) where {N,R}
    r = r isa Integer ? ntuple(_ -> r, N) : r
    return SEBox{N,R}(ax, r)
end

"""
    SEBoxArray(se::SEBox)

The instantiated array object of [`SEBox`](@ref SEBox).
"""
struct SEBoxArray{N,R<:AbstractUnitRange{Int}} <: MorphologySEArray{N}
    axes::NTuple{N,R}
    r::Dims{N}
end
SEBoxArray(se::SEBox{N,R}) where {N,R} = SEBoxArray{N,R}(se.axes, se.r)
strel_type(A::SEBoxArray{N}) where {N} = SEBox{N}(A.axes; r=A.r)
strel_size(se::SEBoxArray) = @. 1 + 2 * se.r

@inline Base.axes(A::SEBoxArray) = A.axes
@inline Base.size(A::SEBoxArray) = map(length, axes(A))
@inline function Base.getindex(A::SEBoxArray, inds::Int...)
    @inbounds for i in 1:length(inds)
        if abs(inds[i]) > A.r[i]
            return false
        end
    end
    return true
end


"""
    strel_box(A; r=1)
    strel_box(size; r=size .÷ 2)

Construct the N-dimensional structuring element (SE) with all elements in the local window
connected.

If image `A` is provided, then the SE size will be `(2r+1, 2r+1, ...)` with default
half-size `r=1`. If `size` is provided, the default `r` will be `size .÷ 2`. The default
`dims` will be all dimensions, that is, `(1, 2, ..., length(size))`.

```jldoctest; setup=:(using ImageMorphology; using ImageMorphology.StructuringElements)
julia> img = rand(64, 64);

julia> strel_box(img)
3×3 SEBoxArray{2, UnitRange{$Int}} with indices -1:1×-1:1:
 1  1  1
 1  1  1
 1  1  1

julia> strel_box(img; r=2)
5×5 SEBoxArray{2, UnitRange{$Int}} with indices -2:2×-2:2:
 1  1  1  1  1
 1  1  1  1  1
 1  1  1  1  1
 1  1  1  1  1
 1  1  1  1  1

julia> strel_box((5,5); r=(1,2))
5×5 SEBoxArray{2, UnitRange{$Int}} with indices -2:2×-2:2:
 0  0  0  0  0
 1  1  1  1  1
 1  1  1  1  1
 1  1  1  1  1
 0  0  0  0  0
```

!!! note "specialization and performance"
    The box shape `SEBox` is a special type for which many morphology algorithms may provide
    efficient implementations. For this reason, if one tries to collect an `SEBoxArray` into
    other array types (e.g. `Array{Bool}` via `collect`), then a significant performance
    drop is very likely to occur.

See also [`strel`](@ref) and [`strel_box`](@ref).
"""
function strel_box(A::AbstractArray{T,N}, dims=coords_spatial(A); r::Union{Nothing,Dims{N},Int}=nothing) where {T,N}
    dims = _to_dims(Val(N), dims)
    sz, r = if isnothing(r)
        ntuple(i -> !isempty(dims) && in(i, dims) ? 3 : 1, N), 1
    elseif r isa Dims{N}
        ntuple(i -> !isempty(dims) && in(i, dims) ? 2r[i] + 1 : 1, N), r
    elseif r isa Integer
        ntuple(i -> !isempty(dims) && in(i, dims) ? 2r + 1 : 1, N), r
    end
    return strel_box(sz, dims)
end
function strel_box(sz::Dims{N}, dims=ntuple(identity, N); r::Union{Nothing,Dims{N},Int}=nothing) where {N}
    dims = _to_dims(Val(N), dims)
    all(isodd, sz) || throw(ArgumentError("size should be odd integers"))
    radius = if isnothing(r)
        ntuple(i -> !isempty(dims) && in(i, dims) ? sz[i] ÷ 2 : 0, N)
    elseif r isa Dims{N}
        r
    elseif r isa Integer
        ntuple(i -> !isempty(dims) && in(i, dims) ? r : 0, N)
    end
    ax = map(r -> (-r):r, sz .÷ 2)
    return SEBoxArray(SEBox{N}(ax; r=radius))
end

"""
    mlaplacian(img; dims=coords_spatial(img), r=1)
    mlaplacian(img, se)

Calculate morphological laplacian of the image.

The morphological lapalacian operator is defined as `∇⁺A - ∇⁻A` where `∇⁺A` is the external
gradient `A - erode(A, se)` and `∇⁻A` is the internal gradient `dilate(A, se) - A`. Thus is
`dilate(A, se) + erode(A, se) - 2A`.

`se` is the structuring element that defines the neighborhood of the image. See
[`strel`](@ref) for more details. If `se` is not specified, then it will use the
[`strel_box`](@ref) with an extra keyword `dims` to control the dimensions to filter.

# Examples

```jldoctest; setup = :(using ImageMorphology)
julia> img = falses(7, 7); img[3:5, 3:5] .= true; img[4, 4] = false; img
7×7 BitMatrix:
 0  0  0  0  0  0  0
 0  0  0  0  0  0  0
 0  0  1  1  1  0  0
 0  0  1  0  1  0  0
 0  0  1  1  1  0  0
 0  0  0  0  0  0  0
 0  0  0  0  0  0  0

julia> Int.(mlaplacian(img))
7×7 Matrix{$Int}:
 0  0   0   0   0  0  0
 0  1   1   1   1  1  0
 0  1  -1  -1  -1  1  0
 0  1  -1   1  -1  1  0
 0  1  -1  -1  -1  1  0
 0  1   1   1   1  1  0
 0  0   0   0   0  0  0

julia> Int.(mlaplacian(img, strel_diamond(img))) # use diamond shape SE
7×7 Matrix{$Int}:
 0  0   0   0   0  0  0
 0  0   1   1   1  0  0
 0  1  -1  -1  -1  1  0
 0  1  -1   1  -1  1  0
 0  1  -1  -1  -1  1  0
 0  0   1   1   1  0  0
 0  0   0   0   0  0  0
```

## See also

- [`mlaplacian!`](@ref) is the in-place version of this function.
- [`mgradient`](@ref) for the gradient operator.
- `ImageBase.FiniteDiff` also provides a few finite difference operators, including `fdiff`,
  `fgradient`, etc.
"""
function mlaplacian(img; dims=coords_spatial(img), r=nothing)
    return mlaplacian(img, strel_box(img, dims; r))
end
function mlaplacian(img::AbstractArray{T}, se) where {T}
    out = similar(img, maybe_floattype(T))
    buffer = similar(img, maybe_floattype(T))
    return mlaplacian!(out, img, se, buffer)
end

"""
    mlaplacian!(out, img, buffer; [dims], [r])
    mlaplacian!(out, img, se, buffer)

The in-place version of [`mlaplacian`](@ref) with input image `img` and output image `out`.
The intermediate erosion result is stored in `buffer`.
"""
function mlaplacian!(out, img, buffer; dims=coords_spatial(img), r=nothing)
    return mlaplacian!(out, img, strel_box(img, dims; r), buffer)
end
function mlaplacian!(out, img, se, buffer)
    require_symmetric_strel(se)
    dilate!(out, img, se)
    erode!(buffer, img, se)
    @. out = out + buffer - 2img
    return out
end
mlaplacian!(out::AbstractArray{<:Color3}, img, se, buffer=nothing) = throw(ArgumentError("color image is not supported"))

@testset "extreme_filter" begin
    @testset "interface" begin
        img = rand(1:10, 7, 7)

        out = extreme_filter(max, img)
        @test out == extreme_filter(max, img; dims=(1, 2), r=1)

        se = strel_box(img, (1, 2); r=(1, 1))
        @test out == extreme_filter(max, img, se)

        se = strel_box(img, (1, 2); r=(1, 3))
        @test extreme_filter(max, img; dims=(1, 2), r=(1, 3)) == extreme_filter(max, img, se)

        out = similar(img)
        rst = extreme_filter!(max, out, img)
        @test rst === out
        @test out == extreme_filter!(max, out, img)

        out = similar(img)
        rst = extreme_filter!(max, out, img; dims=(1, 2), r=1)
        @test rst === out
        se = strel_box(img, (1, 2); r=(1, 1))
        ref_out = similar(img)
        extreme_filter!(max, ref_out, img, se)
        @test ref_out == out

        out = similar(img)
        rst = extreme_filter!(max, out, img; dims=(1, 2), r=(1, 3))
        @test rst === out
        se = strel_box(img, (1, 2); r=(1, 3))
        ref_out = similar(img)
        extreme_filter!(max, ref_out, img, se)
        @test ref_out == out
    end

    @testset "numerical" begin
        # Bool
        img = fill(false, 5, 5)
        img[3, 3] = 1
        ref = collect(strel_box((5, 5); r=1))

        img_d = @inferred extreme_filter(max, img)
        @test img_d == ref
        @test ref == .!extreme_filter(min, .!img) # dual property

        # Int
        A = Int[4 6 5 3 4; 8 6 9 4 8; 7 8 4 9 6; 6 2 2 1 7; 1 6 5 2 6]
        ref = [8 6 9 5 8; 8 9 9 9 8; 8 8 9 9 9; 7 8 5 9 7; 6 6 6 6 7]
        Ad = @inferred extreme_filter(max, A, strel_diamond(A))
        @test Ad == ref
        ref = [8 9 9 9 8; 8 9 9 9 9; 8 9 9 9 9; 8 8 9 9 9; 6 6 6 7 7]
        Ad = @inferred extreme_filter(max, A)
        @test Ad == ref

        # Gray{Float32}
        img = Gray{Float32}.(A ./ 9)
        img_d = @inferred extreme_filter(max, img)
        @test ref == gray.(img_d) .* 9
    end

    @testset "strel" begin
        # ensure it supports both strel representations
        A = rand(32, 32)
        se_mask = centered(collect(strel_diamond(A)))
        out = extreme_filter(max, A, se_mask)
        se_offsets = strel(CartesianIndex, se_mask)
        @test out == extreme_filter(max, A, se_offsets)
    end

    @testset "offset arrays" begin
        img = centered(rand(1:10, 32, 32))
        out = extreme_filter(max, img)
        @test out == centered(extreme_filter(max, OffsetArrays.no_offset_view(img)))
    end

    @testset "multi channel image" begin
        # supporting color image requires some reduced ordering function
        img = rand(RGB, 32, 32)
        msg = "function `max` is not a well-defined select function on type `RGB{Float64}` and `RGB{Float64}`: does `f(x::T1, y::T2)` work as expected?"
        @test_throws ArgumentError(msg) extreme_filter(max, img)

        # the test functions below don't make much sense in practice, but it's good to test them
        _to_number(c::AbstractRGB) = red(c)
        _to_number(x::Number) = x
        _select(x, y) = _to_number(x) > _to_number(y) ? x : y
        out = extreme_filter(_select, img)
        @test issubset(Set(unique(out)), Set(unique(img)))

        _select_new(x, y) = max(_to_number(x), _to_number(y))
        out = extreme_filter(_select_new, img)
        @test eltype(out) == eltype(img)
        @test sum(abs, channelview(RGB.(Gray.(out))) - channelview(out)) < 1e-4
    end

    # Ensure our various implementations of extreme_filter are equivalent by testing against
    # the generic implementation
    for (se_gen_func, se_name) in Any[(strel_diamond, "diamond"), (strel_box, "box")]
        test_name = "optimization: $se_name"
        @testset "$test_name" begin
            # ensure the optimized implementation work equivalently to the generic fallback implementation
            for T in Any[Bool, Int, N0f8, Gray{N0f8}, Gray{Float64}, Float64]
                for N in (1, 2, 3)
                    sz = N == 3 ? (32, 32, 5) : ntuple(_ -> 32, N)
                    img = T == Int ? rand(1:10, sz...) : rand(T, sz...)
                    for r in (1, 3)
                        dims_list = ntuple(i -> ntuple(identity, i), N)
                        for dims in dims_list
                            se = se_gen_func(ntuple(_ -> 2r + 1, N), dims)
                            ref = ImageMorphology._extreme_filter_generic!(max, similar(img), img, se)
                            out = extreme_filter(max, img, se)
                            @test out == ref

                            # `maybe_floattype` is used to pre-allocate the output for
                            # higher level operators (e.g., tophat) to avoid overflow
                            # behavior. We need to ensure it works correctly.
                            # https://github.com/JuliaImages/ImageMorphology.jl/issues/104
                            out = similar(img, ImageMorphology.maybe_floattype(T))
                            extreme_filter!(max, out, img, se)
                            @test out == ref

                            imgc = centered(img)
                            outc = extreme_filter(max, imgc, se)
                            @test outc == centered(out)
                        end
                    end
                end
            end
        end
    end

    @testset "optimization: bool" begin
        # ensure the optimized implementation work equivalently to the generic fallback implementation
        for N in (1, 2, 3)
            sz = ntuple(_ -> 32, N)
            img = rand(Bool, sz...)
            for r in (1, 3)
                dims_list = ntuple(i -> ntuple(identity, i), N)
                for dims in dims_list, select in (max, min)
                    se = strel_diamond(ntuple(_ -> 2r + 1, N), dims)
                    ref = ImageMorphology._extreme_filter_generic!(select, similar(img), img, se)
                    out = extreme_filter(select, img, se) # SEDiamond method
                    @test out == ref

                    se = centered(collect(se))
                    out = extreme_filter(select, img, se) # MorphologySE method
                    @test out == ref
                end
            end
        end
    end
end

"""
    overbuild(marker, mask; [dims])
    overbuild(marker, mask, se)

Reconstruction by erosion. This is an alias for [`mreconstruct`](@ref mreconstruct) with
`op=erode`.

See also the in-place version [`overbuild!`](@ref), and the dual operator
[`underbuild`](@ref).
"""
overbuild(args...; kwargs...) = mreconstruct(erode, args...; kwargs...)

"""
    overbuild!(out, marker, mask; [dims])
    overbuild!(out, marker, mask, se)

The in-place version of [`overbuild`](@ref) with output image `out` being modified in place.
"""
overbuild!(args...; kwargs...) = mreconstruct!(erode, args...; kwargs...)

# ---
# title: "`bothat`"
# id: op_bothat
# cover: assets/bothat.png
# ---

# The (black) tophat operator, also known as bottom hat, is defined as `closing(img) - img`.
# Intuitively, this filter can be used to extract small black elements and details from an
# image.

using ImageMorphology
using TestImages
using ImageBase
using ImageShow

#-

img = restrict(testimage_dip3e("fig1038")) # fingerprint

out1 = bothat(img) # default: all spatial dimensions, r=1, a box-shape SE
out2 = bothat(img; dims=(2,)) # only apply to the second dimension
out3 = bothat(img; r=5) # half-size r=5
out4 = bothat(img, strel_diamond((5, 5))) # generic SE -- this version doesn't accept `r` and `dims`

mosaic(img, out1, out2, out3, out4; nrow=1)

# ## See also

# To extract white small details, use the white [`tophat`](@ref op_tophat):

tophat(img) == bothat(complement.(img))

# For a comprehensive and more accurate documentation, please check the [`bothat`](@ref)
# reference page.

# save cover image #src
using FileIO #src
mkpath("assets") #src
img = Gray.(restrict(testimage("blobs"))) #src
save("assets/bothat.png", bothat(img; r=2)) #src

import ImageMorphology: isboundary_thick, isboundary_dilate_erode

@testset "isboundary" begin
    A = zeros(Int, 16, 16)
    A[4:8, 4:8] .= 5
    A[4:8, 9:12] .= 6
    A[10:12, 13:15] .= 3
    A[10:12, 3:6] .= 9
    OA = OffsetArray(A, -1, -1)
    FA = Float32.(A ./ 2)
    B = A .!= 0
    OB = OffsetArray(B, -1, -1)
    GB = Gray{Bool}.(B)
    normA = A ./ maximum(A)
    C = copy(A)
    C[A .== 0] .= 1
    normC = C ./ maximum(C)
    FC = Float32.(C ./ 2)
    @test sum(isboundary(A)) == 48
    @test sum(isboundary(OA)) == 48
    @test sum(isboundary(FA)) === 48.0f0
    @test sum(isboundary(Gray{Float32}.(normA))) == 48
    @test sum(isboundary(RGB{N0f8}.(normA))) .== RGB{Float64}(48, 48, 48)
    @test sum(isboundary(A; dims=1)) == 32
    @test sum(isboundary(A; dims=2)) == 32
    @test sum(isboundary(GB)) == 42
    @test sum(isboundary(B)) == 42
    @test sum(isboundary(OB)) == 42
    @test sum(isboundary(B; dims=1)) == 32
    @test sum(isboundary(B; dims=2)) == 22
    @test sum(isboundary(C)) == 107
    @test sum(isboundary(C; background=1)) == 48
    @test sum(isboundary(FC)) === 107.0f0
    @test sum(isboundary(FC; background=1 / 2)) === 48.0f0
    @test sum(isboundary(Gray{Float32}.(normC); background=0)) == 107
    @test sum(isboundary(Gray{Float32}.(normC); background=Gray{Float32}(1 / 9))) == 48
    @test sum(isboundary(RGB{N0f8}.(normC); background=RGB{N0f8}(1 / 9))) .==
        RGB{Float64}(48, 48, 48)

    # Tests from pull request #32
    # Normal Case 20x20 binary image
    img = [
        0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
        0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
        0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0
        0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0
        0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0
        0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0
        0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0
        0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0
        0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
        0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    ]
    check_img = zeros(Int, size(img))
    check_img[3, 4:15] .= 1
    check_img[8, 4:15] .= 1
    check_img[3:8, 4] .= 1
    check_img[3:8, 15] .= 1
    @test check_img == isboundary(img)

    # background = 1
    check_img = zeros(Int, size(img))
    check_img[2, 3:16] .= 1
    check_img[9, 3:16] .= 1
    check_img[2:9, 3] .= 1
    check_img[2:9, 16] .= 1
    @test check_img == isboundary(img; background=1)
end

@testset "isboundary_thick" begin
    A = zeros(Int, 16, 16)
    A[4:8, 4:8] .= 5
    A[4:8, 9:12] .= 6
    A[10:12, 13:15] .= 3
    A[10:12, 3:6] .= 9
    OA = OffsetArray(A, -1, -1)
    FA = Float32.(A ./ 2)
    B = A .!= 0
    OB = OffsetArray(B, -1, -1)
    GB = Gray{Bool}.(B)
    normA = A ./ maximum(A)
    C = copy(A)
    C[A .== 0] .= 1
    FC = Float32.(C ./ 2)
    @test sum(isboundary_thick(A)) == 107
    @test sum(isboundary_thick(OA)) == 107
    @test sum(isboundary_thick(FA)) == 107
    @test sum(isboundary_thick(Gray{Float32}.(normA))) == 107
    # MethodError: no method matching isless(::RGB{N0f8}, ::RGB{N0f8})
    @test_broken sum(isboundary_broken(RGB{N0f8}.(normA))) .== RGB{Float64}(107, 107, 107)
    @test sum(isboundary_thick(A; dims=1)) == 61
    @test sum(isboundary_thick(A; dims=2)) == 54
    @test sum(isboundary_thick(GB)) == 101
    @test sum(isboundary_thick(B)) == 101
    @test sum(isboundary_thick(OB)) == 101
    @test sum(isboundary_thick(B; dims=1)) == 61
    @test sum(isboundary_thick(B; dims=2)) == 44
    @test sum(isboundary_thick(C)) == 107
    @test sum(isboundary_thick(FC)) == 107
    img = [
        0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
        0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
        0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0
        0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0
        0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0
        0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0
        0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0
        0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 0 0 0 0 0
        0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
        0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    ]
    check_img = [
         0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
        0  0  1  1  1  1  1  1  1  1  1  1  1  1  1  1  0  0  0  0
        0  0  1  1  1  1  1  1  1  1  1  1  1  1  1  1  0  0  0  0
        0  0  1  1  0  0  0  0  0  0  0  0  0  0  1  1  0  0  0  0
        0  0  1  1  0  0  0  0  0  0  0  0  0  0  1  1  0  0  0  0
        0  0  1  1  0  0  0  0  0  0  0  0  0  0  1  1  0  0  0  0
        0  0  1  1  0  0  0  0  0  0  0  0  0  0  1  1  0  0  0  0
        0  0  1  1  1  1  1  1  1  1  1  1  1  1  1  1  0  0  0  0
        0  0  1  1  1  1  1  1  1  1  1  1  1  1  1  1  0  0  0  0
        0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0
    ]
    @test isboundary_thick(img) == check_img
end

@testset "isboundary == isboundary_thick .& image" begin
    A = zeros(Int, 16, 16)
    A[4:8, 4:8] .= 5
    A[4:8, 9:12] .= 6
    A[10:12, 13:15] .= 3
    A[10:12, 3:6] .= 9
    B = A .!= 0
    C = copy(A)
    C[A .== 0] .= 1
    @test isboundary(A) == isboundary_thick(A) .& (A .!= 0)
    @test isboundary(B) == isboundary_thick(B) .& B
    @test isboundary(B; background=false) == isboundary_thick(B) .& B
    @test isboundary(B; background=true) == isboundary_thick(B) .& .!B
    @test isboundary(B; background=-1) == isboundary_thick(B)
    @test isboundary(C) == isboundary_thick(C)
    @test isboundary(C; background=1) == isboundary_thick(C) .& (C .!= 1)
    @test isboundary(A) == isboundary_dilate_erode(A)
end

# build a random mask se with extra symmetricity constraint
function rand_se_mask(r, N; symmetric=false)
    se = centered(rand(Bool, ntuple(_ -> r, N)))
    symmetric || return se
    dual_se = copy(se)
    for i in CartesianIndices(dual_se)
        dual_se[i] = se[-i]
    end

    out = @. (Int(dual_se) + Int(se)) ÷ 2
    out[OffsetArrays.center(out)...] = 1
    return Bool.(out)
end

@testset "is_symmetric" begin
    m = Bool[
        1 0 0
        0 1 0
        0 0 1
    ]
    @test ImageMorphology.is_symmetric(m)
    @test ImageMorphology.is_symmetric(centered(m))
    mo = strel(CartesianIndex, centered(m))
    @test ImageMorphology.is_symmetric(mo)

    m = Bool[
        1 0 1
        0 1 0
        1 1 1
    ]
    mo = strel(CartesianIndex, centered(m))
    @test !ImageMorphology.is_symmetric(m)
    @test !ImageMorphology.is_symmetric(mo)

    @test ImageMorphology.is_symmetric(strel_box((3, 3)))
    @test ImageMorphology.is_symmetric(strel_diamond((3, 3)))
end

@testset "require_symmetric_strel" begin
    se = rand_se_mask(3, 2; symmetric=true)
    @test_nowarn ImageMorphology.require_symmetric_strel(se)
    se = Bool[1 0 0; 0 1 0; 0 0 0]
    msg = "structuring element must be symmetric with respect to its center"
    @test_throws ArgumentError(msg) ImageMorphology.require_symmetric_strel(se)
end

@testset "require_select_function" begin
    @test_nowarn ImageMorphology.require_select_function(max, Int)
    @test_nowarn ImageMorphology.require_select_function(min, Gray{N0f8})

    msg = "function `min` is not a well-defined select function on type `ComplexF64` and `ComplexF64`: does `f(x::T1, y::T2)` work as expected?"
    @test_throws ArgumentError(msg) ImageMorphology.require_select_function(min, ComplexF64)
    f = (x, y) -> min(x, y)
    msg = "function `$f` is not a well-defined select function on type `RGB{Float32}` and `RGB{Float32}`: does `f(x::T1, y::T2)` work as expected?"
    @test_throws ArgumentError(msg) ImageMorphology.require_select_function(f, RGB{Float32})
end

@testset "staturated" begin
    # unsigned
    @test ImageMorphology.saturating_add(N0f8(0.6), N0f8(0.6)) == N0f8(1.0)
    @test ImageMorphology.saturating_sub(N0f8(0.2), N0f8(0.6)) == N0f8(0.0)
end

"""
    tophat(img; dims=coords_spatial(img), r=1)
    tophat(img, se)

Performs morphological top-hat transform for given image, i.e., `img - opening(img, se)`.

$(_docstring_se)

This _white_ top-hat transform can be used to extract small white elements and details from
an image. To extract black details, the _black_ top-hat transform, also known as bottom-hat
transform, [`bothat`](@ref) can be used.

# Examples

```jldoctest; setup = :(using ImageMorphology)
julia> img = falses(5, 5); img[1, 1] = true; img[3:5, 3:5] .= true; img
5×5 BitMatrix:
 1  0  0  0  0
 0  0  0  0  0
 0  0  1  1  1
 0  0  1  1  1
 0  0  1  1  1

julia> Int.(tophat(img))
5×5 Matrix{$Int}:
 1  0  0  0  0
 0  0  0  0  0
 0  0  0  0  0
 0  0  0  0  0
 0  0  0  0  0

julia> Int.(tophat(img, strel_diamond(img))) # use diamond shape SE
5×5 Matrix{$Int}:
 1  0  0  0  0
 0  0  0  0  0
 0  0  1  0  0
 0  0  0  0  0
 0  0  0  0  0
```
"""
tophat(img; kwargs...) = tophat!(similar(img, maybe_floattype(eltype(img))), img, similar(img); kwargs...)
tophat(img, se) = tophat!(similar(img, maybe_floattype(eltype(img))), img, se, similar(img))

"""
    tophat!(out, img, buffer; [dims], [r])
    tophat!(out, img, se, buffer)

The in-place version of [`tophat`](@ref) with input image `img` and output image `out`. The
intermediate erosion result is stored in `buffer`.
"""
function tophat!(out, img, buffer; dims=coords_spatial(img), r=nothing)
    return tophat!(out, img, strel_box(img, dims; r), buffer)
end
function tophat!(out, img, se, buffer)
    opening!(out, img, se, buffer)
    @. out = img - out
    return out
end
tophat!(out::AbstractArray{<:Color3}, img, se, buffer) = throw(ArgumentError("color image is not supported"))

# ---
# title: "`underbuild`"
# id: op_underbuild
# cover: assets/underbuild.png
# ---

# `underbuild` is reconstruction by dilation, it is an alias for `mreconstruct` when `op=dilate`.

using ImageMorphology
using TestImages
using ImageBase
using ImageShow

img = restrict(Gray.(testimage("blob")))
nothing # hide

# `underbuild` accepts two images as inputs: `marker` and `mask`.

out = underbuild(img .- 0.2, img)
mosaic(img, out; nrow=1)

# ## See also

# [`underbuild`](@ref op_underbuild) is the dual operator of `overbuild` in the following sense:

marker, mask = rand(32, 32), rand(32, 32)
complement.(underbuild(marker, mask)) == underbuild(complement.(marker), complement.(mask))

# For more details, please refer to [`mreconstruct`](@ref op_mreconstruct).

# save cover image #src
using FileIO #src
mkpath("assets") #src
img = Gray.(restrict(testimage("blobs"))) #src
save("assets/underbuild.png", underbuild(img .- 0.2, img)) #src

"""
```
chull = convexhull(img)
```
Computes the convex hull of a binary image and returns the vertices of convex hull as a CartesianIndex array.
"""
function convexhull(img::AbstractArray{T,2}) where {T<:Union{Bool,Gray{Bool}}}

    function getboundarypoints(img)
        points = CartesianIndex{2}[]
        for j in axes(img, 2)
            v = Base.view(img, :, j)
            i1 = findfirst(v)
            if i1 != nothing
                i2 = findlast(v)
                push!(points, CartesianIndex(i1, j))
                if i1 != i2
                    push!(points, CartesianIndex(i2, j))
                end
            end
        end
        return points
    end

    function right_oriented(ref, a, b)
        return (a[2] - ref[2]) * (b[1] - ref[1]) - (b[2] - ref[2]) * (a[1] - ref[1]) < 0
    end

    function collinear(a, b, c)
        return (a[2] - c[2]) * (b[1] - c[1]) - (b[2] - c[2]) * (a[1] - c[1]) == 0
    end

    dist2(a, b) = sum(abs2, (a - b).I)

    function angularsort!(points, ref, img)
        last_point = ref

        for i in eachindex(points)
            if points[i] == last_point
                deleteat!(points, i)
                break
            end
        end

        sort!(points; lt=(a, b) -> right_oriented(last_point, a, b))

        i = 0
        while i <= length(points)
            i = i + 1
            if i + 1 > length(points)
                break
            end

            if collinear(last_point, points[i], points[i + 1])
                if dist2(last_point, points[i]) < dist2(last_point, points[i + 1])
                    deleteat!(points, i)
                else
                    deleteat!(points, i + 1)
                end
                i = i - 1
            end
        end
    end

    # Used Graham scan algorithm

    points = getboundarypoints(img)
    last_point = CartesianIndex(map(r -> first(r) - 1, axes(img)))
    for point in points
        if point[2] > last_point[2] || (point[2] == last_point[2] && point[1] > last_point[1])
            last_point = point
        end
    end
    angularsort!(points, last_point, img)

    n_points = length(points)

    if n_points < 3
        error("Not enough points to compute convex hull.")
    end

    convex_hull = CartesianIndex{2}[]
    push!(convex_hull, last_point)
    push!(convex_hull, points[1])
    push!(convex_hull, points[2])

    for i in 3:n_points
        while (
            right_oriented(convex_hull[end], convex_hull[end - 1], points[i]) ||
            collinear(convex_hull[end], convex_hull[end - 1], points[i])
        )
            pop!(convex_hull)
        end
        push!(convex_hull, points[i])
    end

    return convex_hull
end

import Base.isless
import Base.isgreater
import DataStructures.PriorityQueue

"""
    low_leveling(op, marker, mask; [dims])
    low_leveling(op, marker, mask, se)

A function g is an lower leveling of a function f if and only if 
for any couple of neighbouring pixels (p, q) g(p)>g(q)->g(p)>=f
This algorithm modify marker to become a high_leveling of ref

The `dims` keyword is used to specify the dimension to process by constructing the box shape
structuring element [`strel_box(marker; dims)`](@ref strel_box). For generic structuring
element, the half-size is expected to be either `0` or `1` along each dimension.

# See also
 [`high_leveling`](@ref),[`leveling`](@ref),
 [`underbuild`](@ref),[`overbuild`](@ref)
 
# References
- [1] 'From connected operators to levelings' [Meyer,1998] In ISMM '98: Proceedings of the fourth international symposium on Mathematical morphology and its applications to image and signal processingJune 1998 Pages 191–198
- [2] 'Mathematical Morphology: From Theory to Applications' chap6 [Serra et al.] https://doi.org/10.1002/9781118600788.ch8 
"""
function low_leveling(ref, marker; dims=coords_spatial(marker))
    return low_leveling(ref, marker, strel_box(marker, dims))
end
function low_leveling(ref, marker, se)
    return low_leveling!(similar(ref), ref, marker, se)
end

function low_leveling!(out, ref, marker; dims=coords_spatial(marker))
    return low_leveling!(out, ref, marker, strel_box(marker, dims))
end
function low_leveling!(out, ref, marker, se)
    return _low_leveling!(out, ref, marker, se)
end
function _low_leveling!(out::AbstractArray{T,N}, ref::AbstractArray{T,N}, marker::AbstractArray{T,N}, se) where {T<:ImageCore.NumberLike,N}
    axes(out) == axes(ref) == axes(marker) || throw(DimensionMismatch("images should have the same axes"))

    # For generic structuring element, the half-size should to be either `0` or `1` along
    # each dimension. See also section 6.2.3 of [2].
    se_size = strel_size(se)
    if length(se_size) != N
        msg = "the input structuring element is not for $N dimensional array, instead it is for $(length(se_size)) dimensional array"
        throw(DimensionMismatch(msg))
    end
    if !all(x -> in(x, (1, 3)), strel_size(se))
        msg = "structuring element with half-size larger than 1 is invalid"
        throw(DimensionMismatch(msg))
    end
    se = strel(CartesianIndex, se)
    out = copy(marker)

    # declare priority queue, store position of pixel associated with priority 
    pq = PriorityQueue{CartesianIndex{N},T}()
    R = CartesianIndices(axes(out))
    for i in R
        if @inbounds out[i] < ref[i]
            current_max = out[i]
            for Δi in se # examine neighborhoods
                ii = i + Δi
                if checkbounds(Bool, R, ii) #check that we are in the image
                    @inbounds current_max = max(current_max, out[ii])
                end
            end
            if @inbounds current_max != out[i]
                out[i] = min(ref[i], current_max)
                push!(pq, i => out[i])
            end
            # else posponed to the end
        end
    end
    # Loop until all pixel have been examined 
    while !isempty(pq)
        curr_idx, _ = popfirst!(pq)
        for Δi in se # examine neighborhoods
            ii = curr_idx + Δi
            if checkbounds(Bool, R, ii) #check that we are in the image
                @inbounds if out[ii] < out[curr_idx] && out[ii] < ref[ii]
                    new_value = min(ref[ii], out[curr_idx])
                    if out[ii] != new_value
                        out[ii] = new_value
                        pq[ii] = new_value
                    end
                end
            end
        end
    end
    #Post-processing, so that we have nicer levelings
    #(L-= inf( ref, dilate(mark)) , and L+=sup(ref,erode(mark)),
    #and thus L(ref,mark)=L-( L+(ref,mark),mark) and they commute)
    out .= min.(out, ref)
    return out
end

"""
    high_leveling(op, marker, mask; [dims])
    high_leveling(op, marker, mask, se)

A function g is an upper leveling of a function f if and only if for any couple of 
neighbouring pixels (p, q) g(p)>g(q)->g(p)<=f
This algorithm modify marker to become a high_leveling of ref

The `dims` keyword is used to specify the dimension to process by constructing the box shape
structuring element [`strel_box(marker; dims)`](@ref strel_box). For generic structuring
element, the half-size is expected to be either `0` or `1` along each dimension.

# See also
 [`low_leveling`](@ref),[`leveling`](@ref),
 [`underbuild`](@ref),[`overbuild`](@ref)
 
# References
- [1] 'From connected operators to levelings' [Meyer,1998] In ISMM '98: Proceedings of the fourth international symposium on Mathematical morphology and its applications to image and signal processingJune 1998 Pages 191–198
- [2] 'Mathematical Morphology: From Theory to Applications' chap6 [Serra et al.] https://doi.org/10.1002/9781118600788.ch8 
"""
function high_leveling(ref, marker; dims=coords_spatial(marker))
    return high_leveling(ref, marker, strel_box(marker, dims))
end
function high_leveling(ref, marker, se)
    return high_leveling!(similar(ref), ref, marker, se)
end

function high_leveling!(out, ref, marker; dims=coords_spatial(marker))
    return high_leveling!(out, ref, marker, strel_box(marker, dims))
end
function high_leveling!(out, ref, marker, se)
    return _high_leveling!(out, ref, marker, se)
end
function _high_leveling!(out::AbstractArray{T,N}, ref::AbstractArray{T,N}, marker::AbstractArray{T,N}, se) where {T<:ImageCore.NumberLike,N}
    axes(out) == axes(ref) == axes(marker) || throw(DimensionMismatch("images should have the same axes"))

    # For generic structuring element, the half-size should to be either `0` or `1` along
    # each dimension. See also section 6.2.3 of [2].
    se_size = strel_size(se)
    if length(se_size) != N
        msg = "the input structuring element is not for $N dimensional array, instead it is for $(length(se_size)) dimensional array"
        throw(DimensionMismatch(msg))
    end
    if !all(x -> in(x, (1, 3)), strel_size(se))
        msg = "structuring element with half-size larger than 1 is invalid"
        throw(DimensionMismatch(msg))
    end

    se = strel(CartesianIndex, se)
    out = copy(marker)

    # declare priority queue, store position of pixel associated with priority 
    pq = PriorityQueue{CartesianIndex{N},T}()
    R = CartesianIndices(axes(out))
    for i in R
        @inbounds if out[i] > ref[i]
            current_min = out[i]
            for Δi in se # examine neighborhoods
                ii = i + Δi
                if checkbounds(Bool, R, ii) #check that we are in the image
                    @inbounds current_min = min(current_min, out[ii])
                end
            end
            if @inbounds current_min != out[i]
                out[i] = max(ref[i], current_min)
                push!(pq, i => out[i])
            end
            # else posponed to the end
        end
    end
    # Loop until all pixel have been examined 
    while !isempty(pq)
        curr_idx, _ = popfirst!(pq)
        for Δi in se # examine neighborhoods
            ii = curr_idx + Δi
            if checkbounds(Bool, R, ii) #check that we are in the image
                @inbounds if out[ii] > out[curr_idx] && out[ii] > ref[ii]
                    new_value = max(ref[ii], out[curr_idx])
                    if out[ii] != new_value
                        out[ii] = new_value
                        pq[ii] = new_value
                    end
                end
            end
        end
    end
    #Post-processing, so that we have nicer levelings
    #(L-= inf( ref, dilate(mark)) , and L+=sup(ref,erode(mark)),
    #and thus L(ref,mark)=L-( L+(ref,mark),mark) and they commute)
    out .= max.(out, ref)
    return out
end

"""
leveling(ref, marker)

A function g is a leveling of a function f if and only if it is both an upper and a lower leveling of the function f 
This algorithm modify g (a copy of the marker) to become a leveling of f (the ref)

 # See also
 [`low_leveling](@ref),[`high_leveling`](@ref),
 [`underbuild`](@ref),[`overbuild`](@ref)
 
 # References
 1.'From connected operators to levelings' [Meyer,1998] In ISMM '98: Proceedings of the fourth international symposium on Mathematical morphology and its applications to image and signal processingJune 1998 Pages 191–198
 2.'Mathematical Morphology: From Theory to Applications' chap6 [Serra et al.] https://doi.org/10.1002/9781118600788.ch8 
"""
function leveling(ref, marker; dims=coords_spatial(marker))
    return leveling(ref, marker, strel_box(marker, dims))
end
function leveling(ref, marker, se)
    return leveling!(similar(ref), ref, marker, se)
end

function leveling!(out, ref, marker; dims=coords_spatial(marker))
    return leveling!(out, ref, marker, strel_box(marker, dims))
end
function leveling!(out, ref, marker, se)
    return _leveling!(out, ref, marker, se)
end

function _leveling!(out, ref, marker, se)
    tmp = _high_leveling!(out, ref, marker, se)
    return _low_leveling!(out, tmp, marker, se)
end

"""
```
cleared_img = clearborder(img)
cleared_img = clearborder(img, width)
cleared_img = clearborder(img, width, background)
```
Returns a copy of the original image after clearing objects connected to the border of the image.
Parameters:
 -  img          = Binary/Grayscale input image
 -  width        = Width of the border examined (Default value is 1)
 -  background   = Value to be given to pixels/elements that are cleared (Default value is 0)
"""
function clearborder(img::AbstractArray, width::Integer=1, background::Integer=0)

    for i in size(img)
        if (width > i)
            throw(ArgumentError("Border width must not be greater than size of the image."))
        end
    end

    labels = label_components(img, strel_box(img))
    number = maximum(labels) + 1

    dimensions = size(img)
    outerrange = CartesianIndices(map(i -> 1:i, dimensions))
    innerrange = CartesianIndices(map(i -> (1 + width):(i - width), dimensions))

    border_labels = Set{Int}()
    for i in EdgeIterator(outerrange, innerrange)
        push!(border_labels, labels[i])
    end

    new_img = similar(img)
    for itr in eachindex(labels)
        if labels[itr] in border_labels
            new_img[itr] = background
        else
            new_img[itr] = img[itr]
        end
    end

    return new_img

end

"""
    opening(img; dims=coords_spatial(img), r=1)
    opening(img, se)

Perform the morphological opening on `img`. The opening operation is defined as erosion
followed by a dilation: `dilate(erode(img, se), se)`.

$(_docstring_se)

# Examples

```jldoctest; setup = :(using ImageMorphology)
julia> img = trues(7,7); img[2, 2] = false; img[3:5, 3:5] .= false; img[4, 4] = true; img
7×7 BitMatrix:
 1  1  1  1  1  1  1
 1  0  1  1  1  1  1
 1  1  0  0  0  1  1
 1  1  0  1  0  1  1
 1  1  0  0  0  1  1
 1  1  1  1  1  1  1
 1  1  1  1  1  1  1

julia> opening(img)
7×7 BitMatrix:
 0  0  1  1  1  1  1
 0  0  1  1  1  1  1
 1  1  0  0  0  1  1
 1  1  0  0  0  1  1
 1  1  0  0  0  1  1
 1  1  1  1  1  1  1
 1  1  1  1  1  1  1

julia> opening(img, strel_diamond(img)) # use diamond shape SE
7×7 BitMatrix:
 1  1  1  1  1  1  1
 1  0  1  1  1  1  1
 1  1  0  0  0  1  1
 1  1  0  0  0  1  1
 1  1  0  0  0  1  1
 1  1  1  1  1  1  1
 1  1  1  1  1  1  1
```

## See also

- [`opening!`](@ref) is the in-place version of this function.
- [`closing`](@ref) is the dual operator of `opening` in the sense that
  `complement.(opening(img)) == closing(complement.(img))`.
"""
opening(img; kwargs...) = opening!(similar(img), img, similar(img); kwargs...)
opening(img, se) = opening!(similar(img), img, se, similar(img))

"""
    opening!(out, img, buffer; [dims], [r])
    opening!(out, img, se, buffer)

The in-place version of [`opening`](@ref) with input image `img` and output image `out`. The
intermediate erosion result is stored in `buffer`.
"""
function opening!(out, img, buffer; dims=coords_spatial(img), r=nothing)
    return opening!(out, img, strel_box(img, dims; r), buffer)
end
function opening!(out, img, se, buffer)
    erode!(buffer, img, se)
    dilate!(out, buffer, se)
    return out
end
opening!(out::AbstractArray{<:Color3}, img, se, buffer) = throw(ArgumentError("color image is not supported"))

@testset "connectivity neighborhoods" begin
    @test @inferred(ImageMorphology.neighbor_cartesian_offsets(CartesianIndex{1}, 1)) ==
        ImageMorphology.neighbor_cartesian_offsets(CartesianIndex{1}, 2) ==
        [CartesianIndex{1}(-1), CartesianIndex{1}(1)]
    conn2d_4 = ImageMorphology.neighbor_cartesian_offsets(CartesianIndex{2}, 1)
    @test conn2d_4 == [
        CartesianIndex{2}(0, -1),
        CartesianIndex{2}(-1, 0),
        CartesianIndex{2}(1, 0),
        CartesianIndex{2}(0, 1),
    ]
    @test @inferred(ImageMorphology.neighbor_cartesian_offsets(CartesianIndex{2}, 2)) == [
        CartesianIndex{2}(-1, -1),
        CartesianIndex{2}(0, -1),
        CartesianIndex{2}(1, -1),
        CartesianIndex{2}(-1, 0),
        CartesianIndex{2}(1, 0),
        CartesianIndex{2}(-1, 1),
        CartesianIndex{2}(0, 1),
        CartesianIndex{2}(1, 1),
    ]
    @test ImageMorphology.linear_offsets(conn2d_4, fill(0, (1, 1))) == [-1, -1, 1, 1]
    @test ImageMorphology.linear_offsets(conn2d_4, fill(0, (2, 2))) == [-2, -1, 1, 2]
    @test @inferred(ImageMorphology.linear_offsets(conn2d_4, fill(0, (3, 3)))) ==
        [-3, -1, 1, 3]
    @test @inferred(ImageMorphology.linear_offsets(conn2d_4, fill(0, (7, 9)))) ==
        [-7, -1, 1, 7]
end

const CI2 = CartesianIndex{2}

bbox2d(x1, y1, x2, y2) = (CI2(x1, y1), CI2(x2, y2))

@testset "MaxTree construction" begin
    A = [
        15 13 16
        11 12 10
        16 11 14
    ]
    mtree = MaxTree(A; connectivity=1, rev=false) # test kwargs defaults
    @test mtree isa MaxTree{2}
    @test mtree == MaxTree(A) # test kwargs defaults
    @test isequal(mtree, MaxTree(A))
    @test ndims(mtree) == 2
    @test size(mtree) == size(A)
    @test axes(mtree) == axes(A)
    @test length(mtree) == length(A)
    @test !mtree.rev
    @test mtree.parentindices == [
        4 5 4
        8 2 8
        2 2 2
    ]
    @test mtree.traverse == [8, 2, 6, 5, 4, 9, 1, 3, 7]
    @test areas(mtree) == [1 3 1; 8 4 9; 1 1 1]
    @test diameters(mtree) == [1 3 1; 3 3 3; 1 1 1]
    @test boundingboxes(mtree) == [
        bbox2d(1, 1, 1, 1) bbox2d(1, 1, 1, 3) bbox2d(1, 3, 1, 3)
        bbox2d(1, 1, 3, 3) bbox2d(1, 1, 2, 3) bbox2d(1, 1, 3, 3)
        bbox2d(3, 1, 3, 1) bbox2d(3, 2, 3, 2) bbox2d(3, 3, 3, 3)
    ]

    # test 8-neighborhood
    mtree2 = MaxTree(A; connectivity=2)
    @test !mtree2.rev
    @test mtree2 != mtree
    @test mtree2.parentindices == [
        4 5 4
        8 2 8
        5 2 5
    ]
    @test mtree2.traverse == [8, 2, 6, 5, 4, 9, 1, 3, 7]
    @test areas(mtree2) == [1 3 1; 8 6 9; 1 1 1]
    @test diameters(mtree2) == [1 3 1; 3 3 3; 1 1 1]
    @test boundingboxes(mtree2) == [
        bbox2d(1, 1, 1, 1) bbox2d(1, 1, 1, 3) bbox2d(1, 3, 1, 3)
        bbox2d(1, 1, 3, 3) bbox2d(1, 1, 3, 3) bbox2d(1, 1, 3, 3)
        bbox2d(3, 1, 3, 1) bbox2d(3, 2, 3, 2) bbox2d(3, 3, 3, 3)
    ]

    # test reverse (brightest to darkest) MaxTree
    mtree_rev = MaxTree(A; rev=true)
    @test mtree_rev.rev
    A = [
        15 13 16
        11 12 10
        16 11 14
    ]
    @test mtree_rev.parentindices == [
        3 9 3
        5 4 5
        3 5 1
    ]
    @test mtree_rev.traverse == [3, 7, 1, 9, 4, 5, 2, 6, 8]
    @test areas(mtree_rev) == [7 5 1; 1 4 1; 9 1 6]
    @test diameters(mtree_rev) == [3 3 1; 1 3 1; 3 1 3]
    @test boundingboxes(mtree_rev) == [
        bbox2d(1, 1, 3, 3) bbox2d(1, 1, 3, 3) bbox2d(1, 3, 1, 3)
        bbox2d(2, 1, 2, 1) bbox2d(2, 1, 3, 3) bbox2d(2, 3, 2, 3)
        bbox2d(1, 1, 3, 3) bbox2d(3, 2, 3, 2) bbox2d(1, 1, 3, 3)
    ]

    # test reverse 8-neighborhood MaxTree
    mtree2_rev = MaxTree(A; rev=true, connectivity=2)
    @test mtree2_rev.rev
    @test mtree2_rev.parentindices == [
        3 9 3
        5 4 2
        3 2 1
    ]
    @test mtree2_rev.traverse == [3, 7, 1, 9, 4, 5, 2, 6, 8]
    @test areas(mtree2_rev) == [7 5 1; 3 4 1; 9 1 6]
    @test diameters(mtree2_rev) == [3 3 1; 3 3 1; 3 1 3]
    @test boundingboxes(mtree2_rev) == [
        bbox2d(1, 1, 3, 3) bbox2d(1, 1, 3, 3) bbox2d(1, 3, 1, 3)
        bbox2d(2, 1, 3, 3) bbox2d(2, 1, 3, 3) bbox2d(2, 3, 2, 3)
        bbox2d(1, 1, 3, 3) bbox2d(3, 2, 3, 2) bbox2d(1, 1, 3, 3)
    ]

    # degenerated cases
    A00 = fill(0, (0, 0))
    mtree00 = MaxTree(A00; connectivity=1, rev=false)
    @test mtree00 isa MaxTree{2}
    @test areas(mtree00) == Matrix{Int}(undef, 0, 0)

    A11 = fill(0, (1, 1))
    mtree11 = MaxTree(A11; connectivity=2, rev=false)
    @test mtree11 isa MaxTree{2}
    @test areas(mtree11) == fill(1, (1, 1))

    A101 = fill(0, (1, 0, 1))
    mtree101 = MaxTree(A101; connectivity=2, rev=false)
    @test mtree101 isa MaxTree{3}
    @test diameters(mtree101) == Array{Int}(undef, 1, 0, 1)

    # test grayscale
    @test MaxTree(Gray.(A ./ 255)) isa MaxTree{2}

    # test offset arrays
    Am11 = OffsetArray(A, -1, -1)
    am11_tree = MaxTree(Am11; connectivity=1, rev=false)
    @test size(am11_tree) == size(Am11)
    @test am11_tree.parentindices == mtree.parentindices
end

@testset "local_minima/maxima()" begin
    A = [
        15 13 16
        11 12 10
        16 11 14
    ]
    @test local_maxima(A) == [
        3 0 1
        0 0 0
        2 0 4
    ]
    B = similar(A, Float64)
    @test local_maxima!(B, A) === B
    @test B == float(local_maxima(A))

    @test_throws DimensionMismatch local_maxima!(fill(0, (2, 2)), A)

    @test local_maxima(A; connectivity=2) == [3 0 1; 0 0 0; 2 0 4]
    atree = MaxTree(A)
    atree_rev = MaxTree(A; rev=true)
    @test_throws MethodError local_maxima(A, atree, connectivity=2)
    @test_throws ArgumentError local_maxima(A, atree_rev)

    # test local_minima
    @test local_minima(A) == [
        0 0 0
        3 0 1
        0 2 0
    ]
    @test local_minima(A; connectivity=2) == [
        0 0 0
        0 0 1
        0 0 0
    ]
    @test local_minima!(B, A) === B
    @test B == float(local_minima(A))
    @test_throws DimensionMismatch local_minima!(fill(0, (4, 2)), A)

    @test local_minima(A, atree_rev; connectivity=2) == local_minima(A)
    @test_throws ArgumentError local_minima(A, atree)

    # test grayscale
    @test local_maxima(Gray.(A ./ 255)) == [3 0 1; 0 0 0; 2 0 4]
    @test local_minima(Gray.(A ./ 255)) == [0 0 0; 3 0 1; 0 2 0]

    # test offset arrays
    Am11 = OffsetArray(A, -1, -1)
    @test axes(local_maxima(Am11)) == axes(Am11)
    @test collect(local_maxima(Am11)) == local_maxima(A)
    @test axes(local_minima(Am11)) == axes(Am11)
    @test collect(local_minima(Am11)) == local_minima(A)
end

@testset "area_opening/closing()" begin
    A = [
        3 1 3 1 4 4
        1 3 1 1 3 3
        1 1 1 1 1 1
        1 4 4 1 1 2
        1 4 1 1 5 5
        1 1 1 2 5 2
    ]
    B = similar(A)
    @test B === area_opening!(B, A)
    @test_throws DimensionMismatch area_opening!(similar(A, (7, 6)), A)
    atree = MaxTree(A)
    atree_rev = MaxTree(A; rev=true)
    atree_small = MaxTree(A[1:5, 2:6])
    @test B == area_opening(A, atree)
    @test_throws ArgumentError area_opening(A, atree_rev)
    @test_throws DimensionMismatch area_opening(A, atree_small)
    @test area_opening(A; min_area=3) == [
        1 1 1 1 3 3
        1 1 1 1 3 3
        1 1 1 1 1 1
        1 4 4 1 1 2
        1 4 1 1 5 5
        1 1 1 2 5 2
    ]
    @test area_opening(A; min_area=1) == A
    @test area_opening(A; min_area=5) == [
        1 1 1 1 1 1
        1 1 1 1 1 1
        1 1 1 1 1 1
        1 1 1 1 1 2
        1 1 1 1 2 2
        1 1 1 2 2 2
    ]
    @test area_opening(A; min_area=45) == fill(0, (6, 6)) # image less than min_area

    mA = .-A
    mB = similar(mA)
    @test mB === area_closing!(mB, mA)
    @test_throws DimensionMismatch area_closing!(similar(A, (7, 6)), A)
    matree = MaxTree(mA)
    matree_rev = MaxTree(mA; rev=true)
    @test mB == area_closing(mA, atree_rev)
    @test_throws ArgumentError area_closing(mA, matree)
    @test area_closing(mA; min_area=3) == .-area_opening(A; min_area=3)

    # test grayscale
    @test area_opening(Gray.(A ./ 255)) == area_opening(A)
    @test area_closing(Gray.(A ./ 255)) == area_closing(A)

    # test offset arrays
    Am11 = OffsetArray(A, -1, -1)
    @test axes(area_opening(Am11)) == axes(Am11)
    @test collect(area_opening(Am11)) == area_opening(A)
    @test axes(area_closing(Am11)) == axes(Am11)
    @test collect(area_closing(Am11)) == area_closing(A)
end

@testset "diameter_opening/closing()" begin
    A = [
        3 1 3 1 3 4
        1 3 1 1 4 3
        1 1 4 1 1 3
        1 4 4 1 1 2
        1 4 1 1 1 2
        1 1 1 2 5 1
    ]
    B = similar(A)
    @test B === diameter_opening!(B, A)
    @test_throws DimensionMismatch diameter_opening!(similar(A, (7, 6)), A)
    atree = MaxTree(A)
    atree_rev = MaxTree(A; rev=true)
    atree_small = MaxTree(A[1:5, 2:6])
    @test B == diameter_opening(A, atree)
    @test_throws ArgumentError diameter_opening(A, atree_rev)
    @test_throws DimensionMismatch diameter_opening(A, atree_small)
    @test diameter_opening(A; min_diameter=3) == [
        1 1 1 1 3 3
        1 1 1 1 3 3
        1 1 4 1 1 3
        1 4 4 1 1 2
        1 4 1 1 1 2
        1 1 1 1 1 1
    ]
    @test diameter_opening(A; min_diameter=1) == A
    @test diameter_opening(A; min_diameter=3, connectivity=2) == [
        3 1 3 1 3 3
        1 3 1 1 3 3
        1 1 4 1 1 3
        1 4 4 1 1 2
        1 4 1 1 1 2
        1 1 1 2 2 1
    ]
    @test diameter_opening(A; min_diameter=5, connectivity=2) == [
        3 1 3 1 2 2
        1 3 1 1 2 2
        1 1 3 1 1 2
        1 3 3 1 1 2
        1 3 1 1 1 2
        1 1 1 2 2 1
    ]
    @test diameter_opening(A; min_diameter=45) == fill(0, (6, 6)) # image less than min_diameter

    mA = .-A
    mB = similar(mA)
    @test mB === diameter_closing!(mB, mA)
    @test_throws DimensionMismatch diameter_closing!(similar(A, (7, 6)), A)
    matree = MaxTree(mA)
    matree_rev = MaxTree(mA; rev=true)
    @test mB == diameter_closing(mA, atree_rev)
    @test_throws ArgumentError diameter_closing(mA, matree)
    @test diameter_closing(mA; min_diameter=3) == .-diameter_opening(A; min_diameter=3)

    # test grayscale
    @test diameter_opening(Gray.(A ./ 255)) == diameter_opening(A)
    @test diameter_closing(Gray.(A ./ 255)) == diameter_closing(A)

    # test offset arrays
    Am11 = OffsetArray(A, -1, -1)
    @test axes(diameter_opening(Am11)) == axes(Am11)
    @test collect(diameter_opening(Am11)) == diameter_opening(A)
    @test axes(diameter_closing(Am11)) == axes(Am11)
    @test collect(diameter_closing(Am11)) == diameter_closing(A)
end

@testset "feature_transform" begin
    function ind2cart(F)
        s = CartesianIndices(axes(F))
        return map(i -> CartesianIndex(s[i]), F)
    end
    @testset "Square Images" begin
        # (1)
        A = [true false; false true]
        F = feature_transform(A)
        @test F == ind2cart([1 1; 1 4])
        D = distance_transform(F)
        @test D == [0 1; 1 0]

        # (2)
        A = [true true; false true]
        F = feature_transform(A)
        @test F == ind2cart([1 3; 1 4])
        D = distance_transform(F)
        @test D == [0 0; 1 0]

        # (3)
        A = [false false; false true]
        F = feature_transform(A)
        @test F == ind2cart([4 4; 4 4])
        D = distance_transform(F)
        @test D ≈ [sqrt(2) 1.0; 1.0 0.0]

        # (4)
        A = [true false true; false true false; true true false]
        F = feature_transform(A)
        @test F == ind2cart([1 1 7; 1 5 5; 3 6 6])
        D = distance_transform(F)
        @test D == [0 1 0; 1 0 1; 0 0 1]

        # (5)
        A = [false false true; true true false; true true true]
        F = feature_transform(A)
        @test F == ind2cart([2 5 7; 2 5 5; 3 6 9])
        D = distance_transform(F)
        @test D == [1 1 0; 0 0 1; 0 0 0]

        # (6)
        A = [
            true false true true
            false true false false
            false true true false
            true false false false
        ]
        F = feature_transform(A)
        @test F == ind2cart([1 1 9 13; 1 6 6 13; 4 7 11 11; 4 4 11 11])
        D = distance_transform(F)
        @test D ≈ [0.0 1.0 0.0 0.0; 1.0 0.0 1.0 1.0; 1.0 0.0 0.0 1.0; 0.0 1.0 1.0 sqrt(2)]
    end

    @testset "Rectangular Images" begin
        # (1)
        A = [true false true; false true false]
        F = feature_transform(A)
        @test F == ind2cart([1 1 5; 1 4 4])
        D = distance_transform(F)
        @test D == [0 1 0; 1 0 1]

        # (2)
        A = [true false; false false; false true]
        F = feature_transform(A)
        @test F == ind2cart([1 1; 1 6; 6 6])
        D = distance_transform(F)
        @test D == [0 1; 1 1; 1 0]

        # (3)
        A = [
            true false false
            true false false
            false true true
            true true true
            false true false
        ]
        F = feature_transform(A)
        @test F == ind2cart([1 1 1; 2 2 13; 2 8 13; 4 9 14; 4 10 10])
        D = distance_transform(F)
        @test D == [0.0 1.0 2.0; 0.0 1.0 1.0; 1.0 0.0 0.0; 0.0 0.0 0.0; 1.0 0.0 1.0]

        @test feature_transform(Gray.(A)) == F
    end

    @testset "Corner Case Images" begin
        null1 = CartesianIndex((typemin(Int),))
        null2 = CartesianIndex((typemin(Int), typemin(Int)))
        # (1)
        A = [false]
        F = feature_transform(A)
        @test F == [null1]
        D = distance_transform(F)
        @test D == [Inf]

        # (2)
        A = [true]
        F = feature_transform(A)
        @test F == ind2cart([1])
        D = distance_transform(F)
        @test D == [0]

        # (3)
        A = [true false]
        F = feature_transform(A)
        @test F == ind2cart([1 1])
        D = distance_transform(F)
        @test D == [0 1]

        # (4)
        A = [false; false]
        F = feature_transform(A)
        @test F == [null1; null1]
        D = distance_transform(F)
        @test D == [Inf; Inf]

        # (5)
        A = [true; true]
        F = feature_transform(A)
        @test F == ind2cart([1; 2])
        D = distance_transform(F)
        @test D == [0; 0]

        # (6)
        A = [true; true; false]
        F = feature_transform(A)
        @test F == ind2cart([1; 2; 2])
        D = distance_transform(F)
        @test D == [0; 0; 1]

        # (7)
        A = falses(3, 3)
        F = feature_transform(A)
        @test all(x -> x == null2, F)
        D = distance_transform(F)
        @test all(x -> x == Inf, D)

        # (8)
        A = trues(4, 2, 3)
        F = feature_transform(A)
        @test F == ind2cart(reshape(1:length(A), size(A)))
        D = distance_transform(F)
        @test all(x -> x == 0, D)

        # (9)
        A = falses(4, 2, 3)
        A[3, 1, 2] = true
        @test all(==(CartesianIndex(3, 1, 2)), feature_transform(A))
    end

    @testset "Anisotropic images" begin
        A, w = [false false; false true], (3, 1)
        F = feature_transform(A; weights=w)
        @test F == ind2cart([4 4; 4 4])
        D = distance_transform(F, w)
        @test D ≈ [sqrt(10) 3.0; 1.0 0.0]

        A, w = [false false; false true], (1, 3)
        F = feature_transform(A; weights=w)
        @test F == ind2cart([4 4; 4 4])
        D = distance_transform(F, w)
        @test D ≈ [sqrt(10) 1.0; 3.0 0.0]

        A, w = [true false; false true], (3, 1)
        F = feature_transform(A; weights=w)
        @test F == ind2cart([1 1; 4 4])
        D = distance_transform(F, w)
        @test D == [0 1; 1 0]

        A, w = [true false; false true], (1, 3)
        F = feature_transform(A; weights=w)
        @test F == ind2cart([1 4; 1 4])
        D = distance_transform(F, w)
        @test D == [0 1; 1 0]
    end
end

nothing

"""
    underbuild(marker, mask; [dims])
    underbuild(marker, mask, se)

Reconstruction by dilation. This is an alias for [`mreconstruct`](@ref mreconstruct) with
`op=dilate`.

See also the in-place version [`underbuild!`](@ref), and the dual operator
[`overbuild`](@ref).
"""
underbuild(args...; kwargs...) = mreconstruct(dilate, args...; kwargs...)

"""
    underbuild!(out, marker, mask; [dims])
    underbuild!(out, marker, mask, se)

The in-place version of [`underbuild`](@ref) with output image `out` being modified in
place.
"""
underbuild!(args...; kwargs...) = mreconstruct!(dilate, args...; kwargs...)

ref_mreconstruct(::typeof(dilate), args...; kwargs...) = ref_mreconstruct((dilate, min), args...; kwargs...)
ref_mreconstruct(::typeof(erode), args...; kwargs...) = ref_mreconstruct((erode, max), args...; kwargs...)
function ref_mreconstruct((op, select), marker, mask; dims=coords_spatial(mask))
    return ref_mreconstruct((op, select), marker, mask, strel_box(marker, dims))
end
function ref_mreconstruct((op, select), marker, mask, se)
    # maximum iteration limit to spread top-left pixel to entire image
    max_iter = maximum(size(mask))
    out = select.(mask, marker)
    has_changed = true
    n = 1
    while has_changed && n < max_iter
        old = out
        out = select.(op(out, se), mask)
        has_changed = !(old == out) # must be == instead of ≈
        n += 1
    end
    return out
end

@testset "mreconstruct" begin
    @testset "API" begin
        mask, marker = rand(11, 11), rand(11, 11)
        out1 = mreconstruct(dilate, marker, mask)
        out2 = similar(mask)
        out2 = mreconstruct!(dilate, out2, marker, mask)
        @test out1 == out2
        @test axes(out1) == (1:11, 1:11)

        # ensure the eltype can be mixed
        mask, marker = rand(Gray{Float64}, 11, 11), rand(N0f8, 11, 11)
        out1 = mreconstruct(dilate, marker, mask)
        @test eltype(out1) == Gray{Float64}
        out2 = mreconstruct(dilate, mask, marker)
        @test out1 != out2 # the result changes if swapping the order
        @test eltype(out2) == Gray{Float64}

        se = strel_diamond((7, 7))
        msg = @capture_err mreconstruct(dilate, marker, mask, se)
        @test occursin("structuring element with half-size larger than 1 is invalid, only the center 3×3 values are used", msg)
        ref = mreconstruct(dilate, marker, mask)
        @test ref == @suppress_err mreconstruct(dilate, marker, mask, se)

        msg = "operation `max` is not supported for `mreconstruct`"
        @test_throws ErrorException(msg) mreconstruct(max, marker, mask)
        msg = "`marker` and `mask` should have the same axes"
        @test_throws DimensionMismatch(msg) mreconstruct(dilate, rand(10), rand(3))
        msg = "the input structuring element is not for 1 dimensional array, instead it is for 2 dimensional array"
        @test_throws DimensionMismatch(msg) mreconstruct(dilate, rand(10), rand(10), strel_box((3, 3)))
        @test_throws MethodError mreconstruct(dilate, rand(10), rand(10), strel_box((3,)); dims=1)
    end

    @testset "numeric" begin
        # 1D
        marker = [0, 0, 0, 3, 0]
        mask = [0, 0, 6, 5, 6]
        ref_out = [0, 0, 3, 3, 3]
        @test ref_out == ref_mreconstruct(dilate, marker, mask)
        out = mreconstruct(dilate, marker, mask)
        @test ref_out == out

        # 2D -- marker > mask for non-zero values
        marker = [0 0 0 0 0; 0 9 0 0 0; 0 0 0 0 0; 0 0 0 5 0; 0 0 0 0 0; 0 9 0 0 0]
        mask = [9 0 0 0 0; 0 8 7 1 0; 0 9 0 4 0; 0 0 0 4 0; 0 0 6 5 6; 0 0 9 8 9]
        ref_out = [8 0 0 0 0; 0 8 7 1 0; 0 8 0 4 0; 0 0 0 4 0; 0 0 4 4 4; 0 0 4 4 4]
        out = mreconstruct(dilate, marker, mask)
        @test out == ref_out
        @test ref_out == ref_mreconstruct(dilate, marker, mask)
        ref_out = [0 0 0 0 0; 0 8 7 1 0; 0 8 0 4 0; 0 0 0 4 0; 0 0 4 4 4; 0 0 4 4 4]
        out = mreconstruct(dilate, marker, mask, strel_diamond(marker))
        @test out == ref_out
        @test ref_out == ref_mreconstruct(dilate, marker, mask, strel_diamond(marker))

        # 2D -- marker > mask for non-zero values doesn't hold
        marker = [0 0 0 0 0; 0 9 0 0 0; 0 0 0 0 0; 0 0 0 3 0; 0 0 0 0 0; 0 9 0 0 0]
        mask = [0 0 0 0 0; 0 8 7 1 0; 0 9 0 4 0; 0 0 0 4 0; 0 0 6 5 6; 0 0 9 8 9]
        ref_out = [0 0 0 0 0; 0 8 7 1 0; 0 8 0 4 0; 0 0 0 4 0; 0 0 4 4 4; 0 0 4 4 4]
        out = mreconstruct(dilate, marker, mask)
        @test out == ref_out

        # 3D
        marker = zeros(5, 6, 3)
        marker[3, 4, 2] = 3

        mask = zeros(5, 6, 3)
        mask[3, 4, 1] = 4
        mask[2, 3:5, 2] = [5, 5, 5]
        mask[3, 3:5, 2] = [4, 4, 4]
        mask[4, 3:5, 2] = [4, 4, 4]
        mask[3, 4, 2] = 6
        mask[3, 4, 3] = 4

        ref_out = zeros(5, 6, 3)
        ref_out[3, 4, 1] = 3
        ref_out[2, 3:5, 2] = [3, 3, 3]
        ref_out[3, 3:5, 2] = [3, 3, 3]
        ref_out[4, 3:5, 2] = [3, 3, 3]
        ref_out[3, 4, 3] = 3
        out = mreconstruct(dilate, marker, mask)
        @test out == ref_out
        @test ref_out == ref_mreconstruct(dilate, marker, mask)

        # extensive numeric test against different types
        for T in Any[Bool, Int, N0f8, Gray{N0f8}, Gray{Float64}, Float64]
            for N in (1, 2, 3)
                sz = N == 3 ? (32, 32, 5) : ntuple(_ -> 32, N)
                mask = T == Int ? rand(1:10, sz...) : rand(T, sz...)
                dims_list = ntuple(i -> ntuple(identity, i), N)
                for dims in dims_list
                    marker = T == Int ? rand(1:10, sz...) : rand(T, sz...)
                    for op in Any[erode, dilate]
                        ref_out = ref_mreconstruct(op, marker, mask; dims)
                        out = mreconstruct(op, marker, mask; dims)
                        @test out == ref_out

                        outc = mreconstruct(op, centered(marker), centered(mask); dims)
                        @test outc == centered(out)
                    end

                    # duality
                    mask = T == Int ? rand(1:10, sz...) : rand(T, sz...)
                    marker = T == Int ? rand(1:10, sz...) : rand(T, sz...)
                    out1 = mreconstruct(dilate, marker, mask)
                    out2 = mreconstruct(erode, complement.(marker), complement.(mask))
                    @test out1 == complement.(out2)
                end
            end
        end
    end
end

"""
    mgradient(img; mode=:beucher, dims=coords_spatial(img), r=1)
    mgradient(img, se; mode=:beucher)

Calculate morphological gradient of the image using given mode.

There are three widely used modes[1]:

- `:beucher`: the default mode. It calculates the arithmetic difference between the dilation
  and the erosion -- `dilate(img, se) - erode(img, se)`.
- `:internal`: also known as _half-gradient by erosion_. It calculates the arithmetic
  difference between the original image and its erosion -- `img - erode(img, se)`.
- `:external`: also known as _half-gradient by dilation_. It calculates the arithmetic
  difference between dilation and the original image -- `dilate(img, se) - se`.

$(_docstring_se)

# Examples

```jldoctest; setup = :(using ImageMorphology)
julia> img = falses(7, 7); img[3:5, 3:5] .= true; img
7×7 BitMatrix:
 0  0  0  0  0  0  0
 0  0  0  0  0  0  0
 0  0  1  1  1  0  0
 0  0  1  1  1  0  0
 0  0  1  1  1  0  0
 0  0  0  0  0  0  0
 0  0  0  0  0  0  0

julia> Int.(mgradient(img)) # default mode :beucher always creates a two-pixel wide boundary
7×7 Matrix{$Int}:
 0  0  0  0  0  0  0
 0  1  1  1  1  1  0
 0  1  1  1  1  1  0
 0  1  1  0  1  1  0
 0  1  1  1  1  1  0
 0  1  1  1  1  1  0
 0  0  0  0  0  0  0

julia> Int.(mgradient(img; mode=:internal)) # half-gradient -- the boundary is internal to original image
7×7 Matrix{$Int}:
 0  0  0  0  0  0  0
 0  0  0  0  0  0  0
 0  0  1  1  1  0  0
 0  0  1  0  1  0  0
 0  0  1  1  1  0  0
 0  0  0  0  0  0  0
 0  0  0  0  0  0  0

julia> Int.(mgradient(img; mode=:external)) # half-gradient -- the boundary is external to original image
7×7 Matrix{$Int}:
 0  0  0  0  0  0  0
 0  1  1  1  1  1  0
 0  1  0  0  0  1  0
 0  1  0  0  0  1  0
 0  1  0  0  0  1  0
 0  1  1  1  1  1  0
 0  0  0  0  0  0  0

julia> Int.(mgradient(img, strel_diamond(img))) # use diamond shape SE
7×7 Matrix{$Int}:
 0  0  0  0  0  0  0
 0  0  1  1  1  0  0
 0  1  1  1  1  1  0
 0  1  1  0  1  1  0
 0  1  1  1  1  1  0
 0  0  1  1  1  0  0
 0  0  0  0  0  0  0
```

The beucher operator is a self-complementary operator in the sense that `mgradient(img, se;
mode=:beucher) == mgradient(complement.(img), se; mode=:beucher)`. When `r>1`, it is usually
called _thick gradient_. If a line segment is used as `se`, then the gradient becomes the
_directional gradient_.

## See also

- [`mgradient!`](@ref) is the in-place version of this function.
- [`mlaplacian`](@ref) for the laplacian operator.
- `ImageBase.FiniteDiff` also provides a few finite difference operators, including `fdiff`,
  `fgradient`, etc.

## References

- [1] Rivest, Jean-Francois, Pierre Soille, and Serge Beucher. "Morphological gradients."
  Journal of Electronic Imaging 2.4 (1993): 326-336.
"""
function mgradient(img; dims=coords_spatial(img), r=nothing, mode=:beucher)
    return mgradient(img, strel_box(img, dims; r); mode)
end
function mgradient(img::AbstractArray{T}, se; mode=:beucher) where {T}
    out = similar(img, maybe_floattype(T))
    buffer = _make_gradient_buffer(img, mode)
    return mgradient!(out, img, se, buffer; mode)
end

"""
    mgradient!(out, img, buffer; [dims], [r], [mode])
    mgradient!(out, img, se, buffer; [mode])

The in-place version of [`mgradient`](@ref) with input image `img` and output image `out`.

The `buffer` array is required for `:beucher` mode. For `:internal` and `:external` modes,
`buffer` is not needed and can be `nothing`.
"""
function mgradient!(out, img, buffer; dims=coords_spatial(img), r=nothing, mode=:beucher)
    return mgradient!(out, img, strel_box(img, dims; r), buffer; mode)
end

function mgradient!(out, img, se, @nospecialize(buffer); mode=:beucher)
    require_symmetric_strel(se)
    @debug "calculate mgradient using $mode mode"
    if mode == :beucher
        isnothing(buffer) && throw(ArgumentError("buffer array is required for mode :beucher"))
        _beucher_gradient!(out, img, se, buffer)
    elseif mode == :internal
        _internal_gradient!(out, img, se)
    elseif mode == :external
        _external_gradient!(out, img, se)
    end
    return out
end
mgradient!(out::AbstractArray{<:Color3}, img, se, buffer; kwargs...) = throw(ArgumentError("color image is not supported"))

_make_gradient_buffer(img, mode) = mode == :beucher ? similar(img, maybe_floattype(eltype(img))) : nothing

function _internal_gradient!(out, img, se)
    erode!(out, img, se)
    @. out = img - out
    return out
end

function _external_gradient!(out, img, se)
    dilate!(out, img, se)
    @. out = out - img
    return out
end

function _beucher_gradient!(out, img, se, buffer)
    dilate!(out, img, se)
    erode!(buffer, img, se)
    @. out = out - buffer
    return out
end

module FeatureTransform

using ..ImageMorphology: SplitAxis, SplitAxes
using ..ImageCore

export feature_transform, distance_transform

"""
    feature_transform(img::AbstractArray{Bool, N};
                      weights=nothing, nthreads=Threads.nthreads()) -> F

Compute the feature transform of a binary image `I`, finding the
closest "feature" (positions where `I` is `true`) for each location in
`I`.  Specifically, `F[i]` is a `CartesianIndex` encoding the position
closest to `i` for which `I[F[i]]` is `true`.  In cases where two or
more features in `I` have the same distance from `i`, an arbitrary
feature is chosen. If `I` has no `true` values, then all locations are
mapped to an index where each coordinate is `typemin(Int)`.

Optionally specify the weight `w` assigned to each coordinate.  For
example, if `I` corresponds to an image where voxels are anisotropic,
`w` could be the voxel spacing along each coordinate axis. The default
value of `nothing` is equivalent to `w=(1,1,...)`.

See also: [`distance_transform`](@ref).

# Citation

- [1] Maurer, Calvin R., Rensheng Qi, and Vijay Raghavan. "A linear time algorithm for
  computing exact Euclidean distance transforms of binary images in arbitrary dimensions."
  _IEEE Transactions on Pattern Analysis and Machine Intelligence_ 25.2 (2003): 265-270.
"""
function feature_transform(
    img::AbstractArray{<:Union{Bool,AbstractGray{Bool}},N};
    weights::Union{Nothing,NTuple{N}}=nothing,
    nthreads::Int=length(img) < 1000 ? 1 : Threads.nthreads(),
) where {N}
    nthreads > 0 || error("the number of threads must be positive, got $nthreads")
    N == 0 && return reshape([CartesianIndex()])
    # Allocate the output
    F = similar(img, CartesianIndex{N})
    axsimg = axes(img)
    # To allocate temporary storage for voronoift!, compute one
    # element (so we have the proper type)
    fi = first(CartesianIndices(axsimg))
    drft = DistRFT(fi, weights, (), Base.tail(fi.I))
    if nthreads == 1 || N == 1
        tmp = typeof(drft)[]
        computeft!(F, img, axsimg, CartesianIndex(), weights, tmp)
        # Finish the last dimension (for multithreading, we avoid doing it in computeft!)
        finishft!(F, img, axsimg, CartesianIndex(), weights, tmp)
    else
        tmps = [typeof(drft)[] for _ in 1:nthreads] # temporary storage (one per thread)
        saxs = SplitAxes(axsimg, nthreads - 0.2)   # give main thread less work since it also schedules the others
        tasks = [Threads.@spawn computeft!(F, img, saxs[i], CartesianIndex(), weights, tmps[i]) for i in 2:nthreads]
        computeft!(F, img, saxs[1], CartesianIndex(), weights, tmps[1])
        foreach(wait, tasks)
        # Finish the last dimension
        saxs1 = SplitAxes(axsimg[1:(N - 1)], nthreads - 0.2)
        tasks = [Threads.@spawn finishft!(F, img, (saxs1[i]..., axsimg[end]), CartesianIndex(), weights, tmps[i]) for i in 2:nthreads]
        finishft!(F, img, (saxs1[1]..., axsimg[end]), CartesianIndex(), weights, tmps[1])
        foreach(wait, tasks)
    end
    return F
end

"""
    distance_transform(F::AbstractArray{CartesianIndex}, [w=nothing]) -> D

Compute the distance transform of `F`, where each element `F[i]`
represents a "target" or "feature" location assigned to `i`.
Specifically, `D[i]` is the distance between `i` and `F[i]`.
Optionally specify the weight `w` assigned to each coordinate; the
default value of `nothing` is equivalent to `w=(1,1,...)`.

See also: [`feature_transform`](@ref).
"""
function distance_transform(F::AbstractArray{CartesianIndex{N},N}, w::Union{Nothing,NTuple{N}}=nothing) where {N}
    # To allocate the proper output type, compute the distance for one element
    R = CartesianIndices(axes(F))
    dst = wnorm2(zero(eltype(R)), w)
    D = similar(F, typeof(sqrt(dst)))

    ∅ = nullindex(F)
    @inbounds for i in R
        fi = F[i]
        D[i] = fi == ∅ ? Inf : sqrt(wnorm2(fi - i, w))
    end

    return D
end

# This recursive implementation computes the feature transform, other than for finishing the
# work along the final axis (axis `N` for an `N` dimensional array).
# Omission of the final axis makes it easy to implement multithreading.
# You can finish the final axis with a call to `finishft!` with `jpost = CartesianIndex()`.
function computeft!(F, img, axsimg, jpost::CartesianIndex{K}, pixelspacing, tmp) where {K}
    # tmp is workspace for voronoift!
    ∅ = nullindex(F)                             # sentinel position
    if K == ndims(img) - 1                           # innermost loop (d=1 case, line 1)
        # Fig. 2, lines 2-8
        @inbounds @simd for i1 in axes(img, 1)
            F[i1, jpost] = gray(img[i1, jpost]) ? CartesianIndex(i1, jpost) : ∅
        end
    else                                         # recursively handle trailing dimensions
        # Fig. 2, lines 10-12
        for i1 in axsimg[ndims(img) - K]
            computeft!(F, img, axsimg, CartesianIndex(i1, jpost), pixelspacing, tmp)
        end
    end
    K == 0 && return F                           # defer the final axis, where threads will be split across next-to-last axis
    return finishft!(F, img, axsimg, jpost, pixelspacing, tmp)
end

function finishft!(F, img, axsimg, jpost, pixelspacing, tmp)
    # Fig. 2, lines 14-20
    axespre = truncatet(axsimg, jpost)          # first N-K-1 axes (these are "finished" within each K+1-dimensional slice)
    for jpre in CartesianIndices(axespre)
        voronoift!(F, img, jpre, jpost, pixelspacing, tmp)     # finish axis N-K in K-dimensional slice `jpost`
    end
    return F
end

function voronoift!(F, img, jpre, jpost, pixelspacing, tmp)
    d = length(jpre) + 1   # axis to work along
    ∅ = nullindex(F)
    empty!(tmp)
    for i in axes(img, d)
        # Fig 3, lines 3-13
        xi = CartesianIndex(jpre, i, jpost)
        @inbounds fi = F[xi]
        if fi != ∅
            fidist = DistRFT(fi, pixelspacing, jpre, jpost)
            if length(tmp) < 2
                push!(tmp, fidist)
            else
                @inbounds while length(tmp) >= 2 && removeft(tmp[end - 1], tmp[end], fidist)
                    pop!(tmp)
                end
                push!(tmp, fidist)
            end
        end
    end
    nS = length(tmp)
    nS == 0 && return F
    # Fig 3, lines 18-24
    l = 1
    @inbounds fthis = tmp[l].fi
    for i in axes(img, d)
        xi = CartesianIndex(jpre, i, jpost)
        d2this = wnorm2(xi - fthis, pixelspacing)
        while l < nS
            @inbounds fnext = tmp[l + 1].fi
            d2next = wnorm2(xi - fnext, pixelspacing)
            if d2this > d2next
                d2this, fthis = d2next, fnext
                l += 1
            else
                break
            end
        end
        @inbounds F[xi] = fthis
    end
    return F
end

## Utilities

# Stores a feature location and its distance from the hyperplane Rd
struct DistRFT{N,T}
    fi::CartesianIndex{N}
    dist2::T
    d::Int  # the coordinate in dimension d
end

"""
    DistRFT(fi::CartesianIndex, w, jpre, jpost)

Bundles a feature `fi` together with its distance from the line Rd,
where Rd is specified by `(jpre..., :, jpost...)`. `w` is the
weighting applied to each coordinate, and must be `nothing` or be a
tuple with the same number of coordiantes as `fi`.

"""
function DistRFT(fi::CartesianIndex, w, jpre::CartesianIndex, jpost::CartesianIndex)
    d2pre, ipost, wpost = dist2pre(fi.I, w, jpre.I)
    d2post = wnorm2(CartesianIndex(ipost) - jpost, wpost)
    @inbounds fid = fi[length(jpre) + 1]
    return DistRFT(fi, d2pre + d2post, fid)
end
function DistRFT(fi::CartesianIndex, w, jpre::Tuple, jpost::Tuple)
    return DistRFT(fi, w, CartesianIndex(jpre), CartesianIndex(jpost))
end

@inline function removeft(u, v, w)
    a, b, c = v.d - u.d, w.d - v.d, w.d - u.d
    return c * v.dist2 - b * u.dist2 - a * w.dist2 > a * b * c
end

"""
    truncatet(inds, j::CartesianIndex{K})

Discard the last `K+1` elements of the tuple `inds`.
"""
truncatet(inds, j::CartesianIndex) = _truncatet((), inds, j)
_truncatet(out, inds::NTuple{N}, j::CartesianIndex{N}) where {N} = Base.front(out)
@inline _truncatet(out, inds, j) = _truncatet((out..., inds[1]), Base.tail(inds), j)

if VERSION < v"1.1"
    nullindex(A::AbstractArray{T,N}) where {T,N} = typemin(Int) * one(CartesianIndex{N})
else
    # This is the proper implementation
    nullindex(A::AbstractArray{T,N}) where {T,N} = typemin(Int) * oneunit(CartesianIndex{N})
end

"""
    wnorm2(x::CartesianIndex, w)

Compute `∑ (w[i]*x[i])^2`.  Specifying `nothing` for `w` is equivalent to `w = (1,1,...)`.
"""
wnorm2(x::CartesianIndex, w) = _wnorm2(0, x.I, w)
_wnorm2(s, ::Tuple{}, ::Nothing) = s
_wnorm2(s, ::Tuple{}, ::Tuple{}) = s
@inline _wnorm2(s, x, w::Nothing) = _wnorm2(s + sqr(x[1]), Base.tail(x), w)
@inline _wnorm2(s, x, w) = _wnorm2(s + sqr(w[1] * x[1]), Base.tail(x), Base.tail(w))

"""
    dist2pre(x, w, jpre) -> s, xpost, wpost

`s` is equivalent to `wnorm2(x[1:length(jpre)]-jpre, w)`. `xpost` and
`wpost` contain the trailing indices of `x` and `w` (skipping the
element `length(jpre)+1`).
"""
dist2pre(x::Tuple, w, jpre) = _dist2pre(0, x, w, jpre)
_dist2pre(s, x, w::Nothing, ::Tuple{}) = s, Base.tail(x), w
_dist2pre(s, x, w, ::Tuple{}) = s, Base.tail(x), Base.tail(w)
@inline function _dist2pre(s, x, w::Nothing, jpre)
    return _dist2pre(s + sqr(x[1] - jpre[1]), Base.tail(x), w, Base.tail(jpre))
end
@inline function _dist2pre(s, x, w, jpre)
    return _dist2pre(s + sqr(w[1] * (x[1] - jpre[1])), Base.tail(x), Base.tail(w), Base.tail(jpre))
end

@inline sqr(x) = x * x

end # module

```@setup concept_se
using ImageMorphology
using ImageBase
using TestImages
```

# [Structuring element](@id concept_se)

Structuring Element (SE) is the key concept in morphology to indicate the connectivity and the
neighborhood. This page explains this structuring element concept, and how ImageMorphology supports
the general SEs without compromising the performance on the most commonly used special SE cases.

## The erosion example

The erosion `erode` function in its simplest 1-dimensional case can be defined as

$$\varepsilon_A[p] = min(A[p-1], A[p], A[p+1])$$

Because the output value at position $p$ not only depends on its own pixel `A[p]` but also on
its neighborhood values `A[p-1]` and `A[p+1]`, we call this type of operation a _neighborhood
image transformation_.

Now comes the question: **if we try to generalize the `erode` function, what should we do?** --
we would like to generalize the concept of "neighborhood".

## Two neighborhood representations

By saying "$\Omega_p$ is the neighborhood of $p$", we are expressing `p in Ωₚ` in plain Julia. For
performance consideration, this `Ωₚ` is usually generated from the `(p, Ω)` pair. `p` is the center
point that changes during the iteration, and `Ω` is usually a pre-defined and unchanged data which
contains the neighborhood and shape information. We call this `Ω` a _structuring element_. There are
usually two ways to express `Ω`:

- **displacement offset**: a list of `CartesianIndex` to indicate the offset to the center point `p`
- **connectivity mask**: a bool array mask to indicate the connectivity to the center point `p`

For instance, in the following code block we build a commonly named C4 connectivity in the 2-dimensional case:

```@example concept_se
# displacement offset
Ω_offsets = [
    CartesianIndex(-1, 0),
    CartesianIndex(0, -1),
    CartesianIndex(0, 1),
    CartesianIndex(1, 0),
]

# connectivity mask
Ω_bool = Bool[
    0 1 0
    1 1 1
    0 1 0
]
nothing #hide
```

If `p=CartesianIndex(3, 3)`, then we know `p=CartesianIndex(3, 4)` is in `Ωₚ`.

Now, back to the erosion example. Based on the displacement offset representation, the simplest
generic version of `erode` can be implemented quite simply:

```@example concept_se
# For illustration only, performance can be greatly improved using iteration to eliminate allocations
function my_erode(A, Ω)
    out = similar(A)
    R = CartesianIndices(A)
    for p in R
        Ωₚ = filter!(q->in(q, R), Ref(p) .+ Ω)
        # here we don't assume p in Ωₚ
        out[p] = min(A[p], minimum(A[Ωₚ]))
    end
    return out
end
nothing #hide
```

```@example concept_se
using ImageMorphology
using ImageBase
using TestImages

img = Gray.(testimage("morphology_test_512"))
img = Gray.(img .< 0.8)
img_e = my_erode(img, Ω_offsets)
mosaic(img, img_e; nrow=1)
```

As you may realize, the displacement offset representation is convenient to use when implementing
algorithms, but it is hard to visualize. In contrast, the connectivity mask is not so convenient to
use when implementing algorithms, but it is easy to visualize. For instance, one can very easily
understand the following SE at the first glance:

```@example concept_se
Ω = Bool[1 1 1; 1 1 0; 0 0 0] # hide
```

but not

```@example concept_se
strel(CartesianIndex, Ω) # hide
```

## The `strel` function

This package supports the conversion between different SE representations via the [`strel`](@ref)
helper function. `strel` is the short name for "STRucturing ELement".

To convert a connectivity mask representation to displacement offset representation:

```@example concept_se
Ω_mask = Bool[1 1 1; 1 1 0; 0 0 0] |> centered
Ω_offsets = strel(CartesianIndex, Ω_mask)
```

!!! note "zero-centered mask"
    The mask array is expected to be zero-centered. That means, the axes of a 3×3 mask `axes(se)`
    should be `(-1:1, -1:1)`. The [`centered`](@ref OffsetArrays.centered) function is used to shift
    the center point of the array to `(0, 0, ..., 0)`.
    ```julia
    julia> A = centered([1 2 3; 4 5 6; 7 8 9])
    3×3 OffsetArray(::Matrix{Int64}, -1:1, -1:1) with eltype Int64 with indices -1:1×-1:1:
     1  2  3
     4  5  6
     7  8  9

    julia> A[-1, -1], A[0, 0], A[1, 1] # top-left, center, bottom-right
    (1, 5, 9)
    ```
    This `centered` function comes from [OffsetArrays.jl](https://github.com/JuliaArrays/OffsetArrays.jl)
    and is also exported by ImageMorphology.


And to convert back from a displacement offset representation to connectivity mask representation:

```@example concept_se
strel(Bool, Ω_offsets)
```

Quite simple, right? Thus to make our `my_erode` function more generic, we only need to add one
single line:

```diff
 function my_erode(A, Ω)
     out = similar(A)
+    Ω = strel(CartesianIndex, Ω)
     R = CartesianIndices(A)
```

## [Symmetricity](@id concept_symmetric)

Among all the structuring elements, the symmetric ones are used most in practice -- they have better
properties and their symmetry enables certain implementation optimizations.

The SE symmetricity is defined with respect to the center point for the mask representation `mask =
strel(Bool, se)`: `se` is symmetric if `mask[I] == mask[-I]` holds for `I ∈ CartesianIndices(mask)`.
-- This is also why mask representation requires a `centered` array.

```@example concept_se
se = centered(Bool[
    1 0 1
    0 1 0
    1 0 1
])
ImageMorphology.is_symmetric(se) # true

se = centered(Bool[
    1 1 1
    0 1 0
    1 0 1
])
ImageMorphology.is_symmetric(se) # false

se = [CartesianIndex(1), CartesianIndex(-1)]
ImageMorphology.is_symmetric(se) # true

se = [CartesianIndex(1)]
ImageMorphology.is_symmetric(se) # false
nothing #hide
```

## Convenient constructors

Among all the SE possibilities, this package provides constructors for two commonly used cases:

- diamond-like constructor: [`strel_diamond`](@ref)
- box-like constructor: [`strel_box`](@ref)

```@repl concept_se
strel_diamond((3, 3)) # immediate neighborhood: C4 connectivity
strel_diamond((3, 3), (1, )) # along the first dimension
strel_box((3, 3)) # all adjacent neighborhood: C8 connectivity
strel_box((3, 3), (1, ))
```

Utilizing these constructors, we can provide an easier-to-use `my_erode(A, [dims])` interface by
adding one more method:

```julia
my_erode(A, dims::Dims=ntuple(identity, ndims(A))) = my_erode(A, strel_diamond(A, dims))
```

!!! tip "Performance tip: keep the array type"
    For the structuring element `Ω` generated from `strel_diamond` and `strel_box`, it is likely
    to hit a fast path if you keep its array type. For instance, `erode(A, strel_diamond(A))` is
    usually faster than `erode(A, Array(strel_diamond(A)))` because more information of the `Ω`
    shape is passed to Julia during coding and compilation.

## Performance optimizations and the `strel_type` function

Thanks to Julia's multiple dispatch mechanism, we can provide all the optimization tricks without
compromising the simple user interface. This can be programmatically done with the help of the
`strel_type` function. For example, if you know a very efficient `erode` implementation for the C4
connectivity SE, then you can add it incrementally:

```julia
using ImageMorphology: MorphologySE, SEDiamond

my_erode(A, dims::Dims) = my_erode(A, strel_diamond(A, dims))
my_erode(A, Ω) = _my_erode(strel_type(Ω), A, Ω)

# the generic implementation we've written above
function _my_erode(::MorphologySE, A, Ω)
   ...
end

# the optimized implementation for SE generated from `strel_diamond` function
function _my_erode(::SEDiamond, A, Ω)
   ...
end

# ... and other optimized versions, if there are
```

In essence, `strel_type` is a trait function to assist the dispatch and code design:

```@repl concept_se
strel_type(Ω_mask)
```

It returns an internal object `SEMask{2}()`. This might look scary at first glance, but it's quite a
simple lookup table that reflects our previous reasoning:

| representation          | element type     | `strel_type` |
| ----------------------- | ---------------- | ------------ |
| displacement offset     | `CartesianIndex` | `SEOffset`   |
| connectivity mask       | `Bool`           | `SEMask`     |
| [`strel_diamond`](@ref) | `Bool`           | `SEDiamond`  |
| [`strel_box`](@ref)     | `Bool`           | `SEBox`      |

# [Morphology Operators](@id op_index)

This page describes the interfaces for the basic morphology operators that you can use to build your
own pipeline. To easily visualize the effect of different operators, the "blobs" image is used to
build the cover image.

```@example
using TestImages, ImageBase
restrict(testimage("blobs"))
```

!!! note "color image is not supported"
    Unless explicitly used, most operations in this package don't support color images. This is
    because many morphological operation is based on pixel value comparisons `min`, `max`, `>` and
    `<` -- they are not well-defined for `RGB` type.

!!! note "🚧 work in progress"
    This page contains only a subset of exported functions. The missing ones will be added in the
    future. You might need to check the heavy [reference](@ref reference_index) page to find out
    what you need. Contributions are welcome!

{{{democards}}}

# [Reference](@id reference_index)

## [Structuring element](@id reference_se)

```@docs
# conversion
strel

# constructor
strel_chain
strel_product
strel_box
strel_diamond

# helpers
strel_type
strel_size
ImageMorphology.StructuringElements.strel_ndims
ImageMorphology.StructuringElements.strel_split
OffsetArrays.centered
OffsetArrays.center
OffsetArrays.OffsetVector
OffsetArrays.OffsetMatrix
OffsetArrays.OffsetArray
OffsetArrays.Origin

ImageMorphology.StructuringElements.is_symmetric

## types
ImageMorphology.StructuringElements.SEMask
ImageMorphology.StructuringElements.SEOffset
ImageMorphology.StructuringElements.SEDiamond
ImageMorphology.StructuringElements.SEBox
ImageMorphology.StructuringElements.SEDiamondArray
ImageMorphology.StructuringElements.SEBoxArray
```

## [Morphological operations](@id reference_ops)

```@docs
extreme_filter
extreme_filter!
dilate
dilate!
erode
erode!
opening
opening!
closing
closing!
tophat
tophat!
bothat
bothat!
mgradient
mgradient!
mlaplacian
mlaplacian!
```

## Geodesic operations

```@docs
mreconstruct
mreconstruct!
underbuild
underbuild!
overbuild
overbuild!
```

## Components and segmentation

```@docs
label_components
label_components!
component_boxes
component_lengths
component_indices
component_centroids
component_subscripts
label_flatzones
imfill
```

## Max tree

```@docs
MaxTree
areas
boundingboxes
diameters
area_opening
area_opening!
area_closing
area_closing!
diameter_opening
diameter_opening!
diameter_closing
diameter_closing!
local_maxima!
local_maxima
local_minima!
local_minima
ImageMorphology.rebuild!
ImageMorphology.filter_components!
```

## Feature transform

```@docs
feature_transform
distance_transform
clearborder
```

## Regional extrema

```@docs
hmaxima
hminima
regional_maxima
regional_minima
```

## Thinning

```@docs
GuoAlgo
thinning
```

## Leveling

```@docs
leveling
high_leveling
low_leveling
```

## Misc

```@docs
convexhull
isboundary
isboundary!
ImageMorphology.isboundary_thick
```

# ImageMorphology.jl

This package provides morphology operations for structure analysis and image processing.

!!! info "setup"
    ImageMorphology is a sub-package of the umbrella package Images.jl -- either `using
    Images` or `using ImageMorphology` will give you access to this functionality.

## Installation

Just like all normal Julia packages, you can use
[Pkg](https://pkgdocs.julialang.org/v1/getting-started/) to install it:

```julia
pkg> add ImageMorphology # hit ] to enter Pkg mode
```

## Learn

The perhaps quickest way to use this library is to find a set of useful operators from the
[gallery](@ref op_index) and build your own pipeline from it.

For any advanced usage, we recommend you to read the "Concept" part. For instance, many morphology
operation supports generic ["structuring element"](@ref concept_se).

## Overview

The following tables give an overview of ImageMorphology functionalities.

!!! note "🚧 work in progress"
    This overview is not yet finished and only contains a subset of exported functions. The missing
    functions will be added in the future. You might still need to check the heavy [reference](@ref
    reference_index) page to find out what you need. Contributions are welcome!

### Structuring Element (SE)

Structuring element is the key concept in morphology. If you're not familiar with this, please read
[concept: structuring element](@ref concept_se) first.

| name                          | summary |
| :---------------------------- | :------ |
| [`strel`](@ref)               | convert between different SE representations    |
| [`strel_type`](@ref)          | infer the SE type                               |
| [`strel_size`](@ref)          | get the minimal block size that contains the SE |
| [`strel_chain`](@ref) and [`strel_product`](@ref) | compose multiple SEs into a bigger one |
| [`strel_box`](@ref)           | construct a box-shaped SE, e.g., C8, C26 connectivity |
| [`strel_diamond`](@ref)       | construct a diamond-shaped SE, e.g., C4, C6 connectivity |
| [`centered`](@ref OffsetArrays.centered) | shift the array center to `(0, 0, ..., 0)`    |


### Basic morphological operations

| name                                                   | summary | examples |
| :----------------------------------------------------- | :------ | ---- |
| [`extreme_filter`](@ref) and [`extreme_filter!`](@ref) | iteratively apply a select function `f(x, y)` to each neighborhood | [`extreme_filter` operation](@ref op_extreme_filter) |
| [`dilate`](@ref) and [`dilate!`](@ref)                 | morphological max filter  | [`dilate` operation](@ref op_dilate)   |
| [`erode`](@ref) and [`erode!`](@ref)                   | morphological min filter  | [`erode` operation](@ref op_erode)     |
| [`opening`](@ref) and [`opening!`](@ref)               | fills white holes         | [`opening` operation](@ref op_opening) |
| [`closing`](@ref) and [`closing!`](@ref)               | fills black holes         | [`closing` operation](@ref op_closing) |
| [`bothat`](@ref) and [`bothat!`](@ref)                 | extract black details     | [`bothat` operation](@ref op_bothat)   |
| [`tophat`](@ref) and [`tophat!`](@ref)                 | extract white details     | [`tophat` operation](@ref op_tophat)   |
| [`mgradient`](@ref) and [`mgradient!`](@ref)           | morphological gradient    | [`mgradient` operation](@ref op_mgradient)|
| [`mlaplacian`](@ref) and [`mlaplacian!`](@ref)         | morphological Laplacian   | [`mlaplacian` operation](@ref op_mlaplacian) |

### Geodesic operations

| name                       | summary | examples |
| :--------------------------| :------ | ---- |
| [`underbuild`](@ref)       | morphological reconstruction by dilation, see also [`mreconstruct`](@ref) | [`underbuild` operation](@ref op_underbuild) and [`mreconstruct` operation](@ref op_mreconstruct)
| [`underbuild`](@ref)       | morphological reconstruction by erosion, see also [`mreconstruct`](@ref) | [`overbuild` operation](@ref op_overbuild) and [`mreconstruct` operation](@ref op_mreconstruct)
